//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 10:28:10
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LecServerLoader

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.FTP;
			using System;
			using System.Windows.Forms;
			
		#endregion
		
	public class LoaderFTP
	
	{
		
		#region Fields
			private string Config2FilesPath;
			private string ConfigFilesPath;
			private string FirmwarePath;
			private readonly string FontDefaultPath;
			private string FontPath;
			public const int jaDELETE = 0;
			public const int jaDELETEDIR = 2;
			public const int jaRENAME = 1;
			private readonly string JobDefaultExternalPath;
			private readonly string JobDefaultInternalPath;
			private string JobRemoteExternalPath;
			private string JobRemoteInternalPath;
			private FtpConnection moveFileConnection;
			private Form1 oForm1;
			private string Server2CodePath;
			private string ServerCodePath;
			private string strPassword;
			private string strUsername;
		#endregion
		
		#region Nested Types
		
			public enum RemoteLocation
			
			{
				Drive = 0, 
				JobFlash = 1, 
				JobUSB = 2, 
				Fonts = 3, 
				Config = 4, 
				Server = 5, 
				Firmware = 6, 
				Server2 = 7, 
				Config2 = 8, 
			}
			
		#endregion
		
		#region Constructors
		
			public LoaderFTP (Form1 f)
			
			{
				this.strUsername = "anonymous";
				this.strPassword = "anonymous";
				this.JobDefaultInternalPath = "\\LEC\\Jobs";
				this.JobDefaultExternalPath = "\\USBFlash\\LEC\\Jobs";
				this.FontDefaultPath = "\\LEC\\Fonts";
				this.oForm1 = f;
				this.FirmwarePath = "\\Disk";
				this.ServerCodePath = "\\Disk\\LEC";
				this.Server2CodePath = "\\Disk\\LEC2";
				this.ConfigFilesPath = "\\Disk\\LEC\\Config";
				this.Config2FilesPath = "\\Disk\\LEC2\\Config";
				this.FontPath = ("\\Disk" + this.FontDefaultPath);
				this.JobRemoteInternalPath = ("\\Disk" + this.JobDefaultInternalPath);
				this.JobRemoteExternalPath = ("\\Disk" + this.JobDefaultExternalPath);
			}
			
		#endregion
		
		#region Methods
		
			public void AbortMoveFile ()
			
			{
				if (this.moveFileConnection != null)
				{
					this.moveFileConnection.Abort ();
				}
			}
			
			public void Authenticate (string pstrUsername, string pstrPassword)
			
			{
				this.strUsername = pstrUsername;
				this.strPassword = pstrPassword;
			}
			
			private string GetRemoteLocation (int targetLocation)
			
			{
				switch (targetLocation)
				{
					case 1:
					
					{
							return this.JobRemoteInternalPath.Replace ("\\", "/");
					}
					case 2:
					
					{
							return this.JobRemoteExternalPath.Replace ("\\", "/");
					}
					case 3:
					
					{
							return this.FontPath.Replace ("\\", "/");
					}
					case 4:
					
					{
							return this.ConfigFilesPath.Replace ("\\", "/");
					}
					case 5:
					
					{
							return this.ServerCodePath.Replace ("\\", "/");
					}
					case 6:
					
					{
							return this.FirmwarePath.Replace ("\\", "/");
					}
					case 7:
					
					{
							return this.Server2CodePath.Replace ("\\", "/");
					}
					case 8:
					
					{
							return this.Config2FilesPath.Replace ("\\", "/");
					}
				}
				this.oForm1.DisplayMsg ("ERROR: FTP invalid target location.");
				return "";
			}
			
			public uint ManageFiles (int targetLocation, string pstrCurrentStorageName, string pstrNewStorageName, uint puiActionType)
			
			{
				FtpConnection ftpConnection1;
				string string1;
				string string2;
				FileItem[] fileItemArray1;
				Exception exception1;
				try
				{
					ftpConnection1 = new FtpConnection ();
					ftpConnection1.LocalIPAddress = this.oForm1.LocalIPAddress;
					ftpConnection1.Hostname = this.oForm1.TargetIPAddress;
					ftpConnection1.Username = this.strUsername;
					ftpConnection1.Password = this.strPassword;
					ftpConnection1.Passive = true;
					ftpConnection1.Connect ();
					if (! ftpConnection1.IsConnected)
					{
						this.oForm1.DisplayMsg ("ERROR: FTP connection failed.");
						return 10;
					}
					else
					{
						string1 = this.GetRemoteLocation (targetLocation);
						if (string1.Length == 0)
						{
							return 12;
						}
						else
						{
							if (string1.CompareTo (ftpConnection1.WorkDir) != 0)
							{
								ftpConnection1.ChangeWorkDir (string1);
								if (string1.CompareTo (ftpConnection1.WorkDir) != 0)
								{
									ftpConnection1.Disconnect ();
									this.oForm1.DisplayMsg (("WARNING: FTP target path not found. " + string1));
									return 12;
								}
							}
							if (puiActionType == uint.MinValue)
							{
								ftpConnection1.Delete (pstrCurrentStorageName);
								ECUtils.LogWrite (("Deleting file: " + ftpConnection1.WorkDir + "/" + pstrCurrentStorageName));
							}
							else if (puiActionType == 2)
							{
								string2 = (string1 + "/" + pstrCurrentStorageName);
								ftpConnection1.ChangeWorkDir (string2);
								if (string2.CompareTo (ftpConnection1.WorkDir) != 0)
								{
									ftpConnection1.Disconnect ();
									this.oForm1.DisplayMsg (("WARNING: FTP target path not found. " + string2));
									return 12;
								}
								else
								{
									if (ftpConnection1.GetList ())
									{
										fileItemArray1 = ftpConnection1.GetDirectoryListing ();
										if ((fileItemArray1 != null) && (fileItemArray1.Length > 0))
										{
											foreach (FileItem fileItem1 in fileItemArray1)
											{
												if (! fileItem1.IsDirectory)
												{
													ftpConnection1.Delete (fileItem1.FileTitle);
													ECUtils.LogWrite (("Deleting file: " + ftpConnection1.WorkDir + "/" + fileItem1.FileTitle));
													this.oForm1.progressBar1.PerformStep ();
													this.oForm1.Refresh ();
												}
											}
										}
									}
									ftpConnection1.ChangeWorkDir (string1);
									if (string1.CompareTo (ftpConnection1.WorkDir) != 0)
									{
										ftpConnection1.Disconnect ();
										this.oForm1.DisplayMsg (("WARNING: FTP target path not found. " + string1));
										return 12;
									}
									else
									{
										ftpConnection1.DeleteDirectory (pstrCurrentStorageName);
									}
								}
							}
							else
							{
								ECUtils.LogWrite (("Renaming file: " + ftpConnection1.WorkDir + "/" + pstrCurrentStorageName));
								ftpConnection1.Rename (pstrCurrentStorageName, pstrNewStorageName);
							}
							ftpConnection1.Disconnect ();
							return uint.MinValue;
						}
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					ECUtils.LogWrite (("Loader.ManageFiles() - Exception 0x03d  " + exception1.Message));
					ECUtils.LogWrite (exception1.ToString ());
				}
				return 23;
			}
			
			public uint MoveDir (string pstrLocalPath, int targetLocation, bool pbDownload, bool pbOverwrite)
			
			{
				string string2;
				FileItem[] fileItemArray1;
				char[] charArray1;
				bool b1 = false;
				string string1 = this.GetRemoteLocation (targetLocation);
				if (string1.Length == 0)
				{
					return 12;
				}
				FtpConnection ftpConnection1 = new FtpConnection ();
				ftpConnection1.LocalIPAddress = this.oForm1.LocalIPAddress;
				ftpConnection1.Hostname = this.oForm1.TargetIPAddress;
				ftpConnection1.Username = this.strUsername;
				ftpConnection1.Password = this.strPassword;
				ftpConnection1.Passive = true;
				ftpConnection1.Connect ();
				if (! ftpConnection1.IsConnected)
				{
					this.oForm1.DisplayMsg ("ERROR: FTP commection failed.");
					return 10;
				}
				else
				{
					this.moveFileConnection = ftpConnection1;
					if (string1.CompareTo (ftpConnection1.WorkDir) != 0)
					{
						ftpConnection1.ChangeWorkDir (string1);
						if (string1.CompareTo (ftpConnection1.WorkDir) != 0)
						{
							if (pbDownload)
							{
								ftpConnection1.Disconnect ();
								this.moveFileConnection = ((FtpConnection) null);
								this.oForm1.DisplayMsg ("WARNING: FTP target move dir not found.");
								return 12;
							}
							else
							{
								string2 = "";
								ftpConnection1.ChangeWorkDir ("/");
								charArray1 = new char[] { '\u002F' };
								foreach (string string3 in string1.Split (charArray1))
								{
									if (string3.CompareTo ("") != 0)
									{
										ftpConnection1.MakeDir (string3);
										ftpConnection1.ChangeWorkDir (string3);
										string2 = (string2 + "/" + string3);
										if (string2.CompareTo (ftpConnection1.WorkDir) != 0)
										{
											ftpConnection1.Disconnect ();
											this.moveFileConnection = ((FtpConnection) null);
											this.oForm1.DisplayMsg ("WARNING: FTP target move dir not found.");
											return 12;
										}
									}
								}
								if (string1.CompareTo (ftpConnection1.WorkDir) != 0)
								{
									ftpConnection1.Disconnect ();
									this.moveFileConnection = ((FtpConnection) null);
									this.oForm1.DisplayMsg ("WARNING: FTP target move dir not found.");
									return 12;
								}
							}
						}
					}
					if (ftpConnection1.GetList ())
					{
						fileItemArray1 = ftpConnection1.GetDirectoryListing ();
						if ((fileItemArray1 != null) && (fileItemArray1.Length > 0))
						{
							foreach (FileItem fileItem1 in fileItemArray1)
							{
								if (! fileItem1.IsDirectory)
								{
									if ((! pbDownload) && (! pbOverwrite))
									{
										ftpConnection1.Disconnect ();
										this.moveFileConnection = ((FtpConnection) null);
										this.oForm1.DisplayMsg ("ERROR: FTP Overwrite for existing target files not selected.");
										return 26;
									}
									else if (! pbDownload)
									{
										b1 = ftpConnection1.UploadFile (pstrLocalPath, fileItem1.FileTitle);
										if (b1)
										{
											ECUtils.LogWrite (("SUCCESS UpLoading file: " + ftpConnection1.WorkDir + "/" + fileItem1.FileTitle));
										}
									}
									else
									{
										if (fileItem1.FileTitle.CompareTo ("LocalMgrX.exe") == 0)
										{
											b1 = ftpConnection1.DownloadFile (fileItem1.FileTitle, (pstrLocalPath + "\\LocalMgr.exe"));
										}
										else
										{
											b1 = ftpConnection1.DownloadFile (fileItem1.FileTitle, (pstrLocalPath + "\\" + fileItem1.FileTitle));
										}
										if (b1)
										{
											ECUtils.LogWrite (("SUCCESS Downloading file: " + ftpConnection1.WorkDir + "/" + fileItem1.FileTitle));
										}
										this.oForm1.progressBar1.PerformStep ();
										this.oForm1.Refresh ();
									}
								}
							}
						}
						else if (pbDownload)
						{
							ftpConnection1.Disconnect ();
							this.moveFileConnection = ((FtpConnection) null);
							this.oForm1.DisplayMsg ("ERROR: FTP files to download do not exist in target.");
							return 11;
						}
					}
					else if (pbDownload)
					{
						ftpConnection1.Disconnect ();
						this.moveFileConnection = ((FtpConnection) null);
						this.oForm1.DisplayMsg ("ERROR: FTP files to download do not exist in target.");
						return 11;
					}
					ftpConnection1.Disconnect ();
					this.moveFileConnection = ((FtpConnection) null);
					if (b1)
					{
						return uint.MinValue;
					}
					else
					{
						return 13;
					}
				}
			}
			
			public uint MoveFile (string pstrLocal, string pstrRemote, int targetLocation, bool pbDownload, bool pbOverwrite)
			
			{
				string string2;
				FileItem[] fileItemArray1;
				bool b2;
				FileItem fileItem1;
				char[] charArray1;
				FileItem[] fileItemArray2;
				int i2;
				bool b1 = false;
				string string1 = this.GetRemoteLocation (targetLocation);
				if (string1.Length == 0)
				{
					return 12;
				}
				FtpConnection ftpConnection1 = new FtpConnection ();
				ftpConnection1.LocalIPAddress = this.oForm1.LocalIPAddress;
				ftpConnection1.Hostname = this.oForm1.TargetIPAddress;
				ftpConnection1.Username = this.strUsername;
				ftpConnection1.Password = this.strPassword;
				ftpConnection1.Passive = true;
				ftpConnection1.Connect ();
				if (! ftpConnection1.IsConnected)
				{
					this.oForm1.DisplayMsg ("ERROR: FTP connection failed.");
					return 10;
				}
				else
				{
					this.moveFileConnection = ftpConnection1;
					if (string1.CompareTo (ftpConnection1.WorkDir) != 0)
					{
						ftpConnection1.ChangeWorkDir (string1);
						if (string1.CompareTo (ftpConnection1.WorkDir) != 0)
						{
							if (pbDownload)
							{
								ftpConnection1.Disconnect ();
								this.moveFileConnection = ((FtpConnection) null);
								this.oForm1.DisplayMsg (("WARNING: FTP target move file path not found. " + string1));
								return 12;
							}
							else
							{
								string2 = "";
								ftpConnection1.ChangeWorkDir ("/");
								charArray1 = new char[] { '\u002F' };
								foreach (string string3 in string1.Split (charArray1))
								{
									if (string3.CompareTo ("") != 0)
									{
										ftpConnection1.MakeDir (string3);
										ftpConnection1.ChangeWorkDir (string3);
										string2 = (string2 + "/" + string3);
										if (string2.CompareTo (ftpConnection1.WorkDir) != 0)
										{
											ftpConnection1.Disconnect ();
											this.moveFileConnection = ((FtpConnection) null);
											this.oForm1.DisplayMsg (("WARNING: FTP target move file path not found. " + string1));
											return 12;
										}
									}
								}
								if (string1.CompareTo (ftpConnection1.WorkDir) != 0)
								{
									ftpConnection1.Disconnect ();
									this.moveFileConnection = ((FtpConnection) null);
									this.oForm1.DisplayMsg (("WARNING: FTP target move file path not found." + string1));
									return 12;
								}
							}
						}
					}
					if (ftpConnection1.GetList ())
					{
						fileItemArray1 = ftpConnection1.GetDirectoryListing ();
						if ((fileItemArray1 != null) && (fileItemArray1.Length > 0))
						{
							b2 = false;
							fileItemArray2 = fileItemArray1;
							i2 = 0;
							while (i2 < fileItemArray2.Length)
							{
								fileItem1 = fileItemArray2[i2];
								if (fileItem1.IsDirectory || (fileItem1.FileTitle.CompareTo (pstrRemote) != 0))
								{
									i2++;
									continue;
								}
								b2 = true;
								break;
							}
							if (b2)
							{
								if ((! pbDownload) && (! pbOverwrite))
								{
									ftpConnection1.Disconnect ();
									this.moveFileConnection = ((FtpConnection) null);
									this.oForm1.DisplayMsg ("ERROR: FTP target move file exist but overwrite not selected.");
									return 26;
								}
							}
							else if (pbDownload)
							{
								ftpConnection1.Disconnect ();
								this.moveFileConnection = ((FtpConnection) null);
								this.oForm1.DisplayMsg (("WARNING: FTP target move file not found." + string1));
								return 11;
							}
						}
						else if (pbDownload)
						{
							ftpConnection1.Disconnect ();
							this.moveFileConnection = ((FtpConnection) null);
							this.oForm1.DisplayMsg ("WARNING: FTP target download move file not found.");
							return 11;
						}
					}
					else if (pbDownload)
					{
						ftpConnection1.Disconnect ();
						this.moveFileConnection = ((FtpConnection) null);
						this.oForm1.DisplayMsg ("WARNING: FTP target download move file not found.");
						return 11;
					}
					if (pbDownload)
					{
						ECUtils.LogWrite (("Downloading file: " + ftpConnection1.WorkDir + "/" + pstrRemote));
						b1 = ftpConnection1.DownloadFile (pstrRemote, pstrLocal);
					}
					else
					{
						ECUtils.LogWrite (("UpLoading file: " + ftpConnection1.WorkDir + "/" + pstrRemote));
						b1 = ftpConnection1.UploadFile (pstrLocal, pstrRemote);
					}
					if (b1)
					{
						ECUtils.LogWrite (" SUCCESS");
					}
					else
					{
						ECUtils.LogWrite (" FAILED");
					}
					ftpConnection1.Disconnect ();
					this.moveFileConnection = ((FtpConnection) null);
					if (b1)
					{
						return uint.MinValue;
					}
					else
					{
						return 13;
					}
				}
			}
			
		#endregion
	}
	
}

