//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:19:11
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.CommonLib.Protocol

{
		
		#region Namespace Import Declarations
		
			using System.Collections;
			using System.IO;
			using System.Net;
			using System;
			using System.Xml;
			
		#endregion
		
	public class BroadcastConfigReader : BaseConfig, IBaseXmlReader
	
	{
		
		#region Fields
			private IPAddress m_ipAddress;
			private int m_iPort;
			private ArrayList m_lstTransmitData;
			private string m_strDefaultFileName;
			private static readonly string m_strDisplayName;
			private string m_strType;
			private string m_strVersion;
			public const uint Opcode = 8;
		#endregion
		
		#region Constructors
		
			public BroadcastConfigReader ()
			
			{
				this.m_strDefaultFileName = "";
				this.m_strType = "BroadcastConfigData";
				this.m_strVersion = "1.0";
				this.m_ipAddress = IPAddress.Parse ("224.168.100.2");
				this.m_iPort = 11000;
				this.m_lstTransmitData = new ArrayList ();
			}
			
			
			static BroadcastConfigReader ()
			
			{
				BroadcastConfigReader.m_strDisplayName = "Broadcast Information";
			}
			
		#endregion
		
		#region Properties
		
			public IPAddress Address
			
			{
				get
				{
					return this.m_ipAddress;
				}
				set
				{
					this.m_ipAddress = value;
				}
			}
			
			
			public override string DefaultFileName
			
			{
				get
				{
					return this.m_strDefaultFileName;
				}
			}
			
			
			public static string DisplayName
			
			{
				get
				{
					return BroadcastConfigReader.m_strDisplayName;
				}
			}
			
			
			public int Port
			
			{
				get
				{
					return this.m_iPort;
				}
				set
				{
					this.m_iPort = value;
				}
			}
			
			
			public ArrayList TransmitData
			
			{
				get
				{
					return this.m_lstTransmitData;
				}
				set
				{
					this.m_lstTransmitData = value;
				}
			}
			
			
			public override string Type
			
			{
				get
				{
					return this.m_strType;
				}
			}
			
			
			public override string Version
			
			{
				get
				{
					return this.m_strVersion;
				}
			}
			
		#endregion
		
		#region Methods
		
			public virtual void FromXML (StreamReader poData)
			
			{
				XmlTextReader xmlTextReader1 = new XmlTextReader (((TextReader) poData));
				this.FromXML (xmlTextReader1);
				xmlTextReader1.Close ();
			}
			
			public void FromXML (XmlTextReader pxmlRead)
			
			{
				string string1;
				string string2;
				string string3;
				bool b1 = false;
				while (true)
				{
					while ((pxmlRead.NodeType == XmlNodeType.Element) && b1)
					{
						if ((string3 = pxmlRead.Name) != null)
						{
							string3 = string.IsInterned (string3);
							switch (string3)
							{
								case "Address":
								
								{
										bool b2 = pxmlRead.Read ();
										if (pxmlRead.NodeType == XmlNodeType.Text)
										{
											this.Address = IPAddress.Parse (pxmlRead.Value);
										}
										continue;
								}
								case "Port":
								
								{
										bool b3 = pxmlRead.Read ();
										if (pxmlRead.NodeType == XmlNodeType.Text)
										{
											this.Port = Convert.ToInt32 (pxmlRead.Value);
										}
										continue;
								}
								case "Retransmit":
								
								{
										string1 = pxmlRead.GetAttribute ("type");
										string2 = pxmlRead.GetAttribute ("time");
										this.InsertSort (new TransmitInfo (string1, Convert.ToInt32 (string2)));
										bool b4 = pxmlRead.Read ();
										continue;
								}
							}
						}
						bool b5 = pxmlRead.Read ();
					}
					if ((pxmlRead.NodeType == XmlNodeType.Element) && (pxmlRead.Name.CompareTo ("BroadcastChannel") == 0))
					{
						b1 = true;
						if (! pxmlRead.Read ())
						{
							return;
						}
						continue;
					}
					else if (((pxmlRead.NodeType == XmlNodeType.EndElement) && (pxmlRead.Name.CompareTo ("BroadcastChannel") == 0)) || (! pxmlRead.Read ()))
					{
						return;
					}
				}
			}
			
			public virtual void FromXML (string pstrData)
			
			{
				if (pstrData.Length == 0)
				{
					return;
				}
				StringReader stringReader1 = new StringReader (pstrData);
				XmlTextReader xmlTextReader1 = new XmlTextReader (((TextReader) stringReader1));
				this.FromXML (xmlTextReader1);
				xmlTextReader1.Close ();
				stringReader1.Close ();
			}
			
			private void InsertSort (TransmitInfo poTransmit)
			
			{
				int i1 = 0;
				while (i1 < this.TransmitData.Count)
				{
					if (((TransmitInfo) this.TransmitData[i1]).Time <= poTransmit.Time)
					{
						i1++;
						continue;
					}
					else
					{
						this.TransmitData.Insert (i1, poTransmit);
						return;
					}
				}
				int i2 = this.TransmitData.Add (poTransmit);
			}
			
		#endregion
	}
	
}

