//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:19:11
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.CommonLib.Protocol

{
		
		#region Namespace Import Declarations
		
			using System;
			using System.IO;
			using System.Xml;
			
		#endregion
		
	public class DataConfigReader : BaseConfig, IBaseXmlReader
	
	{
		
		#region Fields
			private bool m_bEnableStreamToFile;
			private int m_iPort;
			private string m_strControlFile;
			private string m_strDefaultFileName;
			private static readonly string m_strDisplayName;
			private string m_strLogFile;
			private string m_strStreamFile;
			private string m_strType;
			private string m_strVersion;
			public const uint Opcode = 9;
		#endregion
		
		#region Constructors
		
			public DataConfigReader ()
			
			{
				this.m_strDefaultFileName = "";
				this.m_strType = "DataConfigData";
				this.m_strVersion = "1.0";
				this.m_iPort = 12200;
				this.m_strLogFile = "DataThread.txt";
				this.m_strStreamFile = "StreamData.txt";
				this.m_bEnableStreamToFile = false;
				this.m_strControlFile = "";
			}
			
			
			static DataConfigReader ()
			
			{
				DataConfigReader.m_strDisplayName = "Data Information";
			}
			
		#endregion
		
		#region Properties
		
			public string ControlFile
			
			{
				get
				{
					if (this.m_strControlFile.Length != 0)
					{
						return this.m_strControlFile;
					}
					ControlConfigReader controlConfigReader1 = new ControlConfigReader ();
					return controlConfigReader1.DefaultFileName;
				}
				set
				{
					this.m_strControlFile = value;
				}
			}
			
			
			public override string DefaultFileName
			
			{
				get
				{
					return this.m_strDefaultFileName;
				}
			}
			
			
			public static string DisplayName
			
			{
				get
				{
					return DataConfigReader.m_strDisplayName;
				}
			}
			
			
			public bool EnableStreamToFile
			
			{
				get
				{
					return this.m_bEnableStreamToFile;
				}
				set
				{
					this.m_bEnableStreamToFile = value;
				}
			}
			
			
			public string LogFile
			
			{
				get
				{
					return this.m_strLogFile;
				}
				set
				{
					this.m_strLogFile = value;
				}
			}
			
			
			public int Port
			
			{
				get
				{
					return this.m_iPort;
				}
				set
				{
					this.m_iPort = value;
				}
			}
			
			
			public string StreamFile
			
			{
				get
				{
					return this.m_strStreamFile;
				}
				set
				{
					this.m_strStreamFile = value;
				}
			}
			
			
			public override string Type
			
			{
				get
				{
					return this.m_strType;
				}
			}
			
			
			public override string Version
			
			{
				get
				{
					return this.m_strVersion;
				}
			}
			
		#endregion
		
		#region Methods
		
			public virtual void FromXML (StreamReader poData)
			
			{
				XmlTextReader xmlTextReader1 = new XmlTextReader (((TextReader) poData));
				this.FromXML (xmlTextReader1);
				xmlTextReader1.Close ();
			}
			
			public virtual void FromXML (string pstrData)
			
			{
				if (pstrData.Length == 0)
				{
					return;
				}
				StringReader stringReader1 = new StringReader (pstrData);
				XmlTextReader xmlTextReader1 = new XmlTextReader (((TextReader) stringReader1));
				this.FromXML (xmlTextReader1);
				xmlTextReader1.Close ();
				stringReader1.Close ();
			}
			
			public void FromXML (XmlTextReader pxmlRead)
			
			{
				string string1;
				bool b1 = false;
				while (true)
				{
					while ((pxmlRead.NodeType == XmlNodeType.Element) && b1)
					{
						if ((string1 = pxmlRead.Name) != null)
						{
							string1 = string.IsInterned (string1);
							switch (string1)
							{
								case "Port":
								
								{
										bool b2 = pxmlRead.Read ();
										if (pxmlRead.NodeType == XmlNodeType.Text)
										{
											this.Port = Convert.ToInt32 (pxmlRead.Value);
										}
										continue;
								}
								case "LogFile":
								
								{
										bool b3 = pxmlRead.Read ();
										if (pxmlRead.NodeType != XmlNodeType.Text)
										{
											this.LogFile = "";
											continue;
										}
										this.LogFile = pxmlRead.Value;
										continue;
								}
								case "StreamFile":
								
								{
										bool b4 = pxmlRead.Read ();
										if (pxmlRead.NodeType == XmlNodeType.Text)
										{
											this.StreamFile = pxmlRead.Value;
										}
										continue;
								}
								case "EnableStreamToFile":
								
								{
										bool b5 = pxmlRead.Read ();
										if (pxmlRead.NodeType == XmlNodeType.Text)
										{
											this.EnableStreamToFile = Convert.ToBoolean (pxmlRead.Value);
										}
										continue;
								}
								case "ControlFile":
								
								{
										bool b6 = pxmlRead.Read ();
										if (pxmlRead.NodeType == XmlNodeType.Text)
										{
											this.ControlFile = pxmlRead.Value;
										}
										continue;
								}
							}
						}
						bool b7 = pxmlRead.Read ();
					}
					if ((pxmlRead.NodeType == XmlNodeType.Element) && (pxmlRead.Name.CompareTo ("DataChannel") == 0))
					{
						b1 = true;
						if (! pxmlRead.Read ())
						{
							return;
						}
						continue;
					}
					else if (((pxmlRead.NodeType == XmlNodeType.EndElement) && (pxmlRead.Name.CompareTo ("DataChannel") == 0)) || (! pxmlRead.Read ()))
					{
						return;
					}
				}
			}
			
		#endregion
	}
	
}

