//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:19:11
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.CommonLib.Protocol

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.Extension;
			using System.Net;
			using System;
			using System.Text;
			
		#endregion
		
	public class ServerAdPacket
	
	{
		
		#region Fields
			public byte[] Data;
			public static int iIPLength;
			private IPAddress m_ipAddress;
			private IPAddress m_ipRequestAddress;
			private uint m_uiDataSize;
			private uint m_uiOpcode;
			private uint m_uiProtocolVersion;
			private UInt16 m_usPacketCount;
			private UInt16 m_usPacketNumber;
			public readonly byte[] Protocol;
		#endregion
		
		#region Constructors
		
			public ServerAdPacket ()
			
			{
				this.Protocol = new ASCIIEncoding ().GetBytes ("LECs");
				this.m_uiProtocolVersion = 1;
				this.m_usPacketCount = 1;
				this.m_usPacketNumber = ushort.MinValue;
				this.m_uiOpcode = uint.MinValue;
				this.m_uiDataSize = uint.MinValue;
				this.m_ipAddress = ((IPAddress) null);
				this.m_ipRequestAddress = ((IPAddress) null);
			}
			
			
			public ServerAdPacket (byte[] pbPacketStream)
			
			{
				this.Protocol = new ASCIIEncoding ().GetBytes ("LECs");
				int i1 = 0;
				if (! ArrayEx.CompareTo (pbPacketStream, this.Protocol, this.Protocol.Length))
				{
					return;
				}
				i1 += this.Protocol.Length;
				this.m_uiProtocolVersion = BitConverter.ToUInt32 (pbPacketStream, i1);
				i1 += 4;
				object[] objectArray1 = new object[] { Convert.ToInt32 (pbPacketStream[i1]), Convert.ToInt32 (pbPacketStream[(i1 + 1)]), Convert.ToInt32 (pbPacketStream[(i1 + 2)]), Convert.ToInt32 (pbPacketStream[(i1 + 3)]) };
				string string1 = string.Format ("{0}.{1}.{2}.{3}", objectArray1);
				this.m_ipAddress = IPAddress.Parse (string1);
				i1 += ServerAdPacket.iIPLength;
				objectArray1 = new object[] { Convert.ToInt32 (pbPacketStream[i1]), Convert.ToInt32 (pbPacketStream[(i1 + 1)]), Convert.ToInt32 (pbPacketStream[(i1 + 2)]), Convert.ToInt32 (pbPacketStream[(i1 + 3)]) };
				string1 = string.Format ("{0}.{1}.{2}.{3}", objectArray1);
				this.m_ipRequestAddress = IPAddress.Parse (string1);
				i1 += ServerAdPacket.iIPLength;
				this.m_usPacketCount = BitConverter.ToUInt16 (pbPacketStream, i1);
				i1 += 2;
				this.m_usPacketNumber = BitConverter.ToUInt16 (pbPacketStream, i1);
				i1 += 2;
				this.m_uiOpcode = ((uint) BitConverter.ToInt32 (pbPacketStream, i1));
				i1 += 4;
				this.m_uiDataSize = ((uint) BitConverter.ToInt32 (pbPacketStream, i1));
				i1 += 4;
				if (this.m_uiDataSize > uint.MinValue)
				{
					this.Data = new byte[this.m_uiDataSize];
					Array.Copy (((Array) pbPacketStream), i1, ((Array) this.Data), 0, ((int) this.m_uiDataSize));
					i1 += ((int) this.m_uiDataSize);
				}
			}
			
			
			static ServerAdPacket ()
			
			{
				ServerAdPacket.iIPLength = 8;
			}
			
		#endregion
		
		#region Properties
		
			public IPAddress Address
			
			{
				get
				{
					return this.m_ipAddress;
				}
				set
				{
					this.m_ipAddress = value;
				}
			}
			
			
			public uint DataSize
			
			{
				get
				{
					return this.m_uiDataSize;
				}
				set
				{
					this.m_uiDataSize = value;
				}
			}
			
			
			public uint Opcode
			
			{
				get
				{
					return this.m_uiOpcode;
				}
				set
				{
					this.m_uiOpcode = value;
				}
			}
			
			
			public UInt16 PacketCount
			
			{
				get
				{
					return this.m_usPacketCount;
				}
				set
				{
					this.m_usPacketCount = value;
				}
			}
			
			
			public UInt16 PacketNumber
			
			{
				get
				{
					return this.m_usPacketNumber;
				}
				set
				{
					this.m_usPacketNumber = value;
				}
			}
			
			
			public uint ProtocolVersion
			
			{
				get
				{
					return this.m_uiProtocolVersion;
				}
				set
				{
					this.m_uiProtocolVersion = value;
				}
			}
			
			
			public IPAddress RequestAddress
			
			{
				get
				{
					return this.m_ipRequestAddress;
				}
				set
				{
					this.m_ipRequestAddress = value;
				}
			}
			
		#endregion
		
		#region Methods
		
			public byte[] ToBytes ()
			
			{
				byte[] byteArray1 = BitConverter.GetBytes (this.m_uiProtocolVersion);
				byte[] byteArray2 = new byte[ServerAdPacket.iIPLength];
				if (this.m_ipAddress != null)
				{
					byteArray2 = BitConverter.GetBytes (this.m_ipAddress.Address);
				}
				byte[] byteArray3 = new byte[ServerAdPacket.iIPLength];
				if (this.m_ipRequestAddress != null)
				{
					byteArray3 = BitConverter.GetBytes (this.m_ipRequestAddress.Address);
				}
				byte[] byteArray4 = BitConverter.GetBytes (this.m_usPacketCount);
				byte[] byteArray5 = BitConverter.GetBytes (this.m_usPacketNumber);
				byte[] byteArray6 = BitConverter.GetBytes (this.m_uiOpcode);
				byte[] byteArray7 = BitConverter.GetBytes (this.m_uiDataSize);
				byte[] byteArray8 = new byte[((((((((((this.Protocol.Length + byteArray1.Length) + byteArray2.Length) + ((byteArray2.Length < ServerAdPacket.iIPLength) ? (ServerAdPacket.iIPLength - byteArray2.Length) : 0)) + byteArray3.Length) + ((byteArray3.Length < ServerAdPacket.iIPLength) ? (ServerAdPacket.iIPLength - byteArray3.Length) : 0)) + byteArray4.Length) + byteArray5.Length) + byteArray6.Length) + byteArray7.Length) + ((this.Data != null) ? this.Data.Length : 0))];
				int i1 = 0;
				Array.Copy (((Array) this.Protocol), 0, ((Array) byteArray8), i1, this.Protocol.Length);
				i1 += this.Protocol.Length;
				Array.Copy (((Array) byteArray1), 0, ((Array) byteArray8), i1, byteArray1.Length);
				i1 += byteArray1.Length;
				Array.Copy (((Array) byteArray2), 0, ((Array) byteArray8), i1, byteArray2.Length);
				i1 += byteArray2.Length;
				if (byteArray2.Length < ServerAdPacket.iIPLength)
				{
					i1 += (ServerAdPacket.iIPLength - byteArray2.Length);
				}
				Array.Copy (((Array) byteArray3), 0, ((Array) byteArray8), i1, byteArray3.Length);
				i1 += byteArray3.Length;
				if (byteArray3.Length < ServerAdPacket.iIPLength)
				{
					i1 += (ServerAdPacket.iIPLength - byteArray3.Length);
				}
				Array.Copy (((Array) byteArray4), 0, ((Array) byteArray8), i1, byteArray4.Length);
				i1 += byteArray4.Length;
				Array.Copy (((Array) byteArray5), 0, ((Array) byteArray8), i1, byteArray5.Length);
				i1 += byteArray5.Length;
				Array.Copy (((Array) byteArray6), 0, ((Array) byteArray8), i1, byteArray6.Length);
				i1 += byteArray6.Length;
				Array.Copy (((Array) byteArray7), 0, ((Array) byteArray8), i1, byteArray7.Length);
				i1 += byteArray7.Length;
				if (this.m_uiDataSize > uint.MinValue)
				{
					Array.Copy (((Array) this.Data), 0, ((Array) byteArray8), i1, this.Data.Length);
					i1 += this.Data.Length;
				}
				return byteArray8;
			}
			
		#endregion
	}
	
}

