//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:19:11
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.CommonLib.Protocol

{
		
		#region Namespace Import Declarations
		
			using System.Collections;
			using System.IO;
			using System;
			using System.Xml;
			
		#endregion
		
	public class SettingsConfigReader : BaseConfig, IBaseXmlReader
	
	{
		
		#region Fields
			private string adminPassword;
			private bool breakConnectOK;
			private string hostClient;
			private string hostPendant;
			private bool m_bLocalMode;
			private int m_iLoggingLevel;
			private string m_strDefaultFileName;
			private static readonly string m_strDisplayName;
			private string m_strFriendlyName;
			private string m_strHeadSN;
			private string m_strType;
			private string m_strVersion;
			public const uint Opcode = 12;
			private string userPassword;
		#endregion
		
		#region Constructors
		
			public SettingsConfigReader ()
			
			{
				this.m_strDefaultFileName = "";
				this.m_strType = "SettingsConfigData";
				this.m_strVersion = "1.0";
				this.m_bLocalMode = false;
				this.m_iLoggingLevel = 0;
				this.m_strFriendlyName = "";
				this.hostClient = "";
				this.hostPendant = "";
				this.userPassword = "";
				this.adminPassword = "";
				this.m_strHeadSN = "";
				this.breakConnectOK = false;
			}
			
			
			static SettingsConfigReader ()
			
			{
				SettingsConfigReader.m_strDisplayName = "Settings Information";
			}
			
		#endregion
		
		#region Properties
		
			public string AdminPassword
			
			{
				get
				{
					return this.adminPassword;
				}
				set
				{
					this.adminPassword = value;
				}
			}
			
			
			public bool BreakConnectOK
			
			{
				get
				{
					return this.breakConnectOK;
				}
				set
				{
					this.breakConnectOK = value;
				}
			}
			
			
			public override string DefaultFileName
			
			{
				get
				{
					return this.m_strDefaultFileName;
				}
			}
			
			
			public static string DisplayName
			
			{
				get
				{
					return SettingsConfigReader.m_strDisplayName;
				}
			}
			
			
			public string FriendlyName
			
			{
				get
				{
					return this.m_strFriendlyName;
				}
				set
				{
					this.m_strFriendlyName = value;
				}
			}
			
			
			public string HeadSN
			
			{
				get
				{
					return this.m_strHeadSN;
				}
				set
				{
					this.m_strHeadSN = value;
				}
			}
			
			
			public string HostClient
			
			{
				get
				{
					return this.hostClient;
				}
				set
				{
					this.hostClient = value;
				}
			}
			
			
			public string HostPendant
			
			{
				get
				{
					return this.hostPendant;
				}
				set
				{
					this.hostPendant = value;
				}
			}
			
			
			public bool LocalMode
			
			{
				get
				{
					return this.m_bLocalMode;
				}
				set
				{
					this.m_bLocalMode = value;
				}
			}
			
			
			public int LoggingLevel
			
			{
				get
				{
					return this.m_iLoggingLevel;
				}
				set
				{
					this.m_iLoggingLevel = value;
				}
			}
			
			
			public override string Type
			
			{
				get
				{
					return this.m_strType;
				}
			}
			
			
			public string UserPassword
			
			{
				get
				{
					return this.userPassword;
				}
				set
				{
					this.userPassword = value;
				}
			}
			
			
			public override string Version
			
			{
				get
				{
					return this.m_strVersion;
				}
			}
			
		#endregion
		
		#region Methods
		
			public virtual void FromXML (StreamReader poData)
			
			{
				XmlTextReader xmlTextReader1 = new XmlTextReader (((TextReader) poData));
				this.FromXML (xmlTextReader1);
				xmlTextReader1.Close ();
			}
			
			public virtual void FromXML (string pstrData)
			
			{
				if (pstrData.Length == 0)
				{
					return;
				}
				StringReader stringReader1 = new StringReader (pstrData);
				XmlTextReader xmlTextReader1 = new XmlTextReader (((TextReader) stringReader1));
				this.FromXML (xmlTextReader1);
				xmlTextReader1.Close ();
				stringReader1.Close ();
			}
			
			public void FromXML (XmlTextReader pxmlRead)
			
			{
				object object1;
				Hashtable hashtable1 = ((Hashtable) null);
				if (hashtable1 == null)
				{
					hashtable1 = new Hashtable (20, 0.5F);
					hashtable1.Add ("LocalMode", 0);
					hashtable1.Add ("LoggingLevel", 1);
					hashtable1.Add ("FriendlyName", 2);
					hashtable1.Add ("HeadSerialNumber", 3);
					hashtable1.Add ("Client", 4);
					hashtable1.Add ("Pendant", 5);
					hashtable1.Add ("User", 6);
					hashtable1.Add ("Admin", 7);
					hashtable1.Add ("BreakOK", 8);
				}
				bool b1 = false;
				while (true)
				{
					while ((pxmlRead.NodeType == XmlNodeType.Element) && b1)
					{
						if (((object1 = pxmlRead.Name) != null) && ((object1 = hashtable1[object1]) != null))
						{
							switch ((int) object1)
							{
								case 0:
								
								{
										bool b2 = pxmlRead.Read ();
										if (pxmlRead.NodeType != XmlNodeType.Text)
										{
											continue;
										}
										this.LocalMode = Convert.ToBoolean (pxmlRead.Value);
										continue;
								}
								case 1:
								
								{
										bool b3 = pxmlRead.Read ();
										if (pxmlRead.NodeType != XmlNodeType.Text)
										{
											continue;
										}
										this.LoggingLevel = Convert.ToInt32 (pxmlRead.Value);
										continue;
								}
								case 2:
								
								{
										bool b4 = pxmlRead.Read ();
										if (pxmlRead.NodeType != XmlNodeType.Text)
										{
											continue;
										}
										this.FriendlyName = pxmlRead.Value;
										continue;
								}
								case 3:
								
								{
										bool b5 = pxmlRead.Read ();
										if (pxmlRead.NodeType != XmlNodeType.Text)
										{
											continue;
										}
										this.HeadSN = pxmlRead.Value;
										continue;
								}
								case 4:
								
								{
										bool b6 = pxmlRead.Read ();
										if (pxmlRead.NodeType != XmlNodeType.Text)
										{
											continue;
										}
										this.HostClient = pxmlRead.Value;
										continue;
								}
								case 5:
								
								{
										bool b7 = pxmlRead.Read ();
										if (pxmlRead.NodeType != XmlNodeType.Text)
										{
											continue;
										}
										this.HostPendant = pxmlRead.Value;
										continue;
								}
								case 6:
								
								{
										bool b8 = pxmlRead.Read ();
										if (pxmlRead.NodeType != XmlNodeType.Text)
										{
											continue;
										}
										this.UserPassword = pxmlRead.Value;
										continue;
								}
								case 7:
								
								{
										bool b9 = pxmlRead.Read ();
										if (pxmlRead.NodeType != XmlNodeType.Text)
										{
											continue;
										}
										this.AdminPassword = pxmlRead.Value;
										continue;
								}
								case 8:
								
								{
										bool b10 = pxmlRead.Read ();
										if (pxmlRead.NodeType != XmlNodeType.Text)
										{
											continue;
										}
										this.BreakConnectOK = Convert.ToBoolean (pxmlRead.Value);
										continue;
								}
							}
						}
						bool b11 = pxmlRead.Read ();
					}
					if ((pxmlRead.NodeType == XmlNodeType.Element) && (pxmlRead.Name.CompareTo ("Settings") == 0))
					{
						b1 = true;
						if (! pxmlRead.Read ())
						{
							return;
						}
						continue;
					}
					else if (((pxmlRead.NodeType == XmlNodeType.EndElement) && (pxmlRead.Name.CompareTo ("Settings") == 0)) || (! pxmlRead.Read ()))
					{
						return;
					}
				}
			}
			
		#endregion
	}
	
}

