//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:31:52
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace OpenNETCF.Net

{
		
		#region Namespace Import Declarations
		
			using OpenNETCF.IO;
			using System;
			using System.Text;
			
		#endregion
		
	public class Adapter
	
	{
		
		#region Fields
			internal string currentIp;
			internal string currentsubnet;
			internal string description;
			internal bool dhcpenabled;
			internal string dhcpserver;
			internal string gateway;
			internal bool havewins;
			internal byte[] hwaddress;
			internal int index;
			internal DateTime leaseexpires;
			internal DateTime leaseobtained;
			internal string name;
			internal string primarywinsserver;
			internal string secondarywinsserver;
			internal StrengthAddon StrengthFetcher;
			internal int type;
		#endregion
		
		#region Constructors
		
			internal Adapter (IP_ADAPTER_INFO info)
			
			{
				this.StrengthFetcher = ((StrengthAddon) null);
				this.name = info.AdapterName;
				this.description = info.Description;
				this.index = info.Index;
				this.type = info.Type;
				this.hwaddress = info.PhysAddress;
				this.dhcpenabled = info.DHCPEnabled;
				this.currentIp = info.CurrentIpAddress;
				this.currentsubnet = info.CurrentSubnetMask;
				this.gateway = info.Gateway;
				this.dhcpserver = info.DHCPServer;
				this.havewins = info.HaveWINS;
				this.primarywinsserver = info.PrimaryWINSServer;
				this.secondarywinsserver = info.SecondaryWINSServer;
				this.leaseobtained = info.LeaseObtained;
				this.leaseexpires = info.LeaseExpires;
			}
			
		#endregion
		
		#region Properties
		
			public unsafe string AssociatedAccessPoint
			
			{
				get
				{
					NDISUIO_QUERY_OID nDISUIO_QUERY_OID1;
					byte[] byteArray2;
					int i1;
					if (! this.IsWireless)
					{
						throw new AdapterException ("Wired NICs are not associated with Access Points");
					}
					string string1 = ((string) null);
					if (Environment.OSVersion.Version.Major < 4)
					{
						goto L_00F2;
					}
					uint uInt32_1 = uint.MinValue;
					IntPtr intPtr1 = FileEx.CreateFile ("UIO1:", FileAccess.All, FileShare.None, FileCreateDisposition.OpenExisting, 1073741952);
					if (((int) intPtr1) == -1)
					{
						return null;
					}
					byte[] byteArray1 = Encoding.Unicode.GetBytes ((this.Name + '\0'.ToString ()));
					fixed (byte* referencedByteAddress1 = byteArray1)
					{
						nDISUIO_QUERY_OID1 = new NDISUIO_QUERY_OID (36);
						nDISUIO_QUERY_OID1.ptcDeviceName = referencedByteAddress1;
						nDISUIO_QUERY_OID1.Oid = 218169602;
						if (NDISUIOPInvokes.DeviceIoControl (intPtr1, 1181700, ((byte[]) nDISUIO_QUERY_OID1), nDISUIO_QUERY_OID1.Size, ((byte[]) nDISUIO_QUERY_OID1), nDISUIO_QUERY_OID1.Size, ref uInt32_1, IntPtr.Zero))
						{
							byteArray2 = nDISUIO_QUERY_OID1.Data;
							i1 = BitConverter.ToInt32 (byteArray2, 0);
							if (i1 > 0)
							{
								string1 = Encoding.ASCII.GetString (byteArray2, 4, i1);
							}
						}
						FileEx.CloseHandle (intPtr1);
						
					L_00F2:
						
						{
						}
						if (string1 != null)
						{
							return string1;
						}
						else if (this.StrengthFetcher == null)
						{
							return string1;
						}
						else
						{
							return this.StrengthFetcher.RFSSID (this);
						}
					}
				}
			}
			
			
			public string CurrentIpAddress
			
			{
				get
				{
					return this.currentIp;
				}
			}
			
			
			public string CurrentSubnetMask
			
			{
				get
				{
					return this.currentsubnet;
				}
			}
			
			
			public string Description
			
			{
				get
				{
					return this.description;
				}
			}
			
			
			public bool DhcpEnabled
			
			{
				get
				{
					return this.dhcpenabled;
				}
			}
			
			
			public string DhcpServer
			
			{
				get
				{
					return this.dhcpserver;
				}
			}
			
			
			public string Gateway
			
			{
				get
				{
					return this.gateway;
				}
			}
			
			
			public bool HasWins
			
			{
				get
				{
					return this.havewins;
				}
			}
			
			
			public int Index
			
			{
				get
				{
					return this.index;
				}
			}
			
			
			public bool IsWireless
			
			{
				get
				{
					if (this.Type != AdapterType.Ethernet)
					{
						return false;
					}
					else
					{
						return (this.SignalStrengthInDecibels != 0);
					}
				}
			}
			
			
			public DateTime LeaseExpires
			
			{
				get
				{
					return this.leaseexpires;
				}
			}
			
			
			public DateTime LeaseObtained
			
			{
				get
				{
					return this.leaseobtained;
				}
			}
			
			
			public byte[] MacAddress
			
			{
				get
				{
					return this.hwaddress;
				}
			}
			
			
			public string Name
			
			{
				get
				{
					return this.name;
				}
			}
			
			
			public AccessPointCollection NearbyAccessPoints
			
			{
				get
				{
					return new AccessPointCollection (this);
				}
			}
			
			
			public string PrimaryWinsServer
			
			{
				get
				{
					return this.primarywinsserver;
				}
			}
			
			
			public string SecondaryWinsServer
			
			{
				get
				{
					return this.secondarywinsserver;
				}
			}
			
			
			public SignalStrength SignalStrength
			
			{
				get
				{
					if (this.IsWireless)
					{
						return new OpenNETCF.Net.SignalStrength (this.SignalStrengthInDecibels);
					}
					else
					{
						throw new AdapterException ("Signal strength is not a property of a wired NIC adapter");
					}
				}
			}
			
			
			public unsafe int SignalStrengthInDecibels
			
			{
				get
				{
					NDISUIO_QUERY_OID nDISUIO_QUERY_OID1;
					byte[] byteArray2;
					int i1 = 0;
					if (Environment.OSVersion.Version.Major < 4)
					{
						goto L_00C8;
					}
					uint uInt32_1 = uint.MinValue;
					IntPtr intPtr1 = FileEx.CreateFile ("UIO1:", FileAccess.All, FileShare.None, FileCreateDisposition.OpenExisting, 1073741952);
					if (((int) intPtr1) == -1)
					{
						return 0;
					}
					byte[] byteArray1 = Encoding.Unicode.GetBytes ((this.Name + '\0'.ToString ()));
					fixed (byte* referencedByteAddress1 = byteArray1)
					{
						nDISUIO_QUERY_OID1 = new NDISUIO_QUERY_OID (4);
						nDISUIO_QUERY_OID1.ptcDeviceName = referencedByteAddress1;
						nDISUIO_QUERY_OID1.Oid = 218169862;
						if (NDISUIOPInvokes.DeviceIoControl (intPtr1, 1181700, ((byte[]) nDISUIO_QUERY_OID1), nDISUIO_QUERY_OID1.Size, ((byte[]) nDISUIO_QUERY_OID1), nDISUIO_QUERY_OID1.Size, ref uInt32_1, IntPtr.Zero))
						{
							byteArray2 = nDISUIO_QUERY_OID1.Data;
							i1 = BitConverter.ToInt32 (byteArray2, 0);
						}
						FileEx.CloseHandle (intPtr1);
						
					L_00C8:
						
						{
						}
						if (i1 != 0)
						{
							return i1;
						}
						else if (this.StrengthFetcher == null)
						{
							return i1;
						}
						else
						{
							return this.StrengthFetcher.RFSignalStrengthDB (this);
						}
					}
				}
			}
			
			
			public AdapterType Type
			
			{
				get
				{
					return ((AdapterType) this.type);
				}
			}
			
		#endregion
	}
	
}

