//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:30:26
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace OpenNETCF.Configuration

{
		
		#region Namespace Import Declarations
		
			using System;
			using System.IO;
			using System.Xml;
			
		#endregion
		
	public sealed class ConfigXmlDocument : XmlDocument, IConfigXmlNode
	
	{
		
		#region Fields
			private string _filename;
			private int _lineOffset;
			private XmlTextReader _reader;
		#endregion
		
		#region Constructors
		
			public ConfigXmlDocument ()
			
			{
			}
			
		#endregion
		
		#region Properties
		
			public string Filename
			
			{
				get
				{
					return this._filename;
				}
			}
			
			
			public int LineNumber
			
			{
				get
				{
					if (this._reader == null)
					{
						return 0;
					}
					else if (this._lineOffset <= 0)
					{
						return this._reader.LineNumber;
					}
					else
					{
						return ((this._reader.LineNumber + this._lineOffset) - 1);
					}
				}
			}
			
			
			string OpenNETCF.Configuration.IConfigXmlNode.Filename
			
			{
				get
				{
					return this._filename;
				}
			}
			
		#endregion
		
		#region Methods
		
			public override XmlAttribute CreateAttribute (string prefix, string localName, string namespaceUri)
			
			{
				return new ConfigXmlAttribute (this._filename, this.LineNumber, prefix, localName, namespaceUri, ((XmlDocument) this));
			}
			
			public override XmlCDataSection CreateCDataSection (string data)
			
			{
				return new ConfigXmlCDataSection (this._filename, this.LineNumber, data, ((XmlDocument) this));
			}
			
			public override XmlComment CreateComment (string data)
			
			{
				return new ConfigXmlComment (this._filename, this.LineNumber, data, ((XmlDocument) this));
			}
			
			public override XmlElement CreateElement (string prefix, string localName, string namespaceUri)
			
			{
				return new ConfigXmlElement (this._filename, this.LineNumber, prefix, localName, namespaceUri, ((XmlDocument) this));
			}
			
			public override XmlSignificantWhitespace CreateSignificantWhitespace (string data)
			
			{
				return new ConfigXmlSignificantWhitespace (this._filename, this.LineNumber, data, ((XmlDocument) this));
			}
			
			public override XmlText CreateTextNode (string text)
			
			{
				return new ConfigXmlText (this._filename, this.LineNumber, text, ((XmlDocument) this));
			}
			
			public override XmlWhitespace CreateWhitespace (string data)
			
			{
				return new ConfigXmlWhitespace (this._filename, this.LineNumber, data, ((XmlDocument) this));
			}
			
			public override void Load (string filename)
			
			{
				this._filename = filename;
				try
				{
					this._reader = new XmlTextReader (filename);
					base.Load (((XmlReader) this._reader));
				}
				finally
				{
					if (this._reader != null)
					{
						this._reader.Close ();
						this._reader = ((XmlTextReader) null);
					}
				}
			}
			
			public void LoadSingleElement (string filename, XmlTextReader sourceReader)
			
			{
				this._filename = filename;
				this._lineOffset = sourceReader.LineNumber;
				string string1 = sourceReader.ReadOuterXml ();
				try
				{
					this._reader = new XmlTextReader (((TextReader) new StringReader (string1)), sourceReader.NameTable);
					base.Load (((XmlReader) this._reader));
				}
				finally
				{
					if (this._reader != null)
					{
						this._reader.Close ();
						this._reader = ((XmlTextReader) null);
					}
				}
			}
			
			internal XmlNode ReadConfigNode (string filename, XmlTextReader sourceReader)
			
			{
				XmlNode xmlNode1;
				this._filename = filename;
				this._reader = sourceReader;
				try
				{
					xmlNode1 = base.ReadNode (((XmlReader) sourceReader));
				}
				finally
				{
					this._reader = ((XmlTextReader) null);
				}
				return xmlNode1;
			}
			
		#endregion
	}
	
}

