//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:30:26
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace OpenNETCF.Configuration

{
		
		#region Namespace Import Declarations
		
			using System;
			using System.IO;
			using System.Reflection;
			using System.Threading;
			
		#endregion
		
	internal class DefaultConfigurationSystem : IConfigurationSystem
	
	{
		
		#region Fields
			private ConfigurationRecord _application;
			private static string _codeBase;
			private const string ConfigExtension = ".config";
			private const string MachineConfigFilename = "machine.config";
			private const string MachineConfigSubdirectory = "config";
		#endregion
		
		#region Constructors
		
			internal DefaultConfigurationSystem ()
			
			{
			}
			
			
			public DefaultConfigurationSystem (string CodeBase)
			
			{
				DefaultConfigurationSystem._codeBase = CodeBase;
			}
			
			
			static DefaultConfigurationSystem ()
			
			{
				DefaultConfigurationSystem._codeBase = ((string) null);
			}
			
		#endregion
		
		#region Properties
		
			internal static Uri AppConfigPath
			
			{
				get
				{
					char char1;
					string string1 = DefaultConfigurationSystem.ApplicationBase ();
					if (string1.Length > 0)
					{
						char1 = string1[((int) (string1.Length - 1))];
						if ((char1 != '\u002F') && (char1 != '\\'))
						{
							string1 = (string1 + '\\'.ToString ());
						}
					}
					Uri uri1 = new Uri (string1);
					string string2 = DefaultConfigurationSystem.ConfigurationFile ();
					if (string2 == null)
					{
						return null;
					}
					else if (string2.Length <= 0)
					{
						return null;
					}
					else
					{
						return new Uri (uri1, string2);
					}
				}
			}
			
			
			internal static string MachineConfigurationFilePath
			
			{
				get
				{
					return Path.Combine (Path.Combine (DefaultConfigurationSystem.MsCorLibDirectory, "config"), "machine.config");
				}
			}
			
			
			internal static string MsCorLibDirectory
			
			{
				get
				{
					string string1 = typeof (object).Assembly.GetName ().CodeBase;
					int i1 = (string1.IndexOf ("\\", 2) + 1);
					string string2 = string1.Substring (0, i1);
					string2 = string2.Replace ("/", "\\");
					return Path.GetDirectoryName (string2);
				}
			}
			
		#endregion
		
		#region Methods
		
			private static string ApplicationBase ()
			
			{
				string string1 = DefaultConfigurationSystem.GetCodeBase ();
				return string1.Substring (0, string1.LastIndexOf ("\\"));
			}
			
			private static string ConfigurationFile ()
			
			{
				return (DefaultConfigurationSystem.GetCodeBase () + ".config");
			}
			
			private static string GetCodeBase ()
			
			{
				return DefaultConfigurationSystem._codeBase;
			}
			
			object IConfigurationSystem.GetConfig (string configKey)
			
			{
				if (this._application != null)
				{
					return this._application.GetConfig (configKey);
				}
				else
				{
					throw new InvalidOperationException ("Client config init error");
				}
			}
			
			void IConfigurationSystem.Init ()
			
			{
				ConfigurationRecord configurationRecord1;
				string string1;
				Uri uri1;
				DefaultConfigurationSystem defaultConfigurationSystem1 = this;
				lock (defaultConfigurationSystem1)
				{
					if (this._application == null)
					{
						configurationRecord1 = ((ConfigurationRecord) null);
						string1 = DefaultConfigurationSystem.MachineConfigurationFilePath;
						uri1 = DefaultConfigurationSystem.AppConfigPath;
						this._application = (configurationRecord1 = new ConfigurationRecord ());
						if (configurationRecord1.Load (string1) && (uri1 != null))
						{
							this._application = new ConfigurationRecord (configurationRecord1);
							bool b2 = this._application.Load (uri1.ToString ());
						}
					}
				}
			}
			
		#endregion
	}
	
}

