//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:30:26
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace OpenNETCF.Configuration

{
		
		#region Namespace Import Declarations
		
			using System;
			using System.Globalization;
			using System.Xml;
			
		#endregion
		
	internal class HandlerBase
	
	{
		
		#region Constructors
		
			public HandlerBase ()
			
			{
			}
			
		#endregion
		
		#region Methods
		
			internal static void CheckForChildNodes (XmlNode node)
			
			{
				if (node.HasChildNodes)
				{
					throw new ConfigurationException ("No child nodes", node.FirstChild);
				}
			}
			
			internal static void CheckForNonElement (XmlNode node)
			
			{
				if (node.NodeType != XmlNodeType.Element)
				{
					throw new ConfigurationException ("Non-element found", node);
				}
			}
			
			internal static void CheckForUnrecognizedAttributes (XmlNode node)
			
			{
				if (node.Attributes.Count != 0)
				{
					throw new ConfigurationException (("Config base unrecognized attribute: " + node.Attributes.Item (0).Name), node);
				}
			}
			
			private static XmlNode GetAndRemoveAttribute (XmlNode node, string attrib, bool fRequired)
			
			{
				XmlNode xmlNode1 = node.Attributes.RemoveNamedItem (attrib);
				if (! fRequired)
				{
					return xmlNode1;
				}
				else if (xmlNode1 != null)
				{
					return xmlNode1;
				}
				else
				{
					throw new ConfigurationException (("Missing required attribute: " + node.Name), node);
				}
			}
			
			internal static XmlNode GetAndRemoveBooleanAttribute (XmlNode node, string attrib, ref bool val)
			
			{
				return HandlerBase.GetAndRemoveBooleanAttributeInternal (node, attrib, false, ref val);
			}
			
			private static XmlNode GetAndRemoveBooleanAttributeInternal (XmlNode node, string attrib, bool fRequired, ref bool val)
			
			{
				Exception exception1;
				XmlNode xmlNode1 = HandlerBase.GetAndRemoveAttribute (node, attrib, fRequired);
				if (xmlNode1 == null)
				{
					return xmlNode1;
				}
				else
				{
					try
					{
						val = bool.Parse (xmlNode1.Value);
						return xmlNode1;
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						throw new ConfigurationException (("Invalid boolean attribute: " + xmlNode1.Name), exception1, xmlNode1);
					}
				}
			}
			
			internal static XmlNode GetAndRemoveIntegerAttribute (XmlNode node, string attrib, ref int val)
			
			{
				return HandlerBase.GetAndRemoveIntegerAttributeInternal (node, attrib, false, ref val);
			}
			
			private static XmlNode GetAndRemoveIntegerAttributeInternal (XmlNode node, string attrib, bool fRequired, ref int val)
			
			{
				Exception exception1;
				XmlNode xmlNode1 = HandlerBase.GetAndRemoveAttribute (node, attrib, fRequired);
				if (xmlNode1 == null)
				{
					return xmlNode1;
				}
				else
				{
					try
					{
						val = int.Parse (xmlNode1.Value, ((IFormatProvider) CultureInfo.InvariantCulture));
						return xmlNode1;
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						throw new ConfigurationException (("Invalid integer attribute:" + xmlNode1.Name), exception1, xmlNode1);
					}
				}
			}
			
			internal static XmlNode GetAndRemovePositiveIntegerAttribute (XmlNode node, string attrib, ref int val)
			
			{
				return HandlerBase.GetAndRemovePositiveIntegerAttributeInternal (node, attrib, false, ref val);
			}
			
			private static XmlNode GetAndRemovePositiveIntegerAttributeInternal (XmlNode node, string attrib, bool fRequired, ref int val)
			
			{
				XmlNode xmlNode1 = HandlerBase.GetAndRemoveIntegerAttributeInternal (node, attrib, fRequired, ref val);
				if (xmlNode1 == null)
				{
					return xmlNode1;
				}
				else if (val >= 0)
				{
					return xmlNode1;
				}
				else
				{
					throw new ConfigurationException (("Invalid positive integer attribute: " + attrib), node);
				}
			}
			
			internal static XmlNode GetAndRemoveRequiredBooleanAttribute (XmlNode node, string attrib, ref bool val)
			
			{
				return HandlerBase.GetAndRemoveBooleanAttributeInternal (node, attrib, true, ref val);
			}
			
			internal static XmlNode GetAndRemoveRequiredIntegerAttribute (XmlNode node, string attrib, ref int val)
			
			{
				return HandlerBase.GetAndRemoveIntegerAttributeInternal (node, attrib, true, ref val);
			}
			
			internal static XmlNode GetAndRemoveRequiredPositiveIntegerAttribute (XmlNode node, string attrib, ref int val)
			
			{
				return HandlerBase.GetAndRemovePositiveIntegerAttributeInternal (node, attrib, true, ref val);
			}
			
			internal static XmlNode GetAndRemoveRequiredStringAttribute (XmlNode node, string attrib, ref string val)
			
			{
				return HandlerBase.GetAndRemoveStringAttributeInternal (node, attrib, true, ref val);
			}
			
			internal static XmlNode GetAndRemoveRequiredTypeAttribute (XmlNode node, string attrib, ref Type val)
			
			{
				return HandlerBase.GetAndRemoveTypeAttributeInternal (node, attrib, true, ref val);
			}
			
			internal static XmlNode GetAndRemoveStringAttribute (XmlNode node, string attrib, ref string val)
			
			{
				return HandlerBase.GetAndRemoveStringAttributeInternal (node, attrib, false, ref val);
			}
			
			private static XmlNode GetAndRemoveStringAttributeInternal (XmlNode node, string attrib, bool fRequired, ref string val)
			
			{
				XmlNode xmlNode1 = HandlerBase.GetAndRemoveAttribute (node, attrib, fRequired);
				if (xmlNode1 != null)
				{
					val = xmlNode1.Value;
				}
				return xmlNode1;
			}
			
			internal static XmlNode GetAndRemoveTypeAttribute (XmlNode node, string attrib, ref Type val)
			
			{
				return HandlerBase.GetAndRemoveTypeAttributeInternal (node, attrib, false, ref val);
			}
			
			private static XmlNode GetAndRemoveTypeAttributeInternal (XmlNode node, string attrib, bool fRequired, ref Type val)
			
			{
				Exception exception1;
				XmlNode xmlNode1 = HandlerBase.GetAndRemoveAttribute (node, attrib, fRequired);
				if (xmlNode1 == null)
				{
					return xmlNode1;
				}
				else
				{
					try
					{
						val = Type.GetType (xmlNode1.Value, true);
						return xmlNode1;
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						throw new ConfigurationException (("Invalid type attribute: " + xmlNode1.Name), exception1, xmlNode1);
					}
				}
			}
			
			internal static bool IsIgnorableAlsoCheckForNonElement (XmlNode node)
			
			{
				if ((node.NodeType == XmlNodeType.Comment) || (node.NodeType == XmlNodeType.Whitespace))
				{
					return true;
				}
				else
				{
					HandlerBase.CheckForNonElement (node);
					return false;
				}
			}
			
			internal static string RemoveAttribute (XmlNode node, string name)
			
			{
				XmlNode xmlNode1 = node.Attributes.RemoveNamedItem (name);
				if (xmlNode1 == null)
				{
					return null;
				}
				else
				{
					return xmlNode1.Value;
				}
			}
			
			internal static string RemoveRequiredAttribute (XmlNode node, string name)
			
			{
				return HandlerBase.RemoveRequiredAttribute (node, name, false);
			}
			
			internal static string RemoveRequiredAttribute (XmlNode node, string name, bool allowEmpty)
			
			{
				object[] objectArray1;
				object[] objectArray2;
				XmlNode xmlNode1 = node.Attributes.RemoveNamedItem (name);
				if (xmlNode1 == null)
				{
					objectArray2 = new object[] { name };
					objectArray1 = objectArray2;
					throw new ConfigurationException (("Required attribute missing: " + objectArray1.ToString ()), node);
				}
				else if (xmlNode1.Value != string.Empty)
				{
					return xmlNode1.Value;
				}
				else if (allowEmpty)
				{
					return xmlNode1.Value;
				}
				else
				{
					objectArray2 = new object[] { name };
					objectArray1 = objectArray2;
					throw new ConfigurationException (("Required attribute empty: " + objectArray1.ToString ()), node);
				}
			}
			
			internal static void ThrowUnrecognizedElement (XmlNode node)
			
			{
				throw new ConfigurationException ("Unrecognized element", node);
			}
			
		#endregion
	}
	
}

