//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:30:26
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace OpenNETCF.Diagnostics

{
		
		#region Namespace Import Declarations
		
			using OpenNETCF.Runtime.InteropServices;
			using OpenNETCF.Win32;
			using System;
			using System.IO;
			using System.Runtime.InteropServices;
			
		#endregion
		
	public sealed class FileVersionInfo
	
	{
		
		#region Fields
			private string m_filename;
			private byte[] m_fixedversioninfo;
		#endregion
		
		#region Constructors
		
			private FileVersionInfo (string fileName)
			
			{
				IntPtr intPtr2;
				int i3;
				this.m_filename = Path.GetFileName (fileName);
				int i1 = 0;
				int i2 = FileVersionInfo.GetFileVersionInfoSize (fileName, ref i1);
				if (i2 <= 0)
				{
					return;
				}
				IntPtr intPtr1 = MarshalEx.AllocHGlobal (i2);
				if (FileVersionInfo.GetFileVersionInfo (fileName, i1, i2, intPtr1))
				{
					intPtr2 = IntPtr.Zero;
					i3 = 0;
					if (! FileVersionInfo.VerQueryValue (intPtr1, "\\", ref intPtr2, ref i3))
					{
						throw new WinAPIException ("Error retrieving language independant version");
					}
					else
					{
						this.m_fixedversioninfo = new byte[i3];
						Marshal.Copy (intPtr2, this.m_fixedversioninfo, 0, i3);
						MarshalEx.FreeHGlobal (intPtr1);
						return;
					}
				}
				throw new WinAPIException ("Error retrieving FileVersionInformation");
			}
			
		#endregion
		
		#region Properties
		
			public int FileBuildPart
			
			{
				get
				{
					return Convert.ToInt32 (BitConverter.ToInt16 (this.m_fixedversioninfo, 14));
				}
			}
			
			
			public int FileMajorPart
			
			{
				get
				{
					return Convert.ToInt32 (BitConverter.ToInt16 (this.m_fixedversioninfo, 10));
				}
			}
			
			
			public int FileMinorPart
			
			{
				get
				{
					return Convert.ToInt32 (BitConverter.ToInt16 (this.m_fixedversioninfo, 8));
				}
			}
			
			
			public string FileName
			
			{
				get
				{
					return this.m_filename;
				}
			}
			
			
			public int FilePrivatePart
			
			{
				get
				{
					return Convert.ToInt32 (BitConverter.ToInt16 (this.m_fixedversioninfo, 12));
				}
			}
			
			
			public int ProductBuildPart
			
			{
				get
				{
					return Convert.ToInt32 (BitConverter.ToInt16 (this.m_fixedversioninfo, 22));
				}
			}
			
			
			public int ProductMajorPart
			
			{
				get
				{
					return Convert.ToInt32 (BitConverter.ToInt16 (this.m_fixedversioninfo, 18));
				}
			}
			
			
			public int ProductMinorPart
			
			{
				get
				{
					return Convert.ToInt32 (BitConverter.ToInt16 (this.m_fixedversioninfo, 16));
				}
			}
			
			
			public int ProductPrivatePart
			
			{
				get
				{
					return Convert.ToInt32 (BitConverter.ToInt16 (this.m_fixedversioninfo, 20));
				}
			}
			
		#endregion
		
		#region Methods
		
			[DllImportAttribute("coredll", EntryPoint = "GetFileVersionInfo", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			private static extern bool GetFileVersionInfo (string filename, int handle, int len, IntPtr buffer);
			[DllImportAttribute("coredll", EntryPoint = "GetFileVersionInfoSize", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			private static extern int GetFileVersionInfoSize (string filename, ref int handle);
			public static FileVersionInfo GetVersionInfo (string fileName)
			
			{
				if (File.Exists (fileName))
				{
					return new FileVersionInfo (fileName);
				}
				else
				{
					throw new FileNotFoundException ("The specified file was not found");
				}
			}
			
			[DllImportAttribute("coredll", EntryPoint = "VerQueryValue", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			private static extern bool VerQueryValue (IntPtr buffer, string subblock, ref IntPtr blockbuffer, ref int len);
		#endregion
	}
	
}

