//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:30:26
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace OpenNETCF.Diagnostics

{
		
		#region Namespace Import Declarations
		
			using OpenNETCF;
			using OpenNETCF.Win32;
			using System;
			using System.Collections;
			using System.ComponentModel;
			using System.IO;
			using System.Runtime.InteropServices;
			using System.Text;
			
		#endregion
		
	public class Process : Component
	
	{
		
		#region Fields
			public event EventHandler Exited;
			private bool m_exited;
			private ProcessInfo m_pinfo;
			private ProcessStartInfo m_pstart;
			private const uint PUserKDataARM = 4294952960;
			private const uint PUserKDataX86 = 22528;
			private const int SH_CURPROC = 2;
			private const int SH_CURTHREAD = 1;
			private const int SH_WIN32 = 0;
			private const int StillActive = 259;
			private const int SYS_HANDLE_BASE = 64;
			private const uint SYSHANDLE_OFFSET = 4;
			private const int TH32CS_SNAPPROCESS = 2;
		#endregion
		
		#region Nested Types
		
			private sealed class ProcessInfo
			
			{
				
				#region Fields
					public int dwProcessID;
					public int dwThreadID;
					public IntPtr hProcess;
					public IntPtr hThread;
				#endregion
				
				#region Constructors
				
					public ProcessInfo ()
					
					{
						this.hProcess = IntPtr.Zero;
						this.hThread = IntPtr.Zero;
						this.dwProcessID = 0;
						this.dwThreadID = 0;
					}
					
				#endregion
			}
			
			
			private sealed class ShellExecuteInfo
			
			{
				
				#region Fields
					public uint cbSize;
					public uint dwHotKey;
					public uint fMask;
					public IntPtr hIcon;
					public IntPtr hInstApp;
					public IntPtr hkeyClass;
					public IntPtr hProcess;
					public IntPtr hwnd;
					public IntPtr lpClass;
					public IntPtr lpDirectory;
					public IntPtr lpFile;
					public IntPtr lpIDList;
					public IntPtr lpParameters;
					public IntPtr lpVerb;
					public int nShow;
				#endregion
				
				#region Constructors
				
					public ShellExecuteInfo ()
					
					{
						this.cbSize = 60;
						this.fMask = 64;
						this.hwnd = IntPtr.Zero;
						this.lpVerb = IntPtr.Zero;
						this.lpFile = IntPtr.Zero;
						this.lpParameters = IntPtr.Zero;
						this.lpDirectory = IntPtr.Zero;
						this.nShow = 0;
						this.hInstApp = IntPtr.Zero;
						this.lpIDList = IntPtr.Zero;
						this.lpClass = IntPtr.Zero;
						this.hkeyClass = IntPtr.Zero;
						this.dwHotKey = uint.MinValue;
						this.hIcon = IntPtr.Zero;
						this.hProcess = IntPtr.Zero;
					}
					
				#endregion
			}
			
		#endregion
		
		#region Constructors
		
			public Process ()
			
			{
				this.m_pstart = new ProcessStartInfo ();
				this.m_pinfo = new ProcessInfo ();
				this.m_exited = false;
			}
			
		#endregion
		
		#region Properties
		
			public int ExitCode
			
			{
				get
				{
					int i1 = 0;
					if (Process.GetExitCodeProcess (this.m_pinfo.hProcess, ref i1))
					{
						if (i1 == 259)
						{
							throw new InvalidOperationException (" The process has not exited.");
						}
						else
						{
							this.m_exited = true;
							return i1;
						}
					}
					throw new InvalidOperationException ("The process OpenNETCF.Diagnostics.Process.Handle is not valid.");
				}
			}
			
			
			public IntPtr Handle
			
			{
				get
				{
					if (this.m_pinfo.hProcess != IntPtr.Zero)
					{
						return this.m_pinfo.hProcess;
					}
					else if (this.m_pinfo.dwProcessID == 0)
					{
						return IntPtr.Zero;
					}
					else
					{
						this.m_pinfo.hProcess = Process.OpenProcess (uint.MinValue, false, ((IntPtr) this.m_pinfo.dwProcessID));
						return this.m_pinfo.hProcess;
					}
				}
			}
			
			
			public bool HasExited
			
			{
				get
				{
					return this.m_exited;
				}
			}
			
			
			public int Id
			
			{
				get
				{
					return this.m_pinfo.dwProcessID;
				}
			}
			
			
			public string ProcessName
			
			{
				get
				{
					return Path.GetFileNameWithoutExtension (this.StartInfo.FileName);
				}
			}
			
			
			public ProcessStartInfo StartInfo
			
			{
				get
				{
					return this.m_pstart;
				}
				set
				{
					if (value != null)
					{
						this.m_pstart = value;
					}
					else
					{
						throw new ArgumentException ("The value that specifies the OpenNETCF.Diagnostics.Process.StartInfo is null.");
					}
				}
			}
			
		#endregion
		
		#region Methods
		
			[DllImportAttribute("coredll.dll", EntryPoint = "CloseHandle", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			internal static extern int CloseHandle (IntPtr hObject);
			[DllImportAttribute("toolhelp.dll", EntryPoint = "CloseToolhelp32Snapshot", CharSet = CharSet.None, ExactSpelling = false, SetLastError = false, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			private static extern int CloseToolhelp32Snapshot (IntPtr handle);
			[DllImportAttribute("coredll", EntryPoint = "CreateProcess", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			private static extern bool CreateProcess (string pszImageName, string pszCmdLine, IntPtr psaProcess, IntPtr psaThread, int fInheritHandles, int fdwCreate, IntPtr pvEnvironment, IntPtr pszCurDir, IntPtr psiStartInfo, ProcessInfo pi);
			[DllImportAttribute("toolhelp.dll", EntryPoint = "CreateToolhelp32Snapshot", CharSet = CharSet.None, ExactSpelling = false, SetLastError = false, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			private static extern IntPtr CreateToolhelp32Snapshot (uint flags, uint processid);
			protected override void Dispose (bool disposing)
			
			{
				int i1 = Process.CloseHandle (this.m_pinfo.hProcess);
				base.Dispose (disposing);
			}
			
			new public void Dispose ()
			
			{
				this.Dispose (true);
				GC.SuppressFinalize (this);
			}
			
			public static Process GetCurrentProcess ()
			
			{
				Process process1 = Process.GetProcessById (Process.GetCurrentProcessID ());
				IntPtr intPtr1 = Process.GetModuleHandle (IntPtr.Zero);
				StringBuilder stringBuilder1 = new StringBuilder (255);
				int i1 = Process.GetModuleFileName (intPtr1, stringBuilder1, stringBuilder1.Capacity);
				string string1 = Path.GetFileNameWithoutExtension (stringBuilder1.ToString ());
				ProcessStartInfo processStartInfo1 = new ProcessStartInfo (string1);
				process1.StartInfo = processStartInfo1;
				return process1;
			}
			
			public static int GetCurrentProcessID ()
			
			{
				IntPtr intPtr1;
				intPtr1 = new IntPtr (((int) (((int) Process.GetPUserKData ()) + 4)));
				return Marshal.ReadInt32 (intPtr1, 8);
			}
			
			public static IntPtr GetCurrentThread ()
			
			{
				return new IntPtr (65);
			}
			
			public static int GetCurrentThreadID ()
			
			{
				IntPtr intPtr1;
				intPtr1 = new IntPtr (((int) (((int) Process.GetPUserKData ()) + 4)));
				return Marshal.ReadInt32 (intPtr1, 4);
			}
			
			[DllImportAttribute("coredll.dll", EntryPoint = "GetExitCodeProcess", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			private static extern bool GetExitCodeProcess (IntPtr hProcess, ref int lpExitCode);
			[DllImportAttribute("coredll.dll", EntryPoint = "GetModuleFileName", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			private static extern int GetModuleFileName (IntPtr hModule, StringBuilder ModuleName, int cch);
			[DllImportAttribute("coredll.dll", EntryPoint = "GetModuleHandle", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			private static extern IntPtr GetModuleHandle (IntPtr ModuleName);
			public static Process GetProcessById (int processId)
			
			{
				Process process1 = new Process ();
				process1.m_pinfo.dwProcessID = processId;
				process1.m_pinfo.hProcess = Process.OpenProcess (uint.MinValue, false, ((IntPtr) processId));
				return process1;
			}
			
			public static Process[] GetProcesses ()
			
			{
				return Process.GetProcessesByName (((string) null));
			}
			
			public static Process[] GetProcessesByName (string processName)
			
			{
				ProcessEntryInfo processEntryInfo1;
				ProcessEntryInfo processEntryInfo2;
				byte[] byteArray1;
				string string1;
				int i1;
				bool b1;
				Process process1;
				ProcessStartInfo processStartInfo1;
				Exception exception1;
				ArrayList arrayList1 = new ArrayList ();
				IntPtr intPtr1 = Process.CreateToolhelp32Snapshot (2, uint.MinValue);
				if (((int) intPtr1) > 0)
				{
					try
					{
						processEntryInfo2 = new ProcessEntryInfo ();
						byteArray1 = processEntryInfo2.AllocateBytes ();
						string1 = Path.GetFileNameWithoutExtension (processName).ToUpper ();
						for (i1 = Process.Process32First (intPtr1, byteArray1); (i1 == 1); i1 = Process.Process32Next (intPtr1, byteArray1))
						{
							processEntryInfo1 = new ProcessEntryInfo (byteArray1);
							b1 = true;
							if (processName != null)
							{
								b1 = (Path.GetFileNameWithoutExtension (processEntryInfo1.Name).ToUpper ().CompareTo (string1) == 0);
							}
							if (b1)
							{
								process1 = Process.GetProcessById (((int) processEntryInfo1.PID));
								processStartInfo1 = new ProcessStartInfo (processEntryInfo1.Name);
								process1.StartInfo = processStartInfo1;
								int i2 = arrayList1.Add (process1);
							}
						}
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						throw new Exception (("Exception: " + exception1.Message));
					}
					int i3 = Process.CloseToolhelp32Snapshot (intPtr1);
					return ((Process[]) arrayList1.ToArray (typeof (Process)));
				}
				else
				{
					throw new Exception ("Unable to create snapshot");
				}
			}
			
			private static uint GetPUserKData ()
			
			{
				Core.SystemInfo systemInfo1 = Core.GetSystemInfo ();
				Core.ProcessorArchitecture processorArchitecture1 = systemInfo1.wProcessorArchitecture;
				if (processorArchitecture1 != OpenNETCF.Win32.Core.ProcessorArchitecture.Intel)
				{
					if (processorArchitecture1 == OpenNETCF.Win32.Core.ProcessorArchitecture.ARM)
					{
						return ((uint) 0xFFFFC800);
					}
					else
					{
						throw new NotSupportedException (("Unsupported on current processor: " + EnumEx.GetName (typeof (Core.ProcessorArchitecture), systemInfo1.wProcessorArchitecture)));
					}
				}
				return 22528;
			}
			
			[DllImportAttribute("coredll.dll", EntryPoint = "GetWindowThreadProcessId", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			private static extern int GetWindowThreadProcessId (IntPtr hWnd, ref int lpdwProcessId);
			public void Kill ()
			
			{
				IntPtr intPtr1;
				if (! this.m_exited)
				{
					intPtr1 = Process.OpenProcess (uint.MinValue, false, this.Handle);
					if (Process.TerminateProcess (intPtr1, 0))
					{
						int i1 = Process.CloseHandle (intPtr1);
						this.OnExited ();
						return;
					}
					else
					{
						throw new Win32Exception (Marshal.GetLastWin32Error (), "The associated process could not be terminated");
					}
				}
				throw new InvalidOperationException ("The process has already exited.");
			}
			
			protected void OnExited ()
			
			{
				this.m_exited = true;
				if (this.Exited != null)
				{
					this.Exited (this, new EventArgs ());
				}
			}
			
			[DllImportAttribute("coredll", EntryPoint = "OpenProcess", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			internal static extern IntPtr OpenProcess (uint fdwAccess, bool fInherit, IntPtr IDProcess);
			[DllImportAttribute("toolhelp.dll", EntryPoint = "Process32First", CharSet = CharSet.None, ExactSpelling = false, SetLastError = false, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			private static extern int Process32First (IntPtr handle, byte[] pe);
			[DllImportAttribute("toolhelp.dll", EntryPoint = "Process32Next", CharSet = CharSet.None, ExactSpelling = false, SetLastError = false, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			private static extern int Process32Next (IntPtr handle, byte[] pe);
			[DllImportAttribute("coredll", EntryPoint = "ShellExecuteEx", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			private static extern bool ShellExecuteEx (ShellExecuteInfo ex);
			public static Process Start (string fileName, string arguments)
			
			{
				return Process.Start (new ProcessStartInfo (fileName, arguments));
			}
			
			public bool Start ()
			
			{
				GCHandle gCHandle1;
				if (! this.m_pstart.UseShellExecute)
				{
					return Process.CreateProcess (this.m_pstart.FileName, this.m_pstart.Arguments, IntPtr.Zero, IntPtr.Zero, 0, 0, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, this.m_pinfo);
				}
				ShellExecuteInfo shellExecuteInfo1 = new ShellExecuteInfo ();
				shellExecuteInfo1.lpFile = ((IntPtr) (((int) (gCHandle1 = GCHandle.Alloc ((this.m_pstart.FileName + '\0'.ToString ()).ToCharArray (), GCHandleType.Pinned)).AddrOfPinnedObject ()) + 4));
				shellExecuteInfo1.nShow = ((int) this.m_pstart.WindowStyle);
				GCHandle gCHandle2 = new GCHandle ();
				if (this.m_pstart.Arguments != null)
				{
					shellExecuteInfo1.lpParameters = ((IntPtr) (((int) (gCHandle2 = GCHandle.Alloc ((this.m_pstart.Arguments + '\0'.ToString ()).ToCharArray (), GCHandleType.Pinned)).AddrOfPinnedObject ()) + 4));
				}
				GCHandle gCHandle3 = new GCHandle ();
				if (this.m_pstart.Verb != null)
				{
					shellExecuteInfo1.lpVerb = ((IntPtr) (((int) (gCHandle3 = GCHandle.Alloc (this.m_pstart.Verb.ToCharArray (), GCHandleType.Pinned)).AddrOfPinnedObject ()) + 4));
				}
				bool b1 = Process.ShellExecuteEx (shellExecuteInfo1);
				this.m_pinfo.hProcess = shellExecuteInfo1.hProcess;
				if (gCHandle1.IsAllocated)
				{
					gCHandle1.Free ();
				}
				if (gCHandle2.IsAllocated)
				{
					gCHandle2.Free ();
				}
				if (gCHandle3.IsAllocated)
				{
					gCHandle3.Free ();
				}
				return b1;
			}
			
			public static Process Start (ProcessStartInfo startInfo)
			
			{
				Process process1 = new Process ();
				process1.m_pstart = startInfo;
				bool b1 = process1.Start ();
				return process1;
			}
			
			public static Process Start (string fileName)
			
			{
				return Process.Start (new ProcessStartInfo (fileName));
			}
			
			[DllImportAttribute("coredll.dll", EntryPoint = "TerminateProcess", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			internal static extern bool TerminateProcess (IntPtr hProcess, int uExitCode);
			public bool WaitForExit (int milliseconds)
			
			{
				uint uInt32_1;
				if ((milliseconds == int.MaxValue) || (milliseconds == int.MinValue))
				{
					uInt32_1 = (uint.MaxValue);
				}
				else if (milliseconds < 0)
				{
					uInt32_1 = (uint.MaxValue);
				}
				else
				{
					uInt32_1 = Convert.ToUInt32 (milliseconds);
				}
				if (Process.WaitForSingleObject (this.m_pinfo.hProcess, uInt32_1) != 0)
				{
					return false;
				}
				else
				{
					this.OnExited ();
					return true;
				}
			}
			
			public void WaitForExit ()
			
			{
				bool b1 = this.WaitForExit (int.MinValue);
			}
			
			[DllImportAttribute("coredll.dll", EntryPoint = "WaitForSingleObject", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			private static extern int WaitForSingleObject (IntPtr hHandle, uint dwMilliseconds);
		#endregion
	}
	
}

