//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:30:26
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace OpenNETCF.Diagnostics

{
		
		#region Namespace Import Declarations
		
			using System.Diagnostics;
			using System.Reflection;
			using System;
			
		#endregion
		
	public sealed class TraceEx
	
	{
		
		#region Fields
			private static string appBase;
			private static bool initialized;
		#endregion
		
		#region Constructors
		
			static TraceEx ()
			
			{
				TraceEx.appBase = string.Empty;
				TraceEx.initialized = false;
			}
			
			
			public TraceEx ()
			
			{
			}
			
		#endregion
		
		#region Properties
		
			public static bool AutoFlush
			
			{
				get
				{
					if (! TraceEx.initialized)
					{
						TraceEx.InitializeSettings (Assembly.GetCallingAssembly ().GetName ().CodeBase);
					}
					return TraceInternalEx.AutoFlush;
				}
				set
				{
					if (! TraceEx.initialized)
					{
						TraceEx.InitializeSettings (Assembly.GetCallingAssembly ().GetName ().CodeBase);
					}
					TraceInternalEx.AutoFlush = value;
				}
			}
			
			
			public static TraceListenerCollection Listeners
			
			{
				get
				{
					if (! TraceEx.initialized)
					{
						TraceEx.InitializeSettings (Assembly.GetCallingAssembly ().GetName ().CodeBase);
					}
					return TraceInternalEx.Listeners;
				}
			}
			
		#endregion
		
		#region Methods
		
			[ConditionalAttribute("TRACE")]
			public static void Assert (bool condition, string message)
			
			{
				if (! TraceEx.initialized)
				{
					TraceEx.InitializeSettings (Assembly.GetCallingAssembly ().GetName ().CodeBase);
				}
				TraceInternalEx.Assert (condition, message);
			}
			
			[ConditionalAttribute("TRACE")]
			public static void Assert (bool condition)
			
			{
				if (! TraceEx.initialized)
				{
					TraceEx.InitializeSettings (Assembly.GetCallingAssembly ().GetName ().CodeBase);
				}
				TraceInternalEx.Assert (condition);
			}
			
			[ConditionalAttribute("TRACE")]
			public static void Assert (bool condition, string message, string detailMessage)
			
			{
				if (! TraceEx.initialized)
				{
					TraceEx.InitializeSettings (Assembly.GetCallingAssembly ().GetName ().CodeBase);
				}
				TraceInternalEx.Assert (condition, message, detailMessage);
			}
			
			private static void InitializeSettings (string path)
			
			{
				TraceEx.appBase = path;
				TraceInternalEx.appBase = path;
				TraceEx.initialized = true;
			}
			
			[ConditionalAttribute("TRACE")]
			public static void Write (object value, string category)
			
			{
				if (! TraceEx.initialized)
				{
					TraceEx.InitializeSettings (Assembly.GetCallingAssembly ().GetName ().CodeBase);
				}
				TraceInternalEx.Write (value, category);
			}
			
			[ConditionalAttribute("TRACE")]
			public static void Write (string message)
			
			{
				if (! TraceEx.initialized)
				{
					TraceEx.InitializeSettings (Assembly.GetCallingAssembly ().GetName ().CodeBase);
				}
				TraceInternalEx.Write (message);
			}
			
			[ConditionalAttribute("TRACE")]
			public static void Write (object value)
			
			{
				if (! TraceEx.initialized)
				{
					TraceEx.InitializeSettings (Assembly.GetCallingAssembly ().GetName ().CodeBase);
				}
				TraceInternalEx.Write (value);
			}
			
			[ConditionalAttribute("TRACE")]
			public static void Write (string message, string category)
			
			{
				if (! TraceEx.initialized)
				{
					TraceEx.InitializeSettings (Assembly.GetCallingAssembly ().GetName ().CodeBase);
				}
				TraceInternalEx.Write (message, category);
			}
			
			[ConditionalAttribute("TRACE")]
			public static void WriteLine (object value, string category)
			
			{
				if (! TraceEx.initialized)
				{
					TraceEx.InitializeSettings (Assembly.GetCallingAssembly ().GetName ().CodeBase);
				}
				TraceInternalEx.WriteLine (value, category);
			}
			
			[ConditionalAttribute("TRACE")]
			public static void WriteLine (object value)
			
			{
				if (! TraceEx.initialized)
				{
					TraceEx.InitializeSettings (Assembly.GetCallingAssembly ().GetName ().CodeBase);
				}
				TraceInternalEx.WriteLine (value);
			}
			
			[ConditionalAttribute("TRACE")]
			public static void WriteLine (string message)
			
			{
				if (! TraceEx.initialized)
				{
					TraceEx.InitializeSettings (Assembly.GetCallingAssembly ().GetName ().CodeBase);
				}
				TraceInternalEx.WriteLine (message);
			}
			
			[ConditionalAttribute("TRACE")]
			public static void WriteLine (string message, string category)
			
			{
				if (! TraceEx.initialized)
				{
					TraceEx.InitializeSettings (Assembly.GetCallingAssembly ().GetName ().CodeBase);
				}
				TraceInternalEx.WriteLine (message, category);
			}
			
		#endregion
	}
	
}

