//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:30:26
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace OpenNETCF.IO

{
		
		#region Namespace Import Declarations
		
			using OpenNETCF.Win32;
			using System;
			using System.IO;
			using System.Runtime.InteropServices;
			// Warning -- Type: System.IO.FileAccess conflicts with a another imported type or namespace name,  Disabled Using Ref --> using FileAccess = System.IO.FileAccess;
			// Warning -- Type: System.IO.FileShare conflicts with a another imported type or namespace name,  Disabled Using Ref --> using FileShare = System.IO.FileShare;
			
		#endregion
		
	public class FileEx
	
	{
		
		#region Fields
			internal const int ERROR_NO_MORE_FILES = 18;
			public const int InvalidHandle = -1;
			public const int MaxPath = 260;
		#endregion
		
		#region Nested Types
		
			private class FILETIME
			
			{
				
				#region Fields
					private byte[] m_data;
				#endregion
				
				#region Constructors
				
					public FILETIME (long FileTime)
					
					{
						this.m_data = BitConverter.GetBytes (FileTime);
					}
					
					
					public FILETIME ()
					
					{
						this.m_data = new byte[8];
					}
					
				#endregion
				
				#region Properties
				
					public uint dwHighDateTime
					
					{
						get
						{
							return BitConverter.ToUInt32 (this.m_data, 4);
						}
						set
						{
							Buffer.BlockCopy (((Array) BitConverter.GetBytes (value)), 0, ((Array) this.m_data), 4, 4);
						}
					}
					
					
					public uint dwLowDateTime
					
					{
						get
						{
							return BitConverter.ToUInt32 (this.m_data, 0);
						}
						set
						{
							Buffer.BlockCopy (((Array) BitConverter.GetBytes (value)), 0, ((Array) this.m_data), 0, 4);
						}
					}
					
				#endregion
				
				#region Methods
				
					public static implicit operator byte[] (FileEx.FILETIME f)
					
					{
						return f.m_data;
					}
					
				#endregion
			}
			
			
			public enum MoveMethod
			
			{
				FileBeginning = 0, 
				CurrentPosition = 1, 
				FileEnd = 2, 
			}
			
		#endregion
		
		#region Constructors
		
			private FileEx ()
			
			{
			}
			
		#endregion
		
		#region Methods
		
			public static StreamWriter AppendText (string path)
			
			{
				return File.AppendText (path);
			}
			
			public static void CloseHandle (IntPtr hObject)
			
			{
				bool b1;
				Exception exception1;
				Core.CheckHandle (hObject);
				try
				{
					b1 = Convert.ToBoolean (FileEx.CloseHandleCE (hObject));
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					throw new WinAPIException (exception1);
				}
				if (! b1)
				{
					throw new WinAPIException ("Failed to close handle");
				}
			}
			
			[DllImportAttribute("coredll.dll", EntryPoint = "CloseHandle", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			internal static extern int CloseHandleCE (IntPtr hObject);
			public static void Copy (string sourceFileName, string destFileName)
			
			{
				File.Copy (sourceFileName, destFileName);
			}
			
			public static void Copy (string sourceFileName, string destFileName, bool overwrite)
			
			{
				File.Copy (sourceFileName, destFileName, overwrite);
			}
			
			public static FileStream Create (string path, int bufferSize)
			
			{
				return File.Create (path, bufferSize);
			}
			
			public static FileStream Create (string path)
			
			{
				return File.Create (path);
			}
			
			[CLSCompliantAttribute(false)]
			public static IntPtr CreateFile (string fileName, FileAccess desiredAccess, FileShare shareMode, FileCreateDisposition creationDisposition, int flagsAndAttributes)
			
			{
				IntPtr intPtr1 = ((IntPtr) FileEx.CreateFileCE (fileName, ((uint) desiredAccess), ((uint) shareMode), 0, ((uint) creationDisposition), ((uint) flagsAndAttributes), 0));
				if (((int) intPtr1) != -1)
				{
					return intPtr1;
				}
				else
				{
					throw new WinAPIException ("Failed to Create File");
				}
			}
			
			[DllImportAttribute("coredll.dll", EntryPoint = "CreateFile", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			internal static extern int CreateFileCE (string lpFileName, uint dwDesiredAccess, uint dwShareMode, int lpSecurityAttributes, uint dwCreationDisposition, uint dwFlagsAndAttributes, int hTemplateFile);
			public static StreamWriter CreateText (string path)
			
			{
				return File.CreateText (path);
			}
			
			public static void Delete (string path)
			
			{
				File.Delete (path);
			}
			
			[DllImportAttribute("coredll.dll", EntryPoint = "DeviceIoControl", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			internal static extern int DeviceIoControlCE (IntPtr hDevice, int dwIoControlCode, byte[] lpInBuffer, int nInBufferSize, byte[] lpOutBuffer, int nOutBufferSize, ref int lpBytesReturned, IntPtr lpOverlapped);
			public static bool Exists (string path)
			
			{
				return File.Exists (path);
			}
			
			public static FileAttributes GetAttributes (string path)
			
			{
				if (path.Length > 260)
				{
					throw new PathTooLongException ();
				}
				if (path.Trim ().Length == 0)
				{
					throw new ArgumentException ();
				}
				uint uInt32_1 = FileEx.GetFileAttributes (path);
				if (uInt32_1 != (uint.MaxValue))
				{
					return ((FileAttributes) uInt32_1);
				}
				int i1 = Marshal.GetLastWin32Error ();
				if ((i1 == 2) || (i1 == 3))
				{
					throw new FileNotFoundException ();
				}
				else
				{
					throw new Exception (("Unmanaged Error: " + i1.ToString ()));
				}
			}
			
			public static DateTime GetCreationTime (string path)
			
			{
				return File.GetCreationTime (path);
			}
			
			public static DateTime GetCreationTimeUtc (string path)
			
			{
				return File.GetCreationTime (path).ToUniversalTime ();
			}
			
			[DllImportAttribute("coredll", EntryPoint = "GetFileAttributes", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			internal static extern uint GetFileAttributes (string lpFileName);
			public static DateTime GetLastAccessTime (string path)
			
			{
				return File.GetLastAccessTime (path);
			}
			
			public static DateTime GetLastAccessTimeUtc (string path)
			
			{
				return File.GetLastAccessTime (path).ToUniversalTime ();
			}
			
			public static DateTime GetLastWriteTime (string path)
			
			{
				return File.GetLastWriteTime (path);
			}
			
			public static DateTime GetLastWriteTimeUtc (string path)
			
			{
				return File.GetLastWriteTime (path).ToUniversalTime ();
			}
			
			public static void Move (string sourceFileName, string destFileName)
			
			{
				File.Move (sourceFileName, destFileName);
			}
			
			public static FileStream Open (string path, FileMode mode, FileAccessEx access)
			
			{
				return File.Open (path, mode, ((System.IO.FileAccess) access));
			}
			
			public static FileStream Open (string path, FileMode mode, FileAccessEx access, FileShare share)
			
			{
				return File.Open (path, mode, ((System.IO.FileAccess) access), ((System.IO.FileShare) share));
			}
			
			public static FileStream Open (string path, FileMode mode)
			
			{
				return File.Open (path, mode);
			}
			
			public static FileStream OpenRead (string path)
			
			{
				return File.OpenRead (path);
			}
			
			public static StreamReader OpenText (string path)
			
			{
				return File.OpenText (path);
			}
			
			public static FileStream OpenWrite (string path)
			
			{
				return File.OpenWrite (path);
			}
			
			public static void ReadFile (IntPtr hFile, byte[] lpBuffer, int nNumberOfBytesToRead, ref int lpNumberOfBytesRead)
			
			{
				Core.CheckHandle (hFile);
				if (! Convert.ToBoolean (FileEx.ReadFileCE (hFile, lpBuffer, nNumberOfBytesToRead, ref lpNumberOfBytesRead, IntPtr.Zero)))
				{
					throw new WinAPIException ("Write Failed");
				}
			}
			
			[DllImportAttribute("coredll.dll", EntryPoint = "ReadFile", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			internal static extern int ReadFileCE (IntPtr hFile, byte[] lpBuffer, int nNumberOfBytesToRead, ref int lpNumberOfBytesRead, IntPtr lpOverlapped);
			public static void SetAttributes (string path, FileAttributes fileAttributes)
			
			{
				if (path.Length > 260)
				{
					throw new PathTooLongException ();
				}
				if (path.Trim ().Length == 0)
				{
					throw new ArgumentException ();
				}
				if (FileEx.SetFileAttributes (path, ((uint) fileAttributes)))
				{
					return;
				}
				int i1 = Marshal.GetLastWin32Error ();
				if ((i1 == 2) || (i1 == 3))
				{
					throw new FileNotFoundException ();
				}
				else
				{
					throw new Exception (("Unmanaged Error: " + i1.ToString ()));
				}
			}
			
			public static void SetCreationTime (string path, DateTime creationTime)
			
			{
				int i1;
				if (path == null)
				{
					throw new ArgumentNullException ();
				}
				if (path.Length > 260)
				{
					throw new PathTooLongException ();
				}
				if (path.Trim ().Length == 0)
				{
					throw new ArgumentException ();
				}
				IntPtr intPtr1 = FileEx.CreateFile (path, FileAccess.Write, FileShare.Write, FileCreateDisposition.OpenExisting, 0);
				if (((int) intPtr1) == -1)
				{
					i1 = Marshal.GetLastWin32Error ();
					if ((i1 == 2) || (i1 == 3))
					{
						throw new FileNotFoundException ();
					}
					else
					{
						throw new Exception (("Unmanaged Error: " + i1.ToString ()));
					}
				}
				FILETIME fILETIME1 = new FILETIME (creationTime.ToFileTime ());
				bool b1 = FileEx.SetFileTime (intPtr1, ((byte[]) fILETIME1), ((byte[]) null), ((byte[]) null));
				FileEx.CloseHandle (intPtr1);
			}
			
			public static void SetCreationTimeUtc (string path, DateTime creationTimeUtc)
			
			{
				FileEx.SetCreationTime (path, creationTimeUtc.ToLocalTime ());
			}
			
			[DllImportAttribute("coredll", EntryPoint = "SetFileAttributes", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			internal static extern bool SetFileAttributes (string lpFileName, uint dwFileAttributes);
			[DllImportAttribute("coredll.dll", EntryPoint = "SetFilePointer", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			internal static extern int SetFilePointerCE (IntPtr hFile, int lDistanceToMove, int lpDistanceToMoveHigh, MoveMethod dwMoveMethod);
			[DllImportAttribute("coredll", EntryPoint = "SetFileTime", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			internal static extern bool SetFileTime (IntPtr hFile, byte[] lpCreationTime, byte[] lpLastAccessTime, byte[] lpLastWriteTime);
			public static void SetLastAccessTime (string path, DateTime lastAccessTime)
			
			{
				int i1;
				if (path == null)
				{
					throw new ArgumentNullException ();
				}
				if (path.Length > 260)
				{
					throw new PathTooLongException ();
				}
				if (path.Trim ().Length == 0)
				{
					throw new ArgumentException ();
				}
				IntPtr intPtr1 = FileEx.CreateFile (path, FileAccess.Write, FileShare.Write, FileCreateDisposition.OpenExisting, 0);
				if (((int) intPtr1) == -1)
				{
					i1 = Marshal.GetLastWin32Error ();
					if ((i1 == 2) || (i1 == 3))
					{
						throw new FileNotFoundException ();
					}
					else
					{
						throw new Exception (("Unmanaged Error: " + i1.ToString ()));
					}
				}
				FILETIME fILETIME1 = new FILETIME (lastAccessTime.ToFileTime ());
				bool b1 = FileEx.SetFileTime (intPtr1, ((byte[]) null), ((byte[]) fILETIME1), ((byte[]) null));
				FileEx.CloseHandle (intPtr1);
			}
			
			public static void SetLastAccessTimeUtc (string path, DateTime lastAccessTimeUtc)
			
			{
				FileEx.SetLastAccessTime (path, lastAccessTimeUtc.ToLocalTime ());
			}
			
			public static void SetLastWriteTime (string path, DateTime lastWriteTime)
			
			{
				int i1;
				if (path == null)
				{
					throw new ArgumentNullException ();
				}
				if (path.Length > 260)
				{
					throw new PathTooLongException ();
				}
				if (path.Trim ().Length == 0)
				{
					throw new ArgumentException ();
				}
				IntPtr intPtr1 = FileEx.CreateFile (path, FileAccess.Write, FileShare.Write, FileCreateDisposition.OpenExisting, 0);
				if (((int) intPtr1) == -1)
				{
					i1 = Marshal.GetLastWin32Error ();
					if ((i1 == 2) || (i1 == 3))
					{
						throw new FileNotFoundException ();
					}
					else
					{
						throw new Exception (("Unmanaged Error: " + i1.ToString ()));
					}
				}
				FILETIME fILETIME1 = new FILETIME (lastWriteTime.ToFileTime ());
				bool b1 = FileEx.SetFileTime (intPtr1, ((byte[]) null), ((byte[]) fILETIME1), ((byte[]) null));
				FileEx.CloseHandle (intPtr1);
			}
			
			public static void SetLastWriteTimeUtc (string path, DateTime lastWriteTimeUtc)
			
			{
				FileEx.SetLastWriteTime (path, lastWriteTimeUtc.ToLocalTime ());
			}
			
			public static void WriteFile (IntPtr hFile, byte[] lpBuffer, int nNumberOfBytesToWrite, ref int lpNumberOfBytesWritten)
			
			{
				Core.CheckHandle (hFile);
				if (! Convert.ToBoolean (FileEx.WriteFileCE (hFile, lpBuffer, nNumberOfBytesToWrite, ref lpNumberOfBytesWritten, IntPtr.Zero)))
				{
					throw new WinAPIException ("Write Failed");
				}
			}
			
			[DllImportAttribute("coredll.dll", EntryPoint = "WriteFile", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			internal static extern int WriteFileCE (IntPtr hFile, byte[] lpBuffer, int nNumberOfBytesToWrite, ref int lpNumberOfBytesWritten, IntPtr lpOverlapped);
		#endregion
	}
	
}

