//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:30:26
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace OpenNETCF.Win32

{
		
		#region Namespace Import Declarations
		
			using System;
			using System.Runtime.InteropServices;
			
		#endregion
		
	public class WinAPIException : Exception
	
	{
		
		#region Fields
			private int win32Error;
		#endregion
		
		#region Constructors
		
			public WinAPIException (string Message)
				 : base ((Message + " " + WinAPIException.GetErrorMessage (Marshal.GetLastWin32Error ())))
			
			{
				this.win32Error = Marshal.GetLastWin32Error ();
			}
			
			
			public WinAPIException (Exception ex)
				 : base (ex.Message)
			
			{
				this.win32Error = 0;
			}
			
			
			public WinAPIException (string Message, int ErrorCode)
				 : base ((Message + " " + WinAPIException.GetErrorMessage (ErrorCode)))
			
			{
				this.win32Error = ErrorCode;
			}
			
		#endregion
		
		#region Properties
		
			public int Win32Error
			
			{
				get
				{
					return this.win32Error;
				}
			}
			
		#endregion
		
		#region Methods
		
			internal static string GetErrorMessage (int ErrNo)
			
			{
				IntPtr intPtr1;
				int i1 = Core.FormatMessage ((Core.FormatMessageFlags.AllocateBuffer | Core.FormatMessageFlags.FromSystem), 0, ErrNo, 0, out intPtr1, 0, ((int[]) null));
				if (i1 == 0)
				{
					return string.Format ("Error {0} (0x{0:X})", ErrNo);
				}
				string string1 = Marshal.PtrToStringUni (intPtr1, i1);
				IntPtr intPtr2 = Core.LocalFreeCE (intPtr1);
				return string1;
			}
			
		#endregion
	}
	
}

