//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:22:16
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LECHardwareAbstraction.Utilities

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.General;
			using LanmarkControls.CommonLib.Protocol;
			using LanmarkControls.LECHardwareAbstraction.FPGAInterface;
			using LanmarkControls.LECHardwareAbstraction;
			using System;
			
		#endregion
		
	public class StatusInfo
	
	{
		
		#region Constructors
		
			public StatusInfo ()
			
			{
			}
			
		#endregion
		
		#region Properties
		
			public short ActXPosition
			
			{
				get
				{
					int i1;
					Exception exception1;
					try
					{
						i1 = LECHAL.Instance.fpgaInterface.GetRegister (MecFPGARegister.MecReg_CURRENTDACX);
						return ((short) (i1 & 65535));
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						Logging.Instance.Log (0, string.Format (("StatusInfo.ActXPosition Property - Exception error 0x03d " + exception1.Message), new object[0]));
						Logging.Instance.Log (0, exception1.ToString ());
					}
					return 0;
				}
			}
			
			
			public short ActYPosition
			
			{
				get
				{
					int i1;
					Exception exception1;
					try
					{
						i1 = LECHAL.Instance.fpgaInterface.GetRegister (MecFPGARegister.MecReg_CURRENTDACY);
						return ((short) (i1 & 65535));
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						Logging.Instance.Log (0, string.Format (("StatusInfo.ActYPosition Property - Exception error 0x03d " + exception1.Message), new object[0]));
						Logging.Instance.Log (0, exception1.ToString ());
					}
					return 0;
				}
			}
			
			
			public float ControllerTemperature
			
			{
				get
				{
					float single1;
					PLI pLI1;
					Exception exception1;
					float single2;
					try
					{
						single1 = 0F;
						pLI1 = new PLI ();
						if (! pLI1.Connect ())
						{
							Logging.Instance.Log (string.Format ("StatusInfo.ControllerTemperature Property - Error connecting to PLI driver", new object[0]));
						}
						else if (! pLI1.getTemperature (ref single1))
						{
							Logging.Instance.Log (string.Format ("StatusInfo.ControllerTemperature Property - Error reading temperature", new object[0]));
						}
						bool b1 = pLI1.Disconnect ();
						single2 = single1;
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						Logging.Instance.Log (0, string.Format (("StatusInfo.ControllerTemperature Property - Exception error 0x03d " + exception1.Message), new object[0]));
						Logging.Instance.Log (0, exception1.ToString ());
						single2 = 0F;
					}
					return single2;
				}
			}
			
			
			public uint CurrentDIO
			
			{
				get
				{
					Exception exception1;
					try
					{
						return ((uint) LECHAL.Instance.fpgaInterface.GetRegister (MecFPGARegister.MecReg_CURRENTDIO));
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						Logging.Instance.Log (0, string.Format (("StatusInfo.UserIn Property - Exception error 0x03d " + exception1.Message), new object[0]));
						Logging.Instance.Log (0, exception1.ToString ());
					}
					return uint.MinValue;
				}
			}
			
			
			public byte[] Data
			
			{
				get
				{
					StatInfoData statInfoData1;
					Exception exception1;
					try
					{
						statInfoData1 = new StatInfoData ();
						statInfoData1.ControllerTemperatureStatus = Convert.ToInt16 (this.ControllerTemperature);
						statInfoData1.XActualPosition = this.ActXPosition;
						statInfoData1.YActualPosition = this.ActYPosition;
						statInfoData1.XPosition = this.XPosition;
						statInfoData1.YPosition = this.YPosition;
						statInfoData1.JobMarker = this.JobMarker;
						statInfoData1.JobDataCounter = this.JobDataCounter;
						statInfoData1.Interlock = this.Interlock;
						statInfoData1.CurrentDIO = this.CurrentDIO;
						return statInfoData1.ToBytes ();
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						Logging.Instance.Log (0, string.Format (("StatusInfo.Data Property - Exception error 0x03d " + exception1.Message), new object[0]));
						Logging.Instance.Log (0, exception1.ToString ());
					}
					return null;
				}
			}
			
			
			public UInt16 Interlock
			
			{
				get
				{
					int i1;
					Exception exception1;
					try
					{
						i1 = LECHAL.Instance.fpgaInterface.GetRegister (MecFPGARegister.MecReg_STATUS);
						return ((UInt16) ((i1 & 7680) >> 9));
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						Logging.Instance.Log (0, string.Format (("StatusInfo.Interlock Property - Exception error 0x03d " + exception1.Message), new object[0]));
						Logging.Instance.Log (0, exception1.ToString ());
					}
					return ushort.MinValue;
				}
			}
			
			
			public int JobDataCounter
			
			{
				get
				{
					Exception exception1;
					try
					{
						return LECHAL.Instance.fpgaInterface.GetRegister (MecFPGARegister.MecReg_CURRENTCMDCOUNT);
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						Logging.Instance.Log (0, string.Format (("StatusInfo.JobDataCounter Property - Exception error 0x03d " + exception1.Message), new object[0]));
						Logging.Instance.Log (0, exception1.ToString ());
					}
					return 0;
				}
			}
			
			
			public UInt16 JobMarker
			
			{
				get
				{
					int i1;
					Exception exception1;
					try
					{
						i1 = LECHAL.Instance.fpgaInterface.GetRegister (MecFPGARegister.MecReg_STATUS);
						return ((UInt16) (i1 >> 16));
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						Logging.Instance.Log (0, string.Format (("StatusInfo.JobMarker Property - Exception error 0x03d " + exception1.Message), new object[0]));
						Logging.Instance.Log (0, exception1.ToString ());
					}
					return ushort.MinValue;
				}
			}
			
			
			public uint Opcode
			
			{
				get
				{
					return 7;
				}
			}
			
			
			public short XPosition
			
			{
				get
				{
					Exception exception1;
					try
					{
						return ((short) LECHAL.Instance.fpgaInterface.GetRegister (MecFPGARegister.MecReg_CURRENTVECTX));
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						Logging.Instance.Log (0, string.Format (("StatusInfo.XPosition Property - Exception error 0x03d " + exception1.Message), new object[0]));
						Logging.Instance.Log (0, exception1.ToString ());
					}
					return 0;
				}
			}
			
			
			public short YPosition
			
			{
				get
				{
					Exception exception1;
					try
					{
						return ((short) LECHAL.Instance.fpgaInterface.GetRegister (MecFPGARegister.MecReg_CURRENTVECTY));
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						Logging.Instance.Log (0, string.Format (("StatusInfo.YPosition Property - Exception error 0x03d " + exception1.Message), new object[0]));
						Logging.Instance.Log (0, exception1.ToString ());
					}
					return 0;
				}
			}
			
		#endregion
	}
	
}

