//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:26:05
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LocalManager.Hosts

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.General;
			using LanmarkControls.LocalManager;
			using System;
			using System.IO;
			using System.Net;
			using System.Net.Sockets;
			using System.Threading;
			using Logging = LanmarkControls.CommonLib.General.Logging;
			
		#endregion
		
	public class LANHost : IHostControl
	
	{
		
		#region Fields
			private string connectedClientAddress;
			private HostTypes hostInControl;
			private HostTypes hostType;
			private Socket newSock;
			public virtual event InputCommandHandler OnInputCommand;
			public virtual event UpdateClientInfoHandler OnUpdateClientInfo;
			private Thread socketLoopThread;
			private bool terminated;
		#endregion
		
		#region Constructors
		
			public LANHost ()
			
			{
				this.hostType = HostTypes.LAN;
				this.newSock = ((Socket) null);
				this.socketLoopThread = ((Thread) null);
				this.connectedClientAddress = "0.0.0.0";
				this.terminated = false;
			}
			
		#endregion
		
		#region Properties
		
			public virtual HostTypes HostInControl
			
			{
				get
				{
					return this.hostInControl;
				}
				set
				{
					this.hostInControl = value;
				}
			}
			
			
			private bool Terminated
			
			{
				get
				{
					return this.terminated;
				}
				set
				{
					this.terminated = value;
				}
			}
			
			
			public virtual HostTypes ThisHostType
			
			{
				get
				{
					return this.hostType;
				}
			}
			
		#endregion
		
		#region Methods
		
			public virtual void AssumeControl ()
			
			{
				if (this.OnUpdateClientInfo != null)
				{
					this.OnUpdateClientInfo (ClientConnectionStatus.Local, "Ethernet Host", this.connectedClientAddress, 0);
				}
			}
			
			public virtual void Disconnect ()
			
			{
				this.connectedClientAddress = "0.0.0.0";
				this.newSock.Close ();
			}
			
			public virtual bool Initialize ()
			
			{
				this.newSock = new Socket (AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
				return true;
			}
			
			public string OnTCPInputCommand (string dataBuffer)
			
			{
				if (this.OnInputCommand == null)
				{
					return APIResponses.ERROR_SOFTWARE.ToString ();
				}
				char[] charArray1 = new char[] { '\u002C' };
				string[] stringArray1 = this.OnInputCommand (this.ThisHostType, dataBuffer.Split (charArray1));
				if (stringArray1 != null)
				{
					return string.Join (",", stringArray1);
				}
				else
				{
					return APIResponses.ERROR_SOFTWARE.ToString ();
				}
			}
			
			public virtual void ReleaseControl ()
			
			{
			}
			
			public void SocketLoop ()
			
			{
				Socket socket1;
				IPEndPoint iPEndPoint2;
				NetworkStream networkStream1;
				StreamReader streamReader1;
				StreamWriter streamWriter1;
				IOException iOException1;
				char[] charArray1;
				IPEndPoint iPEndPoint1 = new IPEndPoint (IPAddress.Any, 12500);
				this.newSock.Bind (((EndPoint) iPEndPoint1));
				this.newSock.Listen (10);
				string string1 = "";
				string string2 = "";
				while (! this.Terminated)
				{
					socket1 = this.newSock.Accept ();
					iPEndPoint2 = ((IPEndPoint) socket1.RemoteEndPoint);
					this.connectedClientAddress = iPEndPoint2.Address.ToString ();
					networkStream1 = new NetworkStream (socket1);
					streamReader1 = new StreamReader (((Stream) networkStream1));
					streamWriter1 = new StreamWriter (((Stream) networkStream1));
					try
					{
						streamWriter1.WriteLine ("Cambridge Technology Inc. - Remote Command API v1.1");
						streamWriter1.Flush ();
						while (! this.Terminated)
						{
							string1 = streamReader1.ReadLine ();
							if (string1 != null)
							{
								if ((string1 == APICommands.HardwareReset.ToString ()) && (this.HostInControl == this.ThisHostType))
								{
									streamWriter1.WriteLine (APIResponses.ACK.ToString ());
									streamWriter1.Flush ();
								}
								string2 = this.OnTCPInputCommand (string1);
								streamWriter1.WriteLine (string2);
								streamWriter1.Flush ();
								continue;
							}
							if (this.HostInControl == this.ThisHostType)
							{
								charArray1 = new char[] { '\u002C' };
								string[] stringArray1 = this.OnInputCommand (this.ThisHostType, APICommands.Abort.ToString ().Split (charArray1));
								Thread.Sleep (250);
								charArray1 = new char[] { '\u002C' };
								string[] stringArray2 = this.OnInputCommand (this.ThisHostType, APICommands.ReleaseHostControl.ToString ().Split (charArray1));
							}
							break;
						}
					}
					catch (IOException iOException2)
					{
						iOException1 = iOException2;
						Logging.Instance.Log (0, "Exception thrown while waiting on a ReadLine in LANHost.");
						Logging.Instance.Log (0, iOException1.ToString ());
						if (this.HostInControl == this.ThisHostType)
						{
							charArray1 = new char[] { '\u002C' };
							string[] stringArray3 = this.OnInputCommand (this.ThisHostType, APICommands.Abort.ToString ().Split (charArray1));
							Thread.Sleep (250);
							charArray1 = new char[] { '\u002C' };
							string[] stringArray4 = this.OnInputCommand (this.ThisHostType, APICommands.ReleaseHostControl.ToString ().Split (charArray1));
						}
					}
					streamWriter1.Close ();
					streamReader1.Close ();
					networkStream1.Close ();
					socket1.Close ();
				}
			}
			
			public virtual void StartHostAPI ()
			
			{
				this.socketLoopThread = new Thread (new ThreadStart (this.SocketLoop));
				this.socketLoopThread.Priority = ThreadPriority.Normal;
				this.socketLoopThread.Start ();
			}
			
		#endregion
	}
	
}

