//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:26:05
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LocalManager.Hosts

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.LECEngine;
			using LanmarkControls.LECHardwareAbstraction.Utilities;
			using LanmarkControls.LocalManager;
			using LanmarkControls.LocalManager.Pendants;
			using System;
			using System.Collections;
			using System.IO;
			using System.Threading;
			
		#endregion
		
	public class PendantHost : IHostControl
	
	{
		
		#region Fields
			private PendantMenu challengeAdminPasswordMenu;
			private PendantMenu challengeUserPasswordMenu;
			private PendantMenu changePasswordMenu;
			private PendantMenu chooseFileSourceMenu;
			private PendantMenu confirmPasswordMenu;
			private bool flashPath;
			private PendantMenu hardwareRestartMenu;
			private HostTypes hostInControl;
			private HostTypes hostType;
			private int m_iCurrentFile;
			private PendantMenu m_JobModeMenu;
			private Queue m_lstDataObject;
			private string[] m_lstJobFiles;
			private ArrayList m_lstMenus;
			private PendantMenu m_oAdvancedMenu;
			private PendantMenu m_oAskContinuousJobMenu;
			private PendantMenu m_oAskOnceJobMenu;
			private IPendantInputData m_oDataObject;
			private PendantMenu m_oDeviceSettingMenu;
			private PendantMenu m_oGlobalsMenu;
			private PendantMenu m_oHomeMenu;
			private PendantMenu m_oInputAcceptMenu;
			private PendantMenu m_oInputDisplayMenu;
			private PendantMenu m_oInputEditMenu;
			private PendantMenu m_oIP1Wiz;
			private PendantMenu m_oIPMenu;
			private PendantMenu m_oLocalPromptMenu;
			private PendantMenu m_oMainLocalMenu;
			private PendantMenu m_oMainRemoteMenu;
			private PendantMenu m_oOffsetSettingMenu;
			private PendantMenu m_oRunningContinuousMenu;
			private PendantMenu m_oRunningOnceMenu;
			private PendantMenu m_oSelectJobMenu;
			private PendantMenu m_oUserAccessMenu;
			private string m_strEditValue;
			private string m_strSelectedJobFile;
			private string newPassword;
			public virtual event InputCommandHandler OnInputCommand;
			public virtual event UpdateClientInfoHandler OnUpdateClientInfo;
			private IPendant Pendant;
			private bool pleaseWait;
			private bool restartRequired;
			private bool runOnce;
			private PendantMenu userInfoMenu;
		#endregion
		
		#region Constructors
		
			public PendantHost (string pendantHost)
			
			{
				string string1;
				this.hostType = HostTypes.Pendant;
				this.Pendant = ((IPendant) null);
				this.restartRequired = false;
				this.pleaseWait = false;
				this.m_lstMenus = new ArrayList ();
				this.m_oHomeMenu = ((PendantMenu) null);
				this.m_oMainRemoteMenu = ((PendantMenu) null);
				this.m_oMainLocalMenu = ((PendantMenu) null);
				this.m_oLocalPromptMenu = ((PendantMenu) null);
				this.m_lstJobFiles = ((string[]) null);
				this.m_strSelectedJobFile = "";
				this.m_iCurrentFile = 0;
				this.m_oSelectJobMenu = ((PendantMenu) null);
				this.flashPath = true;
				this.chooseFileSourceMenu = ((PendantMenu) null);
				this.m_JobModeMenu = ((PendantMenu) null);
				this.m_oAskContinuousJobMenu = ((PendantMenu) null);
				this.runOnce = false;
				this.m_oAskOnceJobMenu = ((PendantMenu) null);
				this.m_oRunningContinuousMenu = ((PendantMenu) null);
				this.m_oRunningOnceMenu = ((PendantMenu) null);
				this.m_oAdvancedMenu = ((PendantMenu) null);
				this.m_oDeviceSettingMenu = ((PendantMenu) null);
				this.m_oUserAccessMenu = ((PendantMenu) null);
				this.newPassword = "";
				this.changePasswordMenu = ((PendantMenu) null);
				this.confirmPasswordMenu = ((PendantMenu) null);
				this.challengeUserPasswordMenu = ((PendantMenu) null);
				this.challengeAdminPasswordMenu = ((PendantMenu) null);
				this.m_oIPMenu = ((PendantMenu) null);
				this.m_oIP1Wiz = ((PendantMenu) null);
				this.m_oDataObject = ((IPendantInputData) null);
				this.m_lstDataObject = new Queue ();
				this.m_strEditValue = "";
				this.m_oInputDisplayMenu = ((PendantMenu) null);
				this.m_oInputEditMenu = ((PendantMenu) null);
				this.m_oInputAcceptMenu = ((PendantMenu) null);
				this.m_oGlobalsMenu = ((PendantMenu) null);
				this.m_oOffsetSettingMenu = ((PendantMenu) null);
				this.hardwareRestartMenu = ((PendantMenu) null);
				this.userInfoMenu = ((PendantMenu) null);
				if ((string1 = pendantHost) != null)
				{
					string1 = string.IsInterned (string1);
					if (string1 == "QTERMJ10")
					{
						this.Pendant = ((IPendant) new QTERMJ10Pendant ());
						goto L_016C;
					}
				}
				this.Pendant = ((IPendant) new QTERMJ10Pendant ());
				
			L_016C:
				
				{
				}
				this.Pendant.OnInputValue += new InputValueHandler (this.OnInputValue);
				this.Pendant.OnInputIdle += new InputIdleHandler (this.OnInputIdle);
			}
			
		#endregion
		
		#region Properties
		
			private PendantMenu AdvancedMenu
			
			{
				get
				{
					if (this.m_oAdvancedMenu != null)
					{
						return this.m_oAdvancedMenu;
					}
					string[] stringArray2 = new string[] { "SelectAdv1", "SelectAdv2", "SelectAdv3", "SelectGoBack" };
					string[] stringArray1 = stringArray2;
					this.m_oAdvancedMenu = new PendantMenu (((string[]) null), stringArray1, this.Pendant);
					this.m_oAdvancedMenu.Action += new MenuCallback (this.AdvancedMenuAction);
					return this.m_oAdvancedMenu;
				}
			}
			
			
			private PendantMenu AskContinuousJobMenu
			
			{
				get
				{
					if (this.m_oAskContinuousJobMenu != null)
					{
						return this.m_oAskContinuousJobMenu;
					}
					string[] stringArray3 = new string[] { "AskLocalInstr", "AskStartTitle" };
					string[] stringArray1 = stringArray3;
					stringArray3 = new string[] { "SelectYes", "SelectNo" };
					string[] stringArray2 = stringArray3;
					this.m_oAskContinuousJobMenu = new PendantMenu (stringArray1, stringArray2, this.Pendant);
					this.m_oAskContinuousJobMenu.Action += new MenuCallback (this.AskContinuousJobMenuAction);
					this.m_oAskContinuousJobMenu.BeforeDisplay += new BeforeDisplayCallback (this.AskContinuousJobMenuBeforeDisplay);
					return this.m_oAskContinuousJobMenu;
				}
			}
			
			
			private PendantMenu AskOnceJobMenu
			
			{
				get
				{
					if (this.m_oAskOnceJobMenu != null)
					{
						return this.m_oAskOnceJobMenu;
					}
					string[] stringArray3 = new string[] { "AskLocalInstr", "AskStartTitle" };
					string[] stringArray1 = stringArray3;
					stringArray3 = new string[] { "SelectYes", "SelectNo" };
					string[] stringArray2 = stringArray3;
					this.m_oAskOnceJobMenu = new PendantMenu (stringArray1, stringArray2, this.Pendant);
					this.m_oAskOnceJobMenu.Action += new MenuCallback (this.AskOnceJobMenuAction);
					this.m_oAskOnceJobMenu.BeforeDisplay += new BeforeDisplayCallback (this.AskOnceJobMenuBeforeDisplay);
					return this.m_oAskOnceJobMenu;
				}
			}
			
			
			private PendantMenu ChallengeAdminPasswordMenu
			
			{
				get
				{
					if (this.challengeAdminPasswordMenu != null)
					{
						return this.challengeAdminPasswordMenu;
					}
					string[] stringArray2 = new string[] { "", "", "CancelInstrTitle", "EditInstrTitle" };
					string[] stringArray1 = stringArray2;
					this.challengeAdminPasswordMenu = new PendantMenu (stringArray1, ((string[]) null), this.Pendant);
					this.challengeAdminPasswordMenu.Action += new MenuCallback (this.ChallengeAdminPasswordMenuAction);
					this.challengeAdminPasswordMenu.BeforeDisplay += new BeforeDisplayCallback (this.ChallengeAdminPasswordMenuBeforeDisplay);
					this.challengeAdminPasswordMenu.ShowCursor = true;
					return this.challengeAdminPasswordMenu;
				}
			}
			
			
			private PendantMenu ChallengeUserPasswordMenu
			
			{
				get
				{
					if (this.challengeUserPasswordMenu != null)
					{
						return this.challengeUserPasswordMenu;
					}
					string[] stringArray2 = new string[] { "", "", "CancelInstrTitle", "EditInstrTitle" };
					string[] stringArray1 = stringArray2;
					this.challengeUserPasswordMenu = new PendantMenu (stringArray1, ((string[]) null), this.Pendant);
					this.challengeUserPasswordMenu.Action += new MenuCallback (this.ChallengeUserPasswordMenuAction);
					this.challengeUserPasswordMenu.BeforeDisplay += new BeforeDisplayCallback (this.ChallengeUserPasswordMenuBeforeDisplay);
					this.challengeUserPasswordMenu.ShowCursor = true;
					return this.challengeUserPasswordMenu;
				}
			}
			
			
			private PendantMenu ChangePasswordMenu
			
			{
				get
				{
					if (this.changePasswordMenu != null)
					{
						return this.changePasswordMenu;
					}
					string[] stringArray2 = new string[] { "", "ChangePasswordTitle", "CancelInstrTitle", "EditInstrTitle" };
					string[] stringArray1 = stringArray2;
					this.changePasswordMenu = new PendantMenu (stringArray1, ((string[]) null), this.Pendant);
					this.changePasswordMenu.Action += new MenuCallback (this.ChangePasswordMenuAction);
					this.changePasswordMenu.BeforeDisplay += new BeforeDisplayCallback (this.ChangePasswordMenuBeforeDisplay);
					this.changePasswordMenu.ShowCursor = true;
					return this.changePasswordMenu;
				}
			}
			
			
			private PendantMenu ChooseFileSourceMenu
			
			{
				get
				{
					if (this.chooseFileSourceMenu != null)
					{
						return this.chooseFileSourceMenu;
					}
					string[] stringArray3 = new string[] { "SelectFileSouce" };
					string[] stringArray1 = stringArray3;
					stringArray3 = new string[] { "SelectFlash", "SelectUSB", "SelectGoBack" };
					string[] stringArray2 = stringArray3;
					this.chooseFileSourceMenu = new PendantMenu (stringArray1, stringArray2, this.Pendant);
					this.chooseFileSourceMenu.Action += new MenuCallback (this.ChooseFileSourceMenuAction);
					return this.chooseFileSourceMenu;
				}
			}
			
			
			private PendantMenu ConfirmPasswordMenu
			
			{
				get
				{
					if (this.confirmPasswordMenu != null)
					{
						return this.confirmPasswordMenu;
					}
					string[] stringArray2 = new string[] { "", "ConfirmPasswordTitle", "CancelInstrTitle", "EditInstrTitle" };
					string[] stringArray1 = stringArray2;
					this.confirmPasswordMenu = new PendantMenu (stringArray1, ((string[]) null), this.Pendant);
					this.confirmPasswordMenu.Action += new MenuCallback (this.ConfirmPasswordMenuAction);
					this.confirmPasswordMenu.BeforeDisplay += new BeforeDisplayCallback (this.ConfirmPasswordMenuBeforeDisplay);
					this.confirmPasswordMenu.ShowCursor = true;
					this.m_strEditValue = "";
					return this.confirmPasswordMenu;
				}
			}
			
			
			private string CurrentConnection
			
			{
				get
				{
					if (this.OnInputCommand == null)
					{
						return "0.0.0.0";
					}
					string[] stringArray3 = new string[] { APICommands.GetRemoteIP.ToString () };
					string[] stringArray1 = stringArray3;
					string[] stringArray2 = this.OnInputCommand (this.ThisHostType, stringArray1);
					if (stringArray2 == null)
					{
						return "0.0.0.0";
					}
					else
					{
						return stringArray2[0];
					}
				}
			}
			
			
			private string CurrentJobState
			
			{
				get
				{
					string string1 = JobOpStatus.Idle.ToString ();
					if (this.OnInputCommand == null)
					{
						return string1;
					}
					string[] stringArray3 = new string[] { APICommands.GetJobStatus.ToString () };
					string[] stringArray1 = stringArray3;
					string[] stringArray2 = this.OnInputCommand (this.ThisHostType, stringArray1);
					if (stringArray2 == null)
					{
						return string1;
					}
					else
					{
						return stringArray2[0];
					}
				}
			}
			
			
			private PendantMenu DeviceSettingMenu
			
			{
				get
				{
					if (this.m_oDeviceSettingMenu != null)
					{
						return this.m_oDeviceSettingMenu;
					}
					string[] stringArray3 = new string[] { "DeviceSettingsTitle" };
					string[] stringArray1 = stringArray3;
					stringArray3 = new string[] { "SelectDev1", "SelectDev2", "SelectGoBack" };
					string[] stringArray2 = stringArray3;
					this.m_oDeviceSettingMenu = new PendantMenu (stringArray1, stringArray2, this.Pendant);
					this.m_oDeviceSettingMenu.Action += new MenuCallback (this.DeviceSettingMenuAction);
					return this.m_oDeviceSettingMenu;
				}
			}
			
			
			private PendantMenu GlobalsMenu
			
			{
				get
				{
					if (this.m_oGlobalsMenu != null)
					{
						return this.m_oGlobalsMenu;
					}
					string[] stringArray2 = new string[] { "SelectGbl1", "SelectGbl2", "SelectGbl3", "SelectGoBack" };
					string[] stringArray1 = stringArray2;
					this.m_oGlobalsMenu = new PendantMenu (((string[]) null), stringArray1, this.Pendant);
					this.m_oGlobalsMenu.Action += new MenuCallback (this.GlobalsMenuAction);
					return this.m_oGlobalsMenu;
				}
			}
			
			
			private PendantMenu HardwareRestartMenu
			
			{
				get
				{
					if (this.hardwareRestartMenu != null)
					{
						return this.hardwareRestartMenu;
					}
					string[] stringArray3 = new string[] { "HardwareRestartTitle1", "HardwareRestartTitle2" };
					string[] stringArray1 = stringArray3;
					stringArray3 = new string[] { "SelectReset", "SelectSkip" };
					string[] stringArray2 = stringArray3;
					this.hardwareRestartMenu = new PendantMenu (stringArray1, stringArray2, this.Pendant);
					this.hardwareRestartMenu.Action += new MenuCallback (this.HardwareRestartMenuAction);
					return this.hardwareRestartMenu;
				}
			}
			
			
			private PendantMenu HomeMenu
			
			{
				get
				{
					if (this.m_oHomeMenu != null)
					{
						return this.m_oHomeMenu;
					}
					string[] stringArray2 = new string[] { "Home2Title", "", "", "Home4Title" };
					string[] stringArray1 = stringArray2;
					this.m_oHomeMenu = new PendantMenu (stringArray1, ((string[]) null), this.Pendant);
					this.m_oHomeMenu.Action += new MenuCallback (this.HomeMenuAction);
					this.m_oHomeMenu.BeforeDisplay += new BeforeDisplayCallback (this.HomeMenuBeforeDisplay);
					return this.m_oHomeMenu;
				}
			}
			
			
			public virtual HostTypes HostInControl
			
			{
				get
				{
					return this.hostInControl;
				}
				set
				{
					this.hostInControl = value;
				}
			}
			
			
			private PendantMenu InputAcceptMenu
			
			{
				get
				{
					if (this.m_oInputAcceptMenu != null)
					{
						return this.m_oInputAcceptMenu;
					}
					string[] stringArray3 = new string[] { "DisplayInstruct", "AskAcceptTitle" };
					string[] stringArray1 = stringArray3;
					stringArray3 = new string[] { "SelectYes", "SelectNo" };
					string[] stringArray2 = stringArray3;
					this.m_oInputAcceptMenu = new PendantMenu (stringArray1, stringArray2, this.Pendant);
					this.m_oInputAcceptMenu.Action += new MenuCallback (this.InputAcceptMenuAction);
					this.m_oInputAcceptMenu.BeforeDisplay += new BeforeDisplayCallback (this.InputAcceptMenuBeforeDisplay);
					return this.m_oInputAcceptMenu;
				}
			}
			
			
			private PendantMenu InputDisplayMenu
			
			{
				get
				{
					if (this.m_oInputDisplayMenu != null)
					{
						return this.m_oInputDisplayMenu;
					}
					string[] stringArray3 = new string[] { "", "StringEditTitle" };
					string[] stringArray1 = stringArray3;
					stringArray3 = new string[] { "SelectEdit", "SelectDone" };
					string[] stringArray2 = stringArray3;
					this.m_oInputDisplayMenu = new PendantMenu (stringArray1, stringArray2, this.Pendant);
					this.m_oInputDisplayMenu.Action += new MenuCallback (this.InputDisplayMenuAction);
					this.m_oInputDisplayMenu.BeforeDisplay += new BeforeDisplayCallback (this.InputDisplayMenuBeforeDisplay);
					return this.m_oInputDisplayMenu;
				}
			}
			
			
			private PendantMenu InputEditMenu
			
			{
				get
				{
					if (this.m_oInputEditMenu != null)
					{
						return this.m_oInputEditMenu;
					}
					string[] stringArray2 = new string[] { "", "", "", "EditInstrTitle" };
					string[] stringArray1 = stringArray2;
					this.m_oInputEditMenu = new PendantMenu (stringArray1, ((string[]) null), this.Pendant);
					this.m_oInputEditMenu.Action += new MenuCallback (this.InputEditMenuAction);
					this.m_oInputEditMenu.BeforeDisplay += new BeforeDisplayCallback (this.InputEditMenuBeforeDisplay);
					this.m_oInputEditMenu.ShowCursor = true;
					return this.m_oInputEditMenu;
				}
			}
			
			
			private PendantMenu IP1Wiz
			
			{
				get
				{
					if (this.m_oIP1Wiz != null)
					{
						return this.m_oIP1Wiz;
					}
					string[] stringArray3 = new string[] { "DisplayInstruct", "" };
					string[] stringArray1 = stringArray3;
					stringArray3 = new string[] { "SelectSwitch", "SelectNext" };
					string[] stringArray2 = stringArray3;
					this.m_oIP1Wiz = new PendantMenu (stringArray1, stringArray2, this.Pendant);
					this.m_oIP1Wiz.Action += new MenuCallback (this.IP1WizAction);
					this.m_oIP1Wiz.BeforeDisplay += new BeforeDisplayCallback (this.IP1WizBeforeDisplay);
					return this.m_oIP1Wiz;
				}
			}
			
			
			private PendantMenu IPMenu
			
			{
				get
				{
					if (this.m_oIPMenu != null)
					{
						return this.m_oIPMenu;
					}
					string[] stringArray3 = new string[] { "Display2Instruct", "Display2Instruct" };
					string[] stringArray1 = stringArray3;
					stringArray3 = new string[] { "SelectChange", "SelectGoBack" };
					string[] stringArray2 = stringArray3;
					this.m_oIPMenu = new PendantMenu (stringArray1, stringArray2, this.Pendant);
					this.m_oIPMenu.Action += new MenuCallback (this.IPMenuAction);
					this.m_oIPMenu.BeforeDisplay += new BeforeDisplayCallback (this.IPMenuBeforeDisplay);
					return this.m_oIPMenu;
				}
			}
			
			
			private PendantMenu JobModeMenu
			
			{
				get
				{
					if (this.m_JobModeMenu != null)
					{
						return this.m_JobModeMenu;
					}
					string[] stringArray3 = new string[] { "JobModeTitle" };
					string[] stringArray1 = stringArray3;
					stringArray3 = new string[] { "SelectRunJobOnce", "SelectRunJobContinuous", "SelectGoBack" };
					string[] stringArray2 = stringArray3;
					this.m_JobModeMenu = new PendantMenu (stringArray1, stringArray2, this.Pendant);
					this.m_JobModeMenu.Action += new MenuCallback (this.JobModeMenuAction);
					return this.m_JobModeMenu;
				}
			}
			
			
			private PendantMenu LocalPromptMenu
			
			{
				get
				{
					if (this.m_oLocalPromptMenu != null)
					{
						return this.m_oLocalPromptMenu;
					}
					string[] stringArray3 = new string[] { "AskLocalInstruct", "AskLocalTitle" };
					string[] stringArray1 = stringArray3;
					stringArray3 = new string[] { "SelectYes", "SelectNo" };
					string[] stringArray2 = stringArray3;
					this.m_oLocalPromptMenu = new PendantMenu (stringArray1, stringArray2, this.Pendant);
					this.m_oLocalPromptMenu.Action += new MenuCallback (this.LocalPromptMenuAction);
					this.m_oLocalPromptMenu.BeforeDisplay += new BeforeDisplayCallback (this.LocalPromptMenuBeforeDisplay);
					return this.m_oLocalPromptMenu;
				}
			}
			
			
			private PendantMenu MainLocalMenu
			
			{
				get
				{
					if (this.m_oMainLocalMenu != null)
					{
						return this.m_oMainLocalMenu;
					}
					string[] stringArray3 = new string[] { "LocalMenuTitle" };
					string[] stringArray1 = stringArray3;
					stringArray3 = new string[] { "SelectRemote", "SelectStartJob", "SelectAdvanced" };
					string[] stringArray2 = stringArray3;
					this.m_oMainLocalMenu = new PendantMenu (stringArray1, stringArray2, this.Pendant);
					this.m_oMainLocalMenu.Action += new MenuCallback (this.MainLocalMenuAction);
					return this.m_oMainLocalMenu;
				}
			}
			
			
			private PendantMenu MainRemoteMenu
			
			{
				get
				{
					if (this.m_oMainRemoteMenu != null)
					{
						return this.m_oMainRemoteMenu;
					}
					string[] stringArray3 = new string[] { "RemoteModeTitle", "", "" };
					string[] stringArray1 = stringArray3;
					stringArray3 = new string[] { "SelectLocal" };
					string[] stringArray2 = stringArray3;
					this.m_oMainRemoteMenu = new PendantMenu (stringArray1, stringArray2, this.Pendant);
					this.m_oMainRemoteMenu.Action += new MenuCallback (this.MainRemoteMenuAction);
					this.m_oMainRemoteMenu.BeforeDisplay += new BeforeDisplayCallback (this.MainRemoteMenuBeforeDisplay);
					return this.m_oMainRemoteMenu;
				}
			}
			
			
			public ArrayList MenuList
			
			{
				get
				{
					return this.m_lstMenus;
				}
			}
			
			
			private PendantMenu OffsetSettingMenu
			
			{
				get
				{
					if (this.m_oOffsetSettingMenu != null)
					{
						return this.m_oOffsetSettingMenu;
					}
					string[] stringArray3 = new string[] { "OffsetSettingsTitle" };
					string[] stringArray1 = stringArray3;
					stringArray3 = new string[] { "SelectOff1", "SelectOff2", "SelectGoBack" };
					string[] stringArray2 = stringArray3;
					this.m_oOffsetSettingMenu = new PendantMenu (stringArray1, stringArray2, this.Pendant);
					this.m_oOffsetSettingMenu.Action += new MenuCallback (this.OffsetSettingMenuAction);
					return this.m_oOffsetSettingMenu;
				}
			}
			
			
			private PendantMenu RunningContinuousMenu
			
			{
				get
				{
					if (this.m_oRunningContinuousMenu != null)
					{
						return this.m_oRunningContinuousMenu;
					}
					string[] stringArray3 = new string[] { "DisplayInstr", "RunningTitle", "" };
					string[] stringArray1 = stringArray3;
					stringArray3 = new string[] { "SelectStopJob" };
					string[] stringArray2 = stringArray3;
					this.m_oRunningContinuousMenu = new PendantMenu (stringArray1, stringArray2, this.Pendant);
					this.m_oRunningContinuousMenu.Action += new MenuCallback (this.RunningContinuousMenuAction);
					this.m_oRunningContinuousMenu.BeforeDisplay += new BeforeDisplayCallback (this.RunningContinuousMenuBeforeDisplay);
					return this.m_oRunningContinuousMenu;
				}
			}
			
			
			private PendantMenu RunningOnceMenu
			
			{
				get
				{
					if (this.m_oRunningOnceMenu != null)
					{
						return this.m_oRunningOnceMenu;
					}
					string[] stringArray3 = new string[] { "DisplayInstr", "", "" };
					string[] stringArray1 = stringArray3;
					stringArray3 = new string[] { "SelectStopJobReturn" };
					string[] stringArray2 = stringArray3;
					this.m_oRunningOnceMenu = new PendantMenu (stringArray1, stringArray2, this.Pendant);
					this.m_oRunningOnceMenu.Action += new MenuCallback (this.RunningOnceMenuAction);
					this.m_oRunningOnceMenu.BeforeDisplay += new BeforeDisplayCallback (this.RunningOnceMenuBeforeDisplay);
					return this.m_oRunningOnceMenu;
				}
			}
			
			
			private PendantMenu SelectJobMenu
			
			{
				get
				{
					if (this.m_oSelectJobMenu != null)
					{
						return this.m_oSelectJobMenu;
					}
					string[] stringArray2 = new string[] { "", "SelectJobTitle", "", "" };
					string[] stringArray1 = stringArray2;
					this.m_oSelectJobMenu = new PendantMenu (stringArray1, ((string[]) null), this.Pendant);
					this.m_oSelectJobMenu.Action += new MenuCallback (this.SelectJobMenuAction);
					this.m_oSelectJobMenu.BeforeDisplay += new BeforeDisplayCallback (this.SelectJobMenuBeforeDisplay);
					return this.m_oSelectJobMenu;
				}
			}
			
			
			public virtual HostTypes ThisHostType
			
			{
				get
				{
					return this.hostType;
				}
			}
			
			
			private PendantMenu UserAccessMenu
			
			{
				get
				{
					if (this.m_oUserAccessMenu != null)
					{
						return this.m_oUserAccessMenu;
					}
					string[] stringArray3 = new string[] { "SelectAdv3" };
					string[] stringArray1 = stringArray3;
					stringArray3 = new string[] { "SelectUsr1", "SelectUsr2", "SelectGoBack" };
					string[] stringArray2 = stringArray3;
					this.m_oUserAccessMenu = new PendantMenu (stringArray1, stringArray2, this.Pendant);
					this.m_oUserAccessMenu.Action += new MenuCallback (this.UserAccessMenuAction);
					return this.m_oUserAccessMenu;
				}
			}
			
			
			private PendantMenu UserInfoMenu
			
			{
				get
				{
					if (this.userInfoMenu != null)
					{
						return this.userInfoMenu;
					}
					string[] stringArray3 = new string[] { "UserInfoTitle", "", "" };
					string[] stringArray1 = stringArray3;
					stringArray3 = new string[] { "SelectGoBack" };
					string[] stringArray2 = stringArray3;
					this.userInfoMenu = new PendantMenu (stringArray1, stringArray2, this.Pendant);
					this.userInfoMenu.Action += new MenuCallback (this.UserInfoMenuAction);
					return this.userInfoMenu;
				}
			}
			
		#endregion
		
		#region Methods
		
			private void AdvancedMenuAction (byte pbValue)
			
			{
				uint uInt32_1 = this.CommonMenuAction (pbValue);
				PendantMenu pendantMenu1 = ((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]);
				if ((pbValue == this.Pendant.D1Key) || (uInt32_1 == 1))
				{
					pendantMenu1.SetSelection (1);
					int i1 = this.MenuList.Add (this.DeviceSettingMenu);
				}
				else if ((pbValue == this.Pendant.D2Key) || (uInt32_1 == 2))
				{
					pendantMenu1.SetSelection (2);
					int i2 = this.MenuList.Add (this.GlobalsMenu);
				}
				else if ((pbValue == this.Pendant.D3Key) || (uInt32_1 == 3))
				{
					pendantMenu1.SetSelection (3);
					int i3 = this.MenuList.Add (this.UserAccessMenu);
				}
				else if ((pbValue == this.Pendant.D4Key) || (uInt32_1 == 4))
				{
					pendantMenu1.SetSelection (4);
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
				}
				this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
			}
			
			private void AskContinuousJobMenuAction (byte pbValue)
			
			{
				bool b2;
				string string1;
				string[] stringArray1;
				string[] stringArray2;
				string[] stringArray3;
				string[] stringArray4;
				string[] stringArray5;
				uint uInt32_1 = this.CommonMenuAction (pbValue);
				PendantMenu pendantMenu1 = ((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]);
				bool b1 = false;
				if ((pbValue == this.Pendant.D1Key) || (uInt32_1 == 1))
				{
					b2 = false;
					pendantMenu1.SetSelection (1);
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
					string1 = JobOpStatus.Idle.ToString ();
					if (this.CurrentJobState == JobOpStatus.Busy.ToString ())
					{
						if (this.OnInputCommand != null)
						{
							stringArray5 = new string[] { APICommands.Abort.ToString () };
							stringArray1 = stringArray5;
							stringArray2 = this.OnInputCommand (this.ThisHostType, stringArray1);
							if (stringArray2 != null)
							{
								string1 = stringArray2[0];
							}
						}
					}
					else if (this.OnInputCommand != null)
					{
						stringArray5 = new string[] { APICommands.ExecuteJobContinuous.ToString (), this.m_strSelectedJobFile };
						stringArray3 = stringArray5;
						stringArray4 = this.OnInputCommand (this.ThisHostType, stringArray3);
						if (stringArray4 != null)
						{
							string1 = stringArray4[0];
							b2 = true;
						}
					}
					if (string1 != APIResponses.ACK.ToString ())
					{
						int i2 = this.MenuList.Add (this.ShowRunError (string1));
					}
					else if (b2)
					{
						int i1 = this.MenuList.Add (this.RunningContinuousMenu);
					}
					else
					{
						this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
						b1 = true;
					}
				}
				else if ((pbValue == this.Pendant.D2Key) || (uInt32_1 == 2))
				{
					pendantMenu1.SetSelection (2);
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
				}
				if (! b1)
				{
					this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
				}
			}
			
			private void AskContinuousJobMenuBeforeDisplay ()
			
			{
				string string3;
				if (this.m_strSelectedJobFile.Length == 0)
				{
					this.m_strSelectedJobFile = "LocalJob.wlb";
				}
				string string1 = (">" + Path.GetFileNameWithoutExtension (this.m_strSelectedJobFile));
				if (string1.Length > 20)
				{
					string1 = (string1.Substring (0, 17) + "...");
				}
				this.AskContinuousJobMenu.UpdateTitle (0, string1);
				string string2 = PendantMenu.GetStringFromResource ("AskLocalInstruct");
				if (this.CurrentJobState == JobOpStatus.Busy.ToString ())
				{
					string3 = string.Format (string2, PendantMenu.GetStringFromResource ("AskStopTitle"));
				}
				else
				{
					string3 = string.Format (string2, PendantMenu.GetStringFromResource ("AskStartTitle"));
				}
				this.AskContinuousJobMenu.UpdateTitle (1, string3);
			}
			
			private void AskOnceJobMenuAction (byte pbValue)
			
			{
				string[] stringArray1;
				string[] stringArray2;
				string[] stringArray3;
				uint uInt32_1 = this.CommonMenuAction (pbValue);
				PendantMenu pendantMenu1 = ((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]);
				if ((pbValue == this.Pendant.D1Key) || (uInt32_1 == 1))
				{
					pendantMenu1.SetSelection (1);
					stringArray1 = ((string[]) null);
					if ((this.OnInputCommand != null) && (this.OnInputCommand != null))
					{
						stringArray3 = new string[] { APICommands.ExecuteJobOnce.ToString (), this.m_strSelectedJobFile };
						stringArray2 = stringArray3;
						stringArray1 = this.OnInputCommand (this.ThisHostType, stringArray2);
					}
					if ((stringArray1 != null) && (stringArray1[0] == APIResponses.ACK.ToString ()))
					{
						int i1 = this.MenuList.Add (this.RunningOnceMenu);
						this.runOnce = true;
					}
					else
					{
						int i2 = this.MenuList.Add (this.ShowRunError (stringArray1[0]));
					}
				}
				else if ((pbValue == this.Pendant.D2Key) || (uInt32_1 == 2))
				{
					pendantMenu1.SetSelection (2);
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
					this.runOnce = false;
				}
				this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
			}
			
			private void AskOnceJobMenuBeforeDisplay ()
			
			{
				string string3;
				if (this.m_strSelectedJobFile.Length == 0)
				{
					this.m_strSelectedJobFile = "LocalJob.wlb";
				}
				string string1 = (">" + Path.GetFileNameWithoutExtension (this.m_strSelectedJobFile));
				if (string1.Length > 20)
				{
					string1 = (string1.Substring (0, 17) + "...");
				}
				this.AskOnceJobMenu.UpdateTitle (0, string1);
				string string2 = PendantMenu.GetStringFromResource ("AskLocalInstruct");
				if (this.runOnce)
				{
					string3 = string.Format (string2, PendantMenu.GetStringFromResource ("AskStartAgainTitle"));
				}
				else
				{
					string3 = string.Format (string2, PendantMenu.GetStringFromResource ("AskStartTitle"));
				}
				this.AskOnceJobMenu.UpdateTitle (1, string3);
			}
			
			public virtual void AssumeControl ()
			
			{
				if (this.OnUpdateClientInfo != null)
				{
					this.OnUpdateClientInfo (ClientConnectionStatus.Local, "Pendant", "0.0.0.0", 0);
				}
			}
			
			private void ChallengeAdminPasswordMenuAction (byte pbValue)
			
			{
				if (pbValue == this.Pendant.EnterKey)
				{
					if (this.m_strEditValue == this.m_oDataObject.Value)
					{
						this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
						int i1 = this.MenuList.Add (this.AdvancedMenu);
					}
					else
					{
						this.ShowPasswordNoMatchMessage ();
						Thread.Sleep (2500);
					}
				}
				else if (pbValue == this.Pendant.EscapeKey)
				{
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
				}
				else if ((pbValue == this.Pendant.DeleteKey) || (pbValue == this.Pendant.BackspaceKey))
				{
					if (this.m_strEditValue.Length != 0)
					{
						this.m_strEditValue = this.m_strEditValue.Substring (0, ((int) (this.m_strEditValue.Length - 1)));
					}
				}
				else if ((this.m_strEditValue.Length < 20) && this.Pendant.IsTextCharacter (pbValue))
				{
					this.m_strEditValue = (this.m_strEditValue + ((char) pbValue).ToString ());
				}
				this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
			}
			
			private void ChallengeAdminPasswordMenuBeforeDisplay ()
			
			{
				int i1;
				string string1 = PendantMenu.GetStringFromResource ("DisplayInstruct");
				string string2 = "";
				for (i1 = 0; (i1 < this.m_strEditValue.Length); i1++)
				{
					string2 = (string2 + "*");
				}
				string string3 = string.Format (string1, string2);
				this.ChallengeAdminPasswordMenu.UpdateTitle (0, string3);
				this.ChallengeAdminPasswordMenu.UpdateTitle (1, this.m_oDataObject.Description);
				this.ChallengeAdminPasswordMenu.CursorColumnPosition = ((uint) this.m_strEditValue.Length);
				this.ChallengeAdminPasswordMenu.CursorRowPosition = uint.MinValue;
			}
			
			private void ChallengeUserPasswordMenuAction (byte pbValue)
			
			{
				string string1;
				string[] stringArray1;
				string[] stringArray2;
				if (pbValue == this.Pendant.EnterKey)
				{
					if (this.m_strEditValue == this.m_oDataObject.Value)
					{
						string1 = this.CurrentConnection;
						if ((string1.Length == 0) || (string1.CompareTo ("0.0.0.0") == 0))
						{
							this.pleaseWait = true;
							this.ShowPleaseWaitMessage ();
							if (this.OnInputCommand != null)
							{
								stringArray2 = new string[] { APICommands.TakeHostControl.ToString () };
								stringArray1 = stringArray2;
								string[] stringArray3 = this.OnInputCommand (this.ThisHostType, stringArray1);
							}
							this.pleaseWait = false;
							this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
							int i1 = this.MenuList.Add (this.MainLocalMenu);
						}
						else
						{
							this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
							int i2 = this.MenuList.Add (this.LocalPromptMenu);
						}
					}
					else
					{
						this.ShowPasswordNoMatchMessage ();
						Thread.Sleep (2500);
					}
				}
				else if (pbValue == this.Pendant.EscapeKey)
				{
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
				}
				else if ((pbValue == this.Pendant.DeleteKey) || (pbValue == this.Pendant.BackspaceKey))
				{
					if (this.m_strEditValue.Length != 0)
					{
						this.m_strEditValue = this.m_strEditValue.Substring (0, ((int) (this.m_strEditValue.Length - 1)));
					}
				}
				else if ((this.m_strEditValue.Length < 20) && this.Pendant.IsTextCharacter (pbValue))
				{
					this.m_strEditValue = (this.m_strEditValue + ((char) pbValue).ToString ());
				}
				this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
			}
			
			private void ChallengeUserPasswordMenuBeforeDisplay ()
			
			{
				int i1;
				string string1 = PendantMenu.GetStringFromResource ("DisplayInstruct");
				string string2 = "";
				for (i1 = 0; (i1 < this.m_strEditValue.Length); i1++)
				{
					string2 = (string2 + "*");
				}
				string string3 = string.Format (string1, string2);
				this.ChallengeUserPasswordMenu.UpdateTitle (0, string3);
				this.ChallengeUserPasswordMenu.UpdateTitle (1, this.m_oDataObject.Description);
				this.ChallengeUserPasswordMenu.CursorColumnPosition = ((uint) this.m_strEditValue.Length);
				this.ChallengeUserPasswordMenu.CursorRowPosition = uint.MinValue;
			}
			
			private void ChangePasswordMenuAction (byte pbValue)
			
			{
				if (pbValue == this.Pendant.EnterKey)
				{
					this.newPassword = this.m_strEditValue;
					this.m_strEditValue = "";
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
					int i1 = this.MenuList.Add (this.ConfirmPasswordMenu);
				}
				if (pbValue == this.Pendant.EscapeKey)
				{
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
				}
				else if ((pbValue == this.Pendant.DeleteKey) || (pbValue == this.Pendant.BackspaceKey))
				{
					if (this.m_strEditValue.Length != 0)
					{
						this.m_strEditValue = this.m_strEditValue.Substring (0, ((int) (this.m_strEditValue.Length - 1)));
					}
				}
				else if ((this.m_strEditValue.Length < 20) && this.Pendant.IsTextCharacter (pbValue))
				{
					this.m_strEditValue = (this.m_strEditValue + ((char) pbValue).ToString ());
				}
				this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
			}
			
			private void ChangePasswordMenuBeforeDisplay ()
			
			{
				int i1;
				string string1 = PendantMenu.GetStringFromResource ("DisplayInstruct");
				string string2 = "";
				for (i1 = 0; (i1 < this.m_strEditValue.Length); i1++)
				{
					string2 = (string2 + "*");
				}
				this.ChangePasswordMenu.CursorColumnPosition = ((uint) this.m_strEditValue.Length);
				this.ChangePasswordMenu.CursorRowPosition = uint.MinValue;
				string string3 = string.Format (string1, string2);
				this.ChangePasswordMenu.UpdateTitle (0, string3);
			}
			
			private void ChooseFileSourceMenuAction (byte pbValue)
			
			{
				string[] stringArray1;
				string[] stringArray2;
				string[] stringArray3;
				uint uInt32_1 = this.CommonMenuAction (pbValue);
				PendantMenu pendantMenu1 = ((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]);
				if ((pbValue == this.Pendant.D1Key) || (uInt32_1 == 1))
				{
					pendantMenu1.SetSelection (1);
					this.flashPath = true;
					if (this.OnInputCommand != null)
					{
						stringArray3 = new string[] { APICommands.GetFlashJobFileList.ToString () };
						stringArray1 = stringArray3;
						this.m_lstJobFiles = this.OnInputCommand (this.ThisHostType, stringArray1);
					}
					if (this.m_lstJobFiles == null)
					{
						pendantMenu1 = this.ShowJobSearchError (APIResponses.ERROR_NO_FILES_FOUND.ToString ());
						int i4 = this.MenuList.Add (pendantMenu1);
					}
					else if (this.m_lstJobFiles.Length > 1)
					{
						int i1 = this.MenuList.Add (this.SelectJobMenu);
					}
					else if ((this.m_lstJobFiles[0] == APIResponses.ERROR_NO_FILES_FOUND.ToString ()) || (this.m_lstJobFiles[0] == APIResponses.ERROR_NO_DRIVE.ToString ()))
					{
						pendantMenu1 = this.ShowJobSearchError (this.m_lstJobFiles[0]);
						int i2 = this.MenuList.Add (pendantMenu1);
					}
					else
					{
						int i3 = this.MenuList.Add (this.SelectJobMenu);
					}
				}
				else if ((pbValue == this.Pendant.D2Key) || (uInt32_1 == 2))
				{
					pendantMenu1.SetSelection (2);
					this.flashPath = false;
					if (this.OnInputCommand != null)
					{
						stringArray3 = new string[] { APICommands.GetUSBJobFileList.ToString () };
						stringArray2 = stringArray3;
						this.m_lstJobFiles = this.OnInputCommand (this.ThisHostType, stringArray2);
					}
					if (this.m_lstJobFiles == null)
					{
						pendantMenu1 = this.ShowJobSearchError (APIResponses.ERROR_NO_FILES_FOUND.ToString ());
						int i8 = this.MenuList.Add (pendantMenu1);
					}
					else if (this.m_lstJobFiles.Length > 1)
					{
						int i5 = this.MenuList.Add (this.SelectJobMenu);
					}
					else if ((this.m_lstJobFiles[0] == APIResponses.ERROR_NO_FILES_FOUND.ToString ()) || (this.m_lstJobFiles[0] == APIResponses.ERROR_NO_DRIVE.ToString ()))
					{
						pendantMenu1 = this.ShowJobSearchError (this.m_lstJobFiles[0]);
						int i6 = this.MenuList.Add (pendantMenu1);
					}
					else
					{
						int i7 = this.MenuList.Add (this.SelectJobMenu);
					}
				}
				else if ((pbValue == this.Pendant.D3Key) || (uInt32_1 == 3))
				{
					pendantMenu1.SetSelection (3);
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
				}
				this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
			}
			
			private uint CommonMenuAction (byte pbValue)
			
			{
				PendantMenu pendantMenu1;
				PendantMenu pendantMenu2;
				if ((pbValue == this.Pendant.LeftKey) || (pbValue == this.Pendant.UpKey))
				{
					pendantMenu1 = ((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]);
					pendantMenu1.PreviousSelection ();
					return uint.MinValue;
				}
				if ((pbValue == this.Pendant.RightKey) || (pbValue == this.Pendant.DownKey))
				{
					pendantMenu2 = ((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]);
					pendantMenu2.NextSelection ();
					return uint.MinValue;
				}
				if (pbValue != this.Pendant.EnterKey)
				{
					return uint.MinValue;
				}
				PendantMenu pendantMenu3 = ((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]);
				return pendantMenu3.MenuSelection;
			}
			
			private void ConfirmPasswordMenuAction (byte pbValue)
			
			{
				if (pbValue == this.Pendant.EnterKey)
				{
					if (this.newPassword == this.m_strEditValue)
					{
						this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
						this.m_oDataObject.UpdateValue (this.m_strEditValue);
					}
					else
					{
						this.ShowPasswordNoMatchMessage ();
						Thread.Sleep (2500);
					}
				}
				else if (pbValue == this.Pendant.EscapeKey)
				{
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
				}
				else if ((pbValue == this.Pendant.DeleteKey) || (pbValue == this.Pendant.BackspaceKey))
				{
					if (this.m_strEditValue.Length != 0)
					{
						this.m_strEditValue = this.m_strEditValue.Substring (0, ((int) (this.m_strEditValue.Length - 1)));
					}
				}
				else if ((this.m_strEditValue.Length < 20) && this.Pendant.IsTextCharacter (pbValue))
				{
					this.m_strEditValue = (this.m_strEditValue + ((char) pbValue).ToString ());
				}
				this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
			}
			
			private void ConfirmPasswordMenuBeforeDisplay ()
			
			{
				int i1;
				string string1 = PendantMenu.GetStringFromResource ("DisplayInstruct");
				string string2 = "";
				for (i1 = 0; (i1 < this.m_strEditValue.Length); i1++)
				{
					string2 = (string2 + "*");
				}
				this.ConfirmPasswordMenu.CursorColumnPosition = ((uint) this.m_strEditValue.Length);
				this.ConfirmPasswordMenu.CursorRowPosition = uint.MinValue;
				string string3 = string.Format (string1, string2);
				this.ConfirmPasswordMenu.UpdateTitle (0, string3);
			}
			
			private void DeviceSettingMenuAction (byte pbValue)
			
			{
				uint uInt32_1 = this.CommonMenuAction (pbValue);
				PendantMenu pendantMenu1 = ((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]);
				if ((pbValue == this.Pendant.D1Key) || (uInt32_1 == 1))
				{
					pendantMenu1.SetSelection (1);
					this.m_oDataObject = ((IPendantInputData) new DeviceName ());
					this.m_oDataObject.OnInputCommand += new InputCommandHandler (this.OnInputCommand);
					this.m_oDataObject.Description = PendantMenu.GetStringFromResource ("SelectDev1");
					this.m_strEditValue = "";
					int i1 = this.MenuList.Add (this.InputDisplayMenu);
				}
				else if ((pbValue == this.Pendant.D2Key) || (uInt32_1 == 2))
				{
					pendantMenu1.SetSelection (2);
					int i2 = this.MenuList.Add (this.IPMenu);
				}
				else if ((pbValue == this.Pendant.D3Key) || (uInt32_1 == 3))
				{
					pendantMenu1.SetSelection (3);
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
				}
				this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
			}
			
			public virtual void Disconnect ()
			
			{
				bool b1 = this.Pendant.Disconnect ();
			}
			
			private void DisplayMenu (PendantMenu poMenuItem)
			
			{
				string string1;
				this.Pendant.ClearScreen ();
				bool b1 = true;
				foreach (object object1 in poMenuItem.BuildDisplay)
				{
					if (b1 && (object1 is string))
					{
						b1 = false;
					}
					else if (object1 is string)
					{
						this.Pendant.WriteLine ();
					}
					if (object1 is string)
					{
						string1 = (object1 as string);
						if (string1.Length > 20)
						{
							string1 = string1.Substring (0, 20);
						}
						this.Pendant.Write (string1);
					}
					else if (object1 is byte[])
					{
						this.Pendant.Write ((object1 as byte[]));
					}
				}
			}
			
			private void GlobalsMenuAction (byte pbValue)
			
			{
				uint uInt32_1 = this.CommonMenuAction (pbValue);
				PendantMenu pendantMenu1 = ((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]);
				if ((pbValue == this.Pendant.D1Key) || (uInt32_1 == 1))
				{
					pendantMenu1.SetSelection (1);
					this.m_oDataObject = ((IPendantInputData) new MarkSpeed ());
					this.m_oDataObject.OnInputCommand += new InputCommandHandler (this.OnInputCommand);
					this.m_oDataObject.Description = PendantMenu.GetStringFromResource ("EnterMarkSpeed");
					this.m_strEditValue = "";
					int i1 = this.MenuList.Add (this.InputDisplayMenu);
				}
				else if ((pbValue == this.Pendant.D2Key) || (uInt32_1 == 2))
				{
					pendantMenu1.SetSelection (2);
					int i2 = this.MenuList.Add (this.OffsetSettingMenu);
				}
				else if ((pbValue == this.Pendant.D3Key) || (uInt32_1 == 3))
				{
					pendantMenu1.SetSelection (3);
					this.m_oDataObject = ((IPendantInputData) new LaserPower ());
					this.m_oDataObject.OnInputCommand += new InputCommandHandler (this.OnInputCommand);
					this.m_oDataObject.Description = PendantMenu.GetStringFromResource ("EnterLaserPower");
					this.m_strEditValue = "";
					int i3 = this.MenuList.Add (this.InputDisplayMenu);
				}
				else if ((pbValue == this.Pendant.D4Key) || (uInt32_1 == 4))
				{
					pendantMenu1.SetSelection (4);
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
				}
				this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
			}
			
			private void HardwareRestartMenuAction (byte pbValue)
			
			{
				string[] stringArray1;
				string[] stringArray2;
				uint uInt32_1 = this.CommonMenuAction (pbValue);
				if ((pbValue == this.Pendant.D1Key) || (uInt32_1 == 1))
				{
					this.ShowRestartMessage ();
					if (this.OnInputCommand != null)
					{
						stringArray2 = new string[] { APICommands.HardwareReset.ToString () };
						stringArray1 = stringArray2;
						string[] stringArray3 = this.OnInputCommand (this.ThisHostType, stringArray1);
					}
				}
				else if ((pbValue == this.Pendant.D2Key) || (uInt32_1 == 2))
				{
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
					int i1 = this.MenuList.Add (this.ShowHardwareResetWarning ());
				}
				this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
			}
			
			private void HomeMenuAction (byte pbValue)
			
			{
				this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
				if (this.MenuList.Count == 0)
				{
					if (this.HostInControl != HostTypes.Pendant)
					{
						int i2 = this.MenuList.Add (this.MainRemoteMenu);
					}
					else
					{
						int i1 = this.MenuList.Add (this.MainLocalMenu);
					}
				}
				this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
			}
			
			private void HomeMenuBeforeDisplay ()
			
			{
				string[] stringArray1;
				string[] stringArray2;
				string string2;
				string string3;
				string string6;
				string string7;
				string string8;
				string string9;
				string[] stringArray3;
				string string1 = "Default Node Name";
				if (this.OnInputCommand != null)
				{
					stringArray3 = new string[] { APICommands.GetNodeFriendlyName.ToString () };
					stringArray1 = stringArray3;
					stringArray2 = this.OnInputCommand (this.ThisHostType, stringArray1);
					if (stringArray2 != null)
					{
						string1 = stringArray2[0];
					}
				}
				this.HomeMenu.UpdateTitle (0, string1);
				if (this.HostInControl == HostTypes.Pendant)
				{
					stringArray3 = new string[] { PendantMenu.GetStringFromResource ("InTitle"), " ", PendantMenu.GetStringFromResource ("PendantTitle"), " ", PendantMenu.GetStringFromResource ("ModeTitle") };
					string3 = string.Concat (stringArray3);
					this.HomeMenu.UpdateTitle (1, string3);
					if (this.CurrentJobState == JobOpStatus.Busy.ToString ())
					{
						string2 = PendantMenu.GetStringFromResource ("RunningTitle");
					}
					else
					{
						string2 = PendantMenu.GetStringFromResource ("IdleTitle");
					}
					this.HomeMenu.UpdateTitle (2, string2);
					return;
				}
				if (this.HostInControl != HostTypes.LANStream)
				{
					if (this.HostInControl == HostTypes.GUI)
					{
						stringArray3 = new string[] { PendantMenu.GetStringFromResource ("InTitle"), " ", PendantMenu.GetStringFromResource ("GUITitle"), " ", PendantMenu.GetStringFromResource ("ModeTitle") };
						string6 = string.Concat (stringArray3);
						this.HomeMenu.UpdateTitle (1, string6);
						if (this.CurrentJobState != JobOpStatus.Busy.ToString ())
						{
							string2 = PendantMenu.GetStringFromResource ("IdleTitle");
						}
						else
						{
							string2 = PendantMenu.GetStringFromResource ("RunningTitle");
						}
						this.HomeMenu.UpdateTitle (2, string2);
					}
					else if (this.HostInControl == HostTypes.Bluetooth)
					{
						stringArray3 = new string[] { PendantMenu.GetStringFromResource ("InTitle"), " ", PendantMenu.GetStringFromResource ("BluetoothTitle"), " ", PendantMenu.GetStringFromResource ("ModeTitle") };
						string7 = string.Concat (stringArray3);
						this.HomeMenu.UpdateTitle (1, string7);
						if (this.CurrentJobState != JobOpStatus.Busy.ToString ())
						{
							string2 = PendantMenu.GetStringFromResource ("IdleTitle");
						}
						else
						{
							string2 = PendantMenu.GetStringFromResource ("RunningTitle");
						}
						this.HomeMenu.UpdateTitle (2, string2);
					}
					else
					{
						if (this.HostInControl == HostTypes.LAN)
						{
							stringArray3 = new string[] { PendantMenu.GetStringFromResource ("InTitle"), " ", PendantMenu.GetStringFromResource ("LANTitle"), " ", PendantMenu.GetStringFromResource ("ModeTitle") };
							string8 = string.Concat (stringArray3);
							this.HomeMenu.UpdateTitle (1, string8);
							if (this.CurrentJobState != JobOpStatus.Busy.ToString ())
							{
								string2 = PendantMenu.GetStringFromResource ("IdleTitle");
							}
							else
							{
								string2 = PendantMenu.GetStringFromResource ("RunningTitle");
							}
							this.HomeMenu.UpdateTitle (2, string2);
						}
						else if (this.HostInControl == HostTypes.RS232)
						{
							stringArray3 = new string[] { PendantMenu.GetStringFromResource ("InTitle"), " ", PendantMenu.GetStringFromResource ("RS232Title"), " ", PendantMenu.GetStringFromResource ("ModeTitle") };
							string9 = string.Concat (stringArray3);
							this.HomeMenu.UpdateTitle (1, string9);
							if (this.CurrentJobState != JobOpStatus.Busy.ToString ())
							{
								string2 = PendantMenu.GetStringFromResource ("IdleTitle");
							}
							else
							{
								string2 = PendantMenu.GetStringFromResource ("RunningTitle");
							}
							this.HomeMenu.UpdateTitle (2, string2);
						}
						return;
					}
					return;
				}
				stringArray3 = new string[] { PendantMenu.GetStringFromResource ("InTitle"), " ", PendantMenu.GetStringFromResource ("LANStreamTitle"), " ", PendantMenu.GetStringFromResource ("ModeTitle") };
				string string4 = string.Concat (stringArray3);
				this.HomeMenu.UpdateTitle (1, string4);
				string string5 = this.CurrentConnection;
				if ((string5.Length != 0) && (string5.CompareTo ("0.0.0.0") != 0))
				{
					string2 = PendantMenu.GetStringFromResource ("ConnectedToClientTitle");
				}
				else
				{
					string2 = PendantMenu.GetStringFromResource ("ConnectionIdleTitle");
				}
				this.HomeMenu.UpdateTitle (2, string2);
			}
			
			public virtual bool Initialize ()
			
			{
				bool b1 = this.Pendant.Connect ();
				if (b1)
				{
					return true;
				}
				else
				{
					return b1;
				}
			}
			
			private void InputAcceptMenuAction (byte pbValue)
			
			{
				string[] stringArray1;
				string[] stringArray2;
				uint uInt32_1 = this.CommonMenuAction (pbValue);
				PendantMenu pendantMenu1 = ((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]);
				if ((pbValue == this.Pendant.D1Key) || (uInt32_1 == 1))
				{
					pendantMenu1.SetSelection (1);
					if ((this.m_oDataObject is Address) || ((this.m_oDataObject is Gateway) || ((this.m_oDataObject is IPMode) || (this.m_oDataObject is SubnetMask))))
					{
						this.ShowPleaseWaitMessage ();
						this.pleaseWait = true;
						this.restartRequired = true;
					}
					this.m_oDataObject.UpdateValue (this.m_strEditValue);
					this.m_strEditValue = "";
					if (this.OnInputCommand != null)
					{
						stringArray2 = new string[] { APICommands.SetAlignmentGlobals.ToString () };
						stringArray1 = stringArray2;
						string[] stringArray3 = this.OnInputCommand (this.ThisHostType, stringArray1);
					}
					this.pleaseWait = false;
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
				}
				else if ((pbValue == this.Pendant.D2Key) || (uInt32_1 == 2))
				{
					pendantMenu1.SetSelection (2);
					this.m_strEditValue = "";
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
				}
				this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
			}
			
			private void InputAcceptMenuBeforeDisplay ()
			
			{
				int i1;
				string string1 = PendantMenu.GetStringFromResource ("DisplayInstruct");
				string string2 = this.m_strEditValue;
				if (this.m_oDataObject.ValueType == InputType.Password)
				{
					string2 = "";
					for (i1 = 0; (i1 < this.m_strEditValue.Length); i1++)
					{
						string2 = (string2 + "*");
					}
				}
				string string3 = string.Format (string1, string2);
				this.InputAcceptMenu.UpdateTitle (0, string3);
			}
			
			private void InputDisplayMenuAction (byte pbValue)
			
			{
				uint uInt32_1 = this.CommonMenuAction (pbValue);
				PendantMenu pendantMenu1 = ((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]);
				if ((pbValue == this.Pendant.D1Key) || (uInt32_1 == 1))
				{
					pendantMenu1.SetSelection (1);
					if (this.m_oDataObject.ValueType == InputType.Password)
					{
						this.m_strEditValue = "";
					}
					else if (this.m_oDataObject.ValueType == InputType.IPAddress)
					{
						this.InputEditMenu.CursorColumnPosition = 2;
					}
					int i1 = this.MenuList.Add (this.InputEditMenu);
				}
				else if ((pbValue == this.Pendant.D2Key) || (uInt32_1 == 2))
				{
					pendantMenu1.SetSelection (2);
					if (this.m_lstDataObject.Count <= 0)
					{
						this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
						if (this.restartRequired)
						{
							int i2 = this.MenuList.Add (this.HardwareRestartMenu);
						}
					}
					else
					{
						this.m_oDataObject = (this.m_lstDataObject.Dequeue () as IPendantInputData);
						this.m_strEditValue = "";
					}
				}
				this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
			}
			
			private void InputDisplayMenuBeforeDisplay ()
			
			{
				int i1;
				if (this.m_strEditValue.Length == 0)
				{
					this.m_strEditValue = this.m_oDataObject.Value;
				}
				if (this.m_oDataObject.Description.Length > 0)
				{
					this.InputDisplayMenu.UpdateTitle (1, this.m_oDataObject.Description);
				}
				else
				{
					this.InputDisplayMenu.UpdateTitle (0, "");
					this.InputDisplayMenu.UpdateTitle (1, "");
				}
				string string1 = PendantMenu.GetStringFromResource ("Display2Instruct");
				string string2 = this.m_strEditValue;
				if (this.m_oDataObject.ValueType == InputType.Password)
				{
					string2 = "";
					for (i1 = 0; (i1 < this.m_strEditValue.Length); i1++)
					{
						string2 = (string2 + "*");
					}
				}
				string string3 = string.Format (string1, string2);
				this.InputDisplayMenu.UpdateTitle (0, string3);
				if (this.m_lstDataObject.Count > 0)
				{
					this.InputDisplayMenu.UpdateBody (1, "SelectNext");
				}
				else
				{
					this.InputDisplayMenu.UpdateBody (1, "SelectDone");
				}
			}
			
			private void InputEditMenuAction (byte pbValue)
			
			{
				InputType inputType1 = this.m_oDataObject.ValueType;
				switch (inputType1)
				{
					case InputType.String:
					
					{
							this.InputStringAction (pbValue);
							break;
					}
					case InputType.Password:
					
					{
							this.InputPasswordAction (pbValue);
							break;
					}
					case InputType.Number:
					
					{
							this.InputNumberAction (pbValue);
							break;
					}
					case InputType.IPAddress:
					
					{
							this.InputIPAddressAction (pbValue);
							break;
					}
				}
				this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
			}
			
			private void InputEditMenuBeforeDisplay ()
			
			{
				int i1;
				char[] charArray1;
				string[] stringArray1;
				bool b1;
				char[] charArray2;
				string string1 = PendantMenu.GetStringFromResource ("DisplayInstruct");
				string string2 = this.m_strEditValue;
				if (this.m_oDataObject.ValueType == InputType.Password)
				{
					string2 = "";
					for (i1 = 0; (i1 < this.m_strEditValue.Length); i1++)
					{
						string2 = (string2 + "*");
					}
				}
				else if (this.m_oDataObject.ValueType == InputType.IPAddress)
				{
					charArray2 = new char[] { '\u002E' };
					charArray1 = charArray2;
					stringArray1 = this.m_strEditValue.Split (charArray1);
					b1 = true;
					foreach (string string3 in stringArray1)
					{
						if (b1)
						{
							string2 = string.Format ("{0,3}", string3);
							b1 = false;
						}
						else
						{
							string2 = string.Format ("{0}.{1,3}", string2, string3);
						}
					}
					this.InputEditMenu.CursorRowPosition = uint.MinValue;
				}
				else if (this.m_oDataObject.ValueType == InputType.String)
				{
					this.InputEditMenu.CursorColumnPosition = ((uint) string2.Length);
					this.InputEditMenu.CursorRowPosition = uint.MinValue;
				}
				else if (this.m_oDataObject.ValueType == InputType.Number)
				{
					this.InputEditMenu.CursorColumnPosition = ((uint) string2.Length);
					this.InputEditMenu.CursorRowPosition = uint.MinValue;
				}
				string string4 = string.Format (string1, string2);
				this.InputEditMenu.UpdateTitle (0, string4);
			}
			
			private void InputIPAddressAction (byte pbValue)
			
			{
				uint uInt32_1;
				int i4;
				PendantMenu pendantMenu1 = ((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]);
				if (pbValue == this.Pendant.EnterKey)
				{
					pendantMenu1.CursorColumnPosition = uint.MinValue;
					pendantMenu1.CursorRowPosition = uint.MinValue;
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
					int i5 = this.MenuList.Add (this.InputAcceptMenu);
					return;
				}
				if ((pbValue == this.Pendant.TabKey) || ((pbValue == this.Pendant.PeriodKey) || ((pbValue == this.Pendant.RightKey) || (pbValue == this.Pendant.DownKey))))
				{
					uInt32_1 = pendantMenu1.CursorColumnPosition;
					if (uInt32_1 < 6)
					{
						if (uInt32_1 == 2)
						{
							pendantMenu1.CursorColumnPosition = 6;
						}
						else if (uInt32_1 == 6)
						{
							pendantMenu1.CursorColumnPosition = 10;
						}
					}
					else if (uInt32_1 == 10)
					{
						pendantMenu1.CursorColumnPosition = 14;
					}
					else if (uInt32_1 == 14)
					{
						pendantMenu1.CursorColumnPosition = 2;
					}
					return;
				}
				if ((pbValue == this.Pendant.LeftKey) || (pbValue == this.Pendant.UpKey))
				{
					uInt32_1 = pendantMenu1.CursorColumnPosition;
					if (uInt32_1 < 6)
					{
						if (uInt32_1 == 2)
						{
							pendantMenu1.CursorColumnPosition = 14;
						}
						else if (uInt32_1 == 6)
						{
							pendantMenu1.CursorColumnPosition = 2;
						}
					}
					else if (uInt32_1 == 10)
					{
						pendantMenu1.CursorColumnPosition = 6;
					}
					else if (uInt32_1 == 14)
					{
						pendantMenu1.CursorColumnPosition = 10;
					}
					return;
				}
				if (((pbValue < this.Pendant.D0Key) || (pbValue > this.Pendant.D9Key)) && ((pbValue != this.Pendant.DeleteKey) && (pbValue != this.Pendant.BackspaceKey)))
				{
					return;
				}
				bool b1 = ((pbValue == this.Pendant.DeleteKey) || (pbValue == this.Pendant.BackspaceKey));
				char[] charArray2 = new char[] { '\u002E' };
				char[] charArray1 = charArray2;
				string[] stringArray1 = this.m_strEditValue.Split (charArray1);
				int i1 = 0;
				uInt32_1 = pendantMenu1.CursorColumnPosition;
				if (uInt32_1 < 6)
				{
					if (uInt32_1 == 2)
					{
						i1 = 0;
					}
					else if (uInt32_1 == 6)
					{
						i1 = 1;
					}
				}
				else if (uInt32_1 == 10)
				{
					i1 = 2;
				}
				else if (uInt32_1 == 14)
				{
					i1 = 3;
				}
				int i2 = ((int) (pbValue - this.Pendant.D0Key));
				int i3 = Convert.ToInt32 (stringArray1[i1]);
				if (b1)
				{
					if (i3 > 9)
					{
						i3 /= 10;
					}
					else
					{
						i3 = 0;
					}
				}
				else if (i3 == 0)
				{
					i3 = i2;
				}
				else if (i3 <= 99)
				{
					i3 = ((int) ((i3 * 10) + i2));
				}
				if (i3 <= 255)
				{
					stringArray1[i1] = i3.ToString ();
				}
				if ((! b1) && (i3 > 99))
				{
					i4 = i1;
					switch (i4)
					{
						case 0:
						
						{
								pendantMenu1.CursorColumnPosition = 6;
								break;
						}
						case 1:
						
						{
								pendantMenu1.CursorColumnPosition = 10;
								break;
						}
						case 2:
						
						{
								pendantMenu1.CursorColumnPosition = 14;
								break;
						}
					}
				}
				bool b2 = true;
				foreach (string string1 in stringArray1)
				{
					if (b2)
					{
						this.m_strEditValue = string1;
						b2 = false;
					}
					else
					{
						this.m_strEditValue = (this.m_strEditValue + "." + string1);
					}
				}
			}
			
			private void InputNumberAction (byte pbValue)
			
			{
				if (pbValue == this.Pendant.EnterKey)
				{
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
					int i1 = this.MenuList.Add (this.InputAcceptMenu);
				}
				else if ((pbValue == this.Pendant.DeleteKey) || (pbValue == this.Pendant.BackspaceKey))
				{
					if (this.m_strEditValue.Length > 1)
					{
						this.m_strEditValue = this.m_strEditValue.Substring (0, ((int) (this.m_strEditValue.Length - 1)));
					}
					else if (this.m_strEditValue.Length <= 1)
					{
						this.m_strEditValue = "0";
					}
				}
				else if ((pbValue >= this.Pendant.D0Key) && (pbValue <= this.Pendant.D9Key))
				{
					if (this.m_strEditValue.Length < 20)
					{
						this.m_strEditValue = (this.m_strEditValue + ((char) pbValue).ToString ());
					}
				}
				else if (pbValue == this.Pendant.MinusKey)
				{
					if (this.m_strEditValue.Length == 0)
					{
						this.m_strEditValue = (this.m_strEditValue + ((char) pbValue).ToString ());
					}
					else if (this.m_strEditValue[0] != '0')
					{
						if (this.m_strEditValue[0] != '\u002D')
						{
							this.m_strEditValue = ("-" + this.m_strEditValue);
						}
						else if (this.m_strEditValue.Length == 1)
						{
							this.m_strEditValue = "";
						}
						else
						{
							this.m_strEditValue = this.m_strEditValue.Substring (1);
						}
					}
				}
			}
			
			private void InputPasswordAction (byte pbValue)
			
			{
				this.InputStringAction (pbValue);
			}
			
			private void InputStringAction (byte pbValue)
			
			{
				if (pbValue == this.Pendant.EnterKey)
				{
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
					int i1 = this.MenuList.Add (this.InputAcceptMenu);
				}
				else if ((pbValue == this.Pendant.DeleteKey) || (pbValue == this.Pendant.BackspaceKey))
				{
					if (this.m_strEditValue.Length != 0)
					{
						this.m_strEditValue = this.m_strEditValue.Substring (0, ((int) (this.m_strEditValue.Length - 1)));
					}
				}
				else if ((this.m_strEditValue.Length < 20) && this.Pendant.IsTextCharacter (pbValue))
				{
					this.m_strEditValue = (this.m_strEditValue + ((char) pbValue).ToString ());
				}
			}
			
			private void IP1WizAction (byte pbValue)
			
			{
				SubnetMask subnetMask1;
				Gateway gateway1;
				uint uInt32_1 = this.CommonMenuAction (pbValue);
				PendantMenu pendantMenu1 = ((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]);
				IPMode iPMode1 = new IPMode ();
				iPMode1.OnInputCommand += new InputCommandHandler (this.OnInputCommand);
				iPMode1.Description = PendantMenu.GetStringFromResource ("NetMode");
				if ((pbValue == this.Pendant.D1Key) || (uInt32_1 == 1))
				{
					pendantMenu1.SetSelection (1);
					this.pleaseWait = true;
					this.ShowPleaseWaitMessage ();
					if (iPMode1.Value.CompareTo (DHCPModeType.Static.ToString ()) == 0)
					{
						iPMode1.UpdateValue (DHCPModeType.Autodetect.ToString ());
					}
					else
					{
						iPMode1.UpdateValue (DHCPModeType.Static.ToString ());
					}
					this.restartRequired = true;
					this.pleaseWait = false;
				}
				else if ((pbValue == this.Pendant.D2Key) || (uInt32_1 == 2))
				{
					pendantMenu1.SetSelection (2);
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
					if (iPMode1.Value.CompareTo (DHCPModeType.Static.ToString ()) == 0)
					{
						this.m_oDataObject = ((IPendantInputData) new Address ());
						this.m_oDataObject.OnInputCommand += new InputCommandHandler (this.OnInputCommand);
						this.m_strEditValue = "";
						this.m_oDataObject.Description = PendantMenu.GetStringFromResource ("StaticAddress");
						int i1 = this.MenuList.Add (this.InputDisplayMenu);
						subnetMask1 = new SubnetMask ();
						subnetMask1.OnInputCommand += new InputCommandHandler (this.OnInputCommand);
						subnetMask1.Description = PendantMenu.GetStringFromResource ("SubnetMask");
						this.m_lstDataObject.Enqueue (subnetMask1);
						gateway1 = new Gateway ();
						gateway1.OnInputCommand += new InputCommandHandler (this.OnInputCommand);
						gateway1.Description = PendantMenu.GetStringFromResource ("Gateway");
						this.m_lstDataObject.Enqueue (gateway1);
					}
					else if (this.restartRequired)
					{
						int i2 = this.MenuList.Add (this.HardwareRestartMenu);
					}
				}
				this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
			}
			
			private void IP1WizBeforeDisplay ()
			
			{
				IPMode iPMode1 = new IPMode ();
				iPMode1.OnInputCommand += new InputCommandHandler (this.OnInputCommand);
				iPMode1.Description = PendantMenu.GetStringFromResource ("NetMode");
				bool b1 = (iPMode1.Value.CompareTo (DHCPModeType.Static.ToString ()) == 0);
				string string1 = PendantMenu.GetStringFromResource ((b1 ? "StaticIP" : "Autodetect"));
				string string2 = PendantMenu.GetStringFromResource ("Display2Instruct");
				string string3 = string.Format (string2, string1);
				this.IP1Wiz.UpdateTitle (0, string3);
				if (b1)
				{
					string2 = PendantMenu.GetStringFromResource ("SelectNext");
				}
				else
				{
					string2 = PendantMenu.GetStringFromResource ("SelectDone");
				}
				this.IP1Wiz.UpdateBody (1, string2);
			}
			
			private void IPMenuAction (byte pbValue)
			
			{
				uint uInt32_1 = this.CommonMenuAction (pbValue);
				PendantMenu pendantMenu1 = ((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]);
				if ((pbValue == this.Pendant.D1Key) || (uInt32_1 == 1))
				{
					pendantMenu1.SetSelection (1);
					int i1 = this.MenuList.Add (this.IP1Wiz);
				}
				else if ((pbValue == this.Pendant.D2Key) || (uInt32_1 == 2))
				{
					pendantMenu1.SetSelection (2);
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
				}
				this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
			}
			
			private void IPMenuBeforeDisplay ()
			
			{
				Address address1;
				IPMode iPMode1 = new IPMode ();
				iPMode1.OnInputCommand += new InputCommandHandler (this.OnInputCommand);
				iPMode1.Description = PendantMenu.GetStringFromResource ("NetMode");
				bool b1 = (iPMode1.Value.CompareTo (DHCPModeType.Static.ToString ()) == 0);
				string string1 = PendantMenu.GetStringFromResource ((b1 ? "StaticIP" : "Autodetect"));
				string string2 = PendantMenu.GetStringFromResource ("Display2Instruct");
				string string3 = string.Format (string2, string1);
				this.IPMenu.UpdateTitle (0, string3);
				if (b1)
				{
					address1 = new Address ();
					address1.OnInputCommand += new InputCommandHandler (this.OnInputCommand);
					address1.Description = PendantMenu.GetStringFromResource ("StaticAddress");
					string3 = string.Format (string2, address1.Value);
					this.IPMenu.UpdateTitle (1, string3);
				}
				else
				{
					this.IPMenu.UpdateTitle (1, "");
				}
			}
			
			private void JobModeMenuAction (byte pbValue)
			
			{
				uint uInt32_1 = this.CommonMenuAction (pbValue);
				PendantMenu pendantMenu1 = ((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]);
				if ((pbValue == this.Pendant.D1Key) || (uInt32_1 == 1))
				{
					pendantMenu1.SetSelection (1);
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
					int i1 = this.MenuList.Add (this.AskOnceJobMenu);
				}
				else if ((pbValue == this.Pendant.D2Key) || (uInt32_1 == 2))
				{
					pendantMenu1.SetSelection (2);
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
					int i2 = this.MenuList.Add (this.AskContinuousJobMenu);
				}
				else if ((pbValue == this.Pendant.D3Key) || (uInt32_1 == 3))
				{
					pendantMenu1.SetSelection (3);
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
				}
				this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
			}
			
			private void LocalPromptMenuAction (byte pbValue)
			
			{
				string[] stringArray1;
				string[] stringArray2;
				string[] stringArray3;
				uint uInt32_1 = this.CommonMenuAction (pbValue);
				PendantMenu pendantMenu1 = ((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]);
				if ((pbValue == this.Pendant.D1Key) || (uInt32_1 == 1))
				{
					pendantMenu1.SetSelection (1);
					stringArray1 = ((string[]) null);
					if (this.OnInputCommand != null)
					{
						stringArray3 = new string[] { APICommands.TakeHostControl.ToString () };
						stringArray2 = stringArray3;
						stringArray1 = this.OnInputCommand (this.ThisHostType, stringArray2);
					}
					if ((stringArray1 != null) && (stringArray1[0] == APIResponses.ACK.ToString ()))
					{
						this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
						this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
						int i1 = this.MenuList.Add (this.MainLocalMenu);
					}
					else
					{
						int i2 = this.MenuList.Add (this.ShowRunError (stringArray1[0]));
					}
				}
				else if ((pbValue == this.Pendant.D2Key) || (uInt32_1 == 2))
				{
					pendantMenu1.SetSelection (2);
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
				}
				this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
			}
			
			private void LocalPromptMenuBeforeDisplay ()
			
			{
				if (this.HostInControl == HostTypes.LANStream)
				{
					this.LocalPromptMenu.UpdateTitle (0, this.CurrentConnection);
				}
				else if (this.HostInControl == HostTypes.LAN)
				{
					this.LocalPromptMenu.UpdateTitle (0, this.CurrentConnection);
				}
				else if (this.HostInControl == HostTypes.GUI)
				{
					this.LocalPromptMenu.UpdateTitle (0, PendantMenu.GetStringFromResource ("GUITitle"));
				}
				else if (this.HostInControl == HostTypes.Bluetooth)
				{
					this.LocalPromptMenu.UpdateTitle (0, PendantMenu.GetStringFromResource ("BluetoothTitle"));
				}
				else if (this.HostInControl == HostTypes.RS232)
				{
					this.LocalPromptMenu.UpdateTitle (0, PendantMenu.GetStringFromResource ("RS232Title"));
				}
				string string1 = PendantMenu.GetStringFromResource ("AskLocalInstruct");
				string string2 = string.Format (string1, PendantMenu.GetStringFromResource ("AskLocalTitle"));
				this.LocalPromptMenu.UpdateTitle (1, string2);
			}
			
			private void MainLocalMenuAction (byte pbValue)
			
			{
				string[] stringArray1;
				string string1;
				string string2;
				string[] stringArray2;
				string[] stringArray3;
				string[] stringArray4;
				uint uInt32_1 = this.CommonMenuAction (pbValue);
				PendantMenu pendantMenu1 = ((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]);
				if ((pbValue == this.Pendant.D1Key) || (uInt32_1 == 1))
				{
					pendantMenu1.SetSelection (1);
					this.pleaseWait = true;
					this.ShowPleaseWaitMessage ();
					if (this.OnInputCommand != null)
					{
						stringArray4 = new string[] { APICommands.ReleaseHostControl.ToString () };
						stringArray1 = stringArray4;
						string[] stringArray5 = this.OnInputCommand (this.ThisHostType, stringArray1);
					}
					this.pleaseWait = false;
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
					int i1 = this.MenuList.Add (this.MainRemoteMenu);
				}
				else if ((pbValue == this.Pendant.D2Key) || (uInt32_1 == 2))
				{
					pendantMenu1.SetSelection (2);
					string1 = this.CurrentJobState;
					if (string1 == JobOpStatus.Busy.ToString ())
					{
						int i2 = this.MenuList.Add (this.RunningContinuousMenu);
					}
					else if (string1 == JobOpStatus.Idle.ToString ())
					{
						this.m_strSelectedJobFile = "";
						int i3 = this.MenuList.Add (this.ChooseFileSourceMenu);
					}
					else
					{
						pendantMenu1 = this.ShowRunError (string1);
						int i4 = this.MenuList.Add (pendantMenu1);
					}
				}
				else if ((pbValue == this.Pendant.D3Key) || (uInt32_1 == 3))
				{
					pendantMenu1.SetSelection (3);
					string2 = "";
					if (this.OnInputCommand != null)
					{
						stringArray4 = new string[] { APICommands.GetAdminPIN.ToString () };
						stringArray2 = stringArray4;
						stringArray3 = this.OnInputCommand (this.ThisHostType, stringArray2);
						if (stringArray3 != null)
						{
							string2 = stringArray3[0];
						}
					}
					switch (string2)
					{
						case "":
						
						{
								int i6 = this.MenuList.Add (this.AdvancedMenu);
								break;
						}
						default:
						
						{
								this.m_oDataObject = ((IPendantInputData) new AdminPasswordData ());
								this.m_oDataObject.OnInputCommand += new InputCommandHandler (this.OnInputCommand);
								this.m_oDataObject.Description = PendantMenu.GetStringFromResource ("AdminChallenge");
								this.m_strEditValue = "";
								int i5 = this.MenuList.Add (this.ChallengeAdminPasswordMenu);
								break;
						}
					}
				}
				this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
			}
			
			private void MainRemoteMenuAction (byte pbValue)
			
			{
				string[] stringArray1;
				string[] stringArray2;
				string string2;
				string[] stringArray3;
				string[] stringArray4;
				string string1 = "";
				if (this.OnInputCommand != null)
				{
					stringArray4 = new string[] { APICommands.GetUserPIN.ToString () };
					stringArray1 = stringArray4;
					stringArray2 = this.OnInputCommand (this.ThisHostType, stringArray1);
					if (stringArray2 != null)
					{
						string1 = stringArray2[0];
					}
				}
				switch (string1)
				{
					case "":
					
					{
							if (this.HostInControl != HostTypes.LANStream)
							{
								int i2 = this.MenuList.Add (this.LocalPromptMenu);
							}
							else
							{
								string2 = this.CurrentConnection;
								if ((string2.Length == 0) || (string2.CompareTo ("0.0.0.0") == 0))
								{
									this.pleaseWait = true;
									this.ShowPleaseWaitMessage ();
									if (this.OnInputCommand != null)
									{
										stringArray4 = new string[] { APICommands.TakeHostControl.ToString () };
										stringArray3 = stringArray4;
										string[] stringArray5 = this.OnInputCommand (this.ThisHostType, stringArray3);
									}
									this.pleaseWait = false;
									this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
									int i3 = this.MenuList.Add (this.MainLocalMenu);
								}
								else
								{
									int i4 = this.MenuList.Add (this.LocalPromptMenu);
								}
							}
							break;
					}
					default:
					
					{
							this.m_oDataObject = ((IPendantInputData) new UserPasswordData ());
							this.m_oDataObject.OnInputCommand += new InputCommandHandler (this.OnInputCommand);
							this.m_oDataObject.Description = PendantMenu.GetStringFromResource ("UserChallenge");
							this.m_strEditValue = "";
							int i1 = this.MenuList.Add (this.ChallengeUserPasswordMenu);
							break;
					}
				}
				this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
			}
			
			private void MainRemoteMenuBeforeDisplay ()
			
			{
				string string1;
				string string2;
				string string3;
				string string4;
				string string5;
				string string6;
				string[] stringArray1;
				if (this.HostInControl == HostTypes.Pendant)
				{
					stringArray1 = new string[] { PendantMenu.GetStringFromResource ("InTitle"), " ", PendantMenu.GetStringFromResource ("PendantTitle"), " ", PendantMenu.GetStringFromResource ("ModeTitle") };
					string1 = string.Concat (stringArray1);
					this.MainRemoteMenu.UpdateTitle (0, string1);
					this.MainRemoteMenu.UpdateTitle (1, "");
					this.MainRemoteMenu.UpdateTitle (2, "");
					return;
				}
				if (this.HostInControl == HostTypes.Bluetooth)
				{
					stringArray1 = new string[] { PendantMenu.GetStringFromResource ("InTitle"), " ", PendantMenu.GetStringFromResource ("BluetoothTitle"), " ", PendantMenu.GetStringFromResource ("ModeTitle") };
					string2 = string.Concat (stringArray1);
					this.MainRemoteMenu.UpdateTitle (0, string2);
					this.MainRemoteMenu.UpdateTitle (1, "");
					this.MainRemoteMenu.UpdateTitle (2, "");
					return;
				}
				if (this.HostInControl == HostTypes.GUI)
				{
					stringArray1 = new string[] { PendantMenu.GetStringFromResource ("InTitle"), " ", PendantMenu.GetStringFromResource ("GUITitle"), " ", PendantMenu.GetStringFromResource ("ModeTitle") };
					string3 = string.Concat (stringArray1);
					this.MainRemoteMenu.UpdateTitle (0, string3);
					this.MainRemoteMenu.UpdateTitle (1, "");
					this.MainRemoteMenu.UpdateTitle (2, "");
					return;
				}
				if (this.HostInControl == HostTypes.RS232)
				{
					stringArray1 = new string[] { PendantMenu.GetStringFromResource ("InTitle"), " ", PendantMenu.GetStringFromResource ("RS232Title"), " ", PendantMenu.GetStringFromResource ("ModeTitle") };
					string4 = string.Concat (stringArray1);
					this.MainRemoteMenu.UpdateTitle (0, string4);
					this.MainRemoteMenu.UpdateTitle (1, "");
					this.MainRemoteMenu.UpdateTitle (2, "");
					return;
				}
				if (this.HostInControl == HostTypes.LAN)
				{
					stringArray1 = new string[] { PendantMenu.GetStringFromResource ("InTitle"), " ", PendantMenu.GetStringFromResource ("LANTitle"), " ", PendantMenu.GetStringFromResource ("ModeTitle") };
					string5 = string.Concat (stringArray1);
					this.MainRemoteMenu.UpdateTitle (0, string5);
				}
				else if (this.HostInControl == HostTypes.LANStream)
				{
					stringArray1 = new string[] { PendantMenu.GetStringFromResource ("InTitle"), " ", PendantMenu.GetStringFromResource ("LANStreamTitle"), " ", PendantMenu.GetStringFromResource ("ModeTitle") };
					string6 = string.Concat (stringArray1);
					this.MainRemoteMenu.UpdateTitle (0, string6);
				}
				string string7 = this.CurrentConnection;
				if ((string7.Length == 0) || (string7.CompareTo ("0.0.0.0") == 0))
				{
					this.MainRemoteMenu.UpdateTitle (1, "ConnectionIdleTitle");
					this.MainRemoteMenu.UpdateTitle (2, "");
				}
				else
				{
					this.MainRemoteMenu.UpdateTitle (1, "ConnectedClientTitle");
					this.MainRemoteMenu.UpdateTitle (2, this.CurrentConnection);
				}
			}
			
			private void OffsetSettingMenuAction (byte pbValue)
			
			{
				uint uInt32_1 = this.CommonMenuAction (pbValue);
				PendantMenu pendantMenu1 = ((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]);
				if ((pbValue == this.Pendant.D1Key) || (uInt32_1 == 1))
				{
					pendantMenu1.SetSelection (1);
					this.m_oDataObject = ((IPendantInputData) new XOffset ());
					this.m_oDataObject.OnInputCommand += new InputCommandHandler (this.OnInputCommand);
					this.m_strEditValue = "";
					this.m_oDataObject.Description = PendantMenu.GetStringFromResource ("SelectOff1");
					int i1 = this.MenuList.Add (this.InputDisplayMenu);
				}
				else if ((pbValue == this.Pendant.D2Key) || (uInt32_1 == 2))
				{
					pendantMenu1.SetSelection (2);
					this.m_oDataObject = ((IPendantInputData) new YOffset ());
					this.m_oDataObject.OnInputCommand += new InputCommandHandler (this.OnInputCommand);
					this.m_strEditValue = "";
					this.m_oDataObject.Description = PendantMenu.GetStringFromResource ("SelectOff2");
					int i2 = this.MenuList.Add (this.InputDisplayMenu);
				}
				else if ((pbValue == this.Pendant.D3Key) || (uInt32_1 == 3))
				{
					pendantMenu1.SetSelection (3);
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
				}
				this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
			}
			
			public void OnInputIdle (string pstrValue)
			
			{
				string[] stringArray1;
				string[] stringArray2;
				string[] stringArray3;
				if ((this.MenuList.Count == 0) || this.pleaseWait)
				{
					return;
				}
				PendantMenu pendantMenu1 = ((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]);
				string string1 = "";
				if (this.OnInputCommand != null)
				{
					stringArray3 = new string[] { APICommands.GetLastError.ToString () };
					stringArray1 = stringArray3;
					stringArray2 = this.OnInputCommand (this.ThisHostType, stringArray1);
					if ((stringArray2 != null) && (stringArray2[0] != ""))
					{
						string1 = stringArray2[0];
					}
				}
				if (string1 != "ACK")
				{
					if (pendantMenu1 == this.HomeMenu)
					{
						this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
					}
					if (this.MenuList.Count > 0)
					{
						this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
					}
					int i1 = this.MenuList.Add (this.ShowRunError (string1));
					this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
				}
			}
			
			public void OnInputValue (byte pbValue)
			
			{
				if ((this.MenuList == null) || (this.MenuList.Count <= 0))
				{
					return;
				}
				PendantMenu pendantMenu1 = ((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]);
				pendantMenu1.Execute (pbValue);
			}
			
			public virtual void ReleaseControl ()
			
			{
				this.MenuList.Clear ();
				PendantMenu pendantMenu1 = this.MainRemoteMenu;
				int i1 = this.MenuList.Add (pendantMenu1);
				pendantMenu1 = this.HomeMenu;
				int i2 = this.MenuList.Add (pendantMenu1);
				this.DisplayMenu (pendantMenu1);
			}
			
			private void RunningContinuousMenuAction (byte pbValue)
			
			{
				uint uInt32_1 = this.CommonMenuAction (pbValue);
				if ((pbValue == this.Pendant.D1Key) || (uInt32_1 == 1))
				{
					int i1 = this.MenuList.Add (this.AskContinuousJobMenu);
				}
				this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
			}
			
			private void RunningContinuousMenuBeforeDisplay ()
			
			{
				if (this.m_strSelectedJobFile.Length == 0)
				{
					this.m_strSelectedJobFile = "LocalJob.wlb";
				}
				string string1 = (">" + Path.GetFileNameWithoutExtension (this.m_strSelectedJobFile));
				if (string1.Length > 20)
				{
					string1 = (string1.Substring (0, 17) + "...");
				}
				this.RunningContinuousMenu.UpdateTitle (0, string1);
				string string2 = PendantMenu.GetStringFromResource ("DisplayInstruct");
				string string3 = string.Format (string2, PendantMenu.GetStringFromResource ("RunningTitle"));
				this.RunningContinuousMenu.UpdateTitle (1, string3);
			}
			
			private void RunningOnceMenuAction (byte pbValue)
			
			{
				string string1;
				string[] stringArray1;
				string[] stringArray2;
				string[] stringArray3;
				uint uInt32_1 = this.CommonMenuAction (pbValue);
				bool b1 = false;
				if ((pbValue == this.Pendant.D1Key) || (uInt32_1 == 1))
				{
					string1 = JobOpStatus.Idle.ToString ();
					if (this.CurrentJobState != JobOpStatus.Busy.ToString ())
					{
						this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
					}
					else
					{
						if (this.OnInputCommand != null)
						{
							stringArray3 = new string[] { APICommands.Abort.ToString () };
							stringArray1 = stringArray3;
							stringArray2 = this.OnInputCommand (this.ThisHostType, stringArray1);
							if (stringArray2 != null)
							{
								string1 = stringArray2[0];
							}
						}
						if (string1 != APIResponses.ACK.ToString ())
						{
							int i1 = this.MenuList.Add (this.ShowRunError (string1));
						}
						else
						{
							this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
							b1 = true;
						}
					}
				}
				if (! b1)
				{
					this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
				}
			}
			
			private void RunningOnceMenuBeforeDisplay ()
			
			{
				if (this.m_strSelectedJobFile.Length == 0)
				{
					this.m_strSelectedJobFile = "LocalJob.wlb";
				}
				string string1 = (">" + Path.GetFileNameWithoutExtension (this.m_strSelectedJobFile));
				if (string1.Length > 20)
				{
					string1 = (string1.Substring (0, 17) + "...");
				}
				this.RunningOnceMenu.UpdateTitle (0, string1);
				string string2 = PendantMenu.GetStringFromResource ("DisplayInstruct");
				string string3 = string.Format (string2, PendantMenu.GetStringFromResource ("SentTitle"));
				this.RunningOnceMenu.UpdateTitle (1, string3);
			}
			
			private void SelectJobMenuAction (byte pbValue)
			
			{
				string[] stringArray1;
				string[] stringArray2;
				string[] stringArray3;
				string[] stringArray4;
				string[] stringArray5;
				uint uInt32_1 = this.CommonMenuAction (pbValue);
				if ((pbValue == this.Pendant.LeftKey) || (pbValue == this.Pendant.UpKey))
				{
					this.m_iCurrentFile--;
					if (this.m_iCurrentFile < 0)
					{
						this.m_iCurrentFile = 0;
					}
				}
				else if ((pbValue == this.Pendant.RightKey) || (pbValue == this.Pendant.DownKey))
				{
					this.m_iCurrentFile++;
					if (this.m_iCurrentFile >= this.m_lstJobFiles.Length)
					{
						this.m_iCurrentFile = (this.m_lstJobFiles.Length - 1);
					}
				}
				else if (pbValue == this.Pendant.EnterKey)
				{
					this.pleaseWait = true;
					this.ShowJobLoadPleaseWaitMessage ();
					if (this.m_iCurrentFile > (this.m_lstJobFiles.Length - 1))
					{
						this.m_iCurrentFile = (this.m_lstJobFiles.Length - 1);
					}
					this.m_strSelectedJobFile = this.m_lstJobFiles[this.m_iCurrentFile];
					stringArray5 = new string[] { APICommands.ClearJobList.ToString () };
					stringArray1 = stringArray5;
					string[] stringArray6 = this.OnInputCommand (this.ThisHostType, stringArray1);
					if (this.flashPath)
					{
						stringArray5 = new string[] { APICommands.LoadFlashJob.ToString (), this.m_strSelectedJobFile };
						stringArray3 = stringArray5;
						stringArray2 = this.OnInputCommand (this.ThisHostType, stringArray3);
					}
					else
					{
						stringArray5 = new string[] { APICommands.LoadUSBJob.ToString (), this.m_strSelectedJobFile };
						stringArray4 = stringArray5;
						stringArray2 = this.OnInputCommand (this.ThisHostType, stringArray4);
					}
					if ((stringArray2 != null) && (stringArray2[0] == APIResponses.ACK.ToString ()))
					{
						this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
						int i1 = this.MenuList.Add (this.JobModeMenu);
					}
					else
					{
						int i2 = this.MenuList.Add (this.ShowRunError (stringArray2[0]));
					}
					this.pleaseWait = false;
				}
				this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
			}
			
			private void SelectJobMenuBeforeDisplay ()
			
			{
				string string3;
				string string1 = PendantMenu.GetStringFromResource ("DisplayInstruct");
				if (this.m_iCurrentFile > (this.m_lstJobFiles.Length - 1))
				{
					this.m_iCurrentFile = (this.m_lstJobFiles.Length - 1);
				}
				string string2 = string.Format (string1, (">" + Path.GetFileNameWithoutExtension (this.m_lstJobFiles[this.m_iCurrentFile])));
				if (string2.Length > 20)
				{
					string2 = (string2.Substring (0, 17) + "...");
				}
				this.SelectJobMenu.UpdateTitle (0, string2);
				if (this.m_lstJobFiles.Length > 1)
				{
					if (this.m_iCurrentFile == 0)
					{
						string3 = PendantMenu.GetStringFromResource ("JobListBegin");
					}
					else if (this.m_iCurrentFile == (this.m_lstJobFiles.Length - 1))
					{
						string3 = PendantMenu.GetStringFromResource ("JobListEnd");
					}
					else
					{
						string3 = PendantMenu.GetStringFromResource ("JobListMiddle");
					}
					this.SelectJobMenu.UpdateTitle (3, string3);
				}
			}
			
			private PendantMenu ShowHardwareResetWarning ()
			
			{
				PendantMenu pendantMenu1 = this.UserInfoMenu;
				pendantMenu1.UpdateTitle (0, PendantMenu.GetStringFromResource ("HardwareWarning1"));
				pendantMenu1.UpdateTitle (1, PendantMenu.GetStringFromResource ("HardwareWarning2"));
				pendantMenu1.UpdateTitle (2, PendantMenu.GetStringFromResource ("HardwareWarning3"));
				pendantMenu1.UpdateBody (0, PendantMenu.GetStringFromResource ("SelectAcknowledge"));
				return pendantMenu1;
			}
			
			private void ShowJobLoadPleaseWaitMessage ()
			
			{
				string[] stringArray2 = new string[] { "LoadingJobTitle", "LoadingJobMessage", "PleaseWaitTitle" };
				string[] stringArray1 = stringArray2;
				PendantMenu pendantMenu1 = new PendantMenu (stringArray1, ((string[]) null), this.Pendant);
				this.DisplayMenu (pendantMenu1);
			}
			
			private PendantMenu ShowJobSearchError (string peError)
			
			{
				PendantMenu pendantMenu1 = this.UserInfoMenu;
				pendantMenu1.UpdateTitle (0, PendantMenu.GetStringFromResource ("ErrorJob"));
				if (peError == APIResponses.ERROR_NO_FILES_FOUND.ToString ())
				{
					pendantMenu1.UpdateTitle (1, PendantMenu.GetStringFromResource ("ErrorNoFiles"));
				}
				else if (peError == APIResponses.ERROR_NO_DRIVE.ToString ())
				{
					pendantMenu1.UpdateTitle (1, PendantMenu.GetStringFromResource ("ErrorNoDrive"));
				}
				return pendantMenu1;
			}
			
			private void ShowNoBreakMessage ()
			
			{
				string[] stringArray2 = new string[] { "NoBreakTitle1", "", "", "" };
				string[] stringArray1 = stringArray2;
				PendantMenu pendantMenu1 = new PendantMenu (stringArray1, ((string[]) null), this.Pendant);
				this.DisplayMenu (pendantMenu1);
			}
			
			private void ShowPasswordNoMatchMessage ()
			
			{
				string[] stringArray2 = new string[] { "NoMatchTitle1", "NoMatchTitle2", "", "NoMatchTitle3" };
				string[] stringArray1 = stringArray2;
				PendantMenu pendantMenu1 = new PendantMenu (stringArray1, ((string[]) null), this.Pendant);
				this.DisplayMenu (pendantMenu1);
			}
			
			private void ShowPleaseWaitMessage ()
			
			{
				string[] stringArray2 = new string[] { "PleaseWaitTitle" };
				string[] stringArray1 = stringArray2;
				PendantMenu pendantMenu1 = new PendantMenu (stringArray1, ((string[]) null), this.Pendant);
				this.DisplayMenu (pendantMenu1);
			}
			
			private void ShowRestartMessage ()
			
			{
				string[] stringArray2 = new string[] { "RestartTitle1", "PleaseWaitTitle", "", "" };
				string[] stringArray1 = stringArray2;
				PendantMenu pendantMenu1 = new PendantMenu (stringArray1, ((string[]) null), this.Pendant);
				this.DisplayMenu (pendantMenu1);
			}
			
			private PendantMenu ShowRunError (string peError)
			
			{
				PendantMenu pendantMenu1 = this.UserInfoMenu;
				pendantMenu1.UpdateTitle (0, PendantMenu.GetStringFromResource ("ErrorTitle"));
				if (peError == JobOpStatus.Idle.ToString ())
				{
					pendantMenu1.UpdateTitle (1, PendantMenu.GetStringFromResource ("ErrorIdle"));
				}
				else if (peError == JobOpStatus.NoJob.ToString ())
				{
					pendantMenu1.UpdateTitle (1, PendantMenu.GetStringFromResource ("ErrorNoJob"));
				}
				else if (peError == JobOpStatus.Busy.ToString ())
				{
					pendantMenu1.UpdateTitle (1, PendantMenu.GetStringFromResource ("ErrorBusy"));
				}
				else if (peError == JobOpStatus.JobException.ToString ())
				{
					pendantMenu1.UpdateTitle (1, PendantMenu.GetStringFromResource ("ErrorException"));
				}
				else
				{
					pendantMenu1.UpdateTitle (1, peError);
				}
				return pendantMenu1;
			}
			
			public virtual void StartHostAPI ()
			
			{
				PendantMenu pendantMenu1;
				this.Pendant.StartIdleTimer ();
				if (this.HostInControl == HostTypes.Pendant)
				{
					this.MenuList.Clear ();
					pendantMenu1 = this.MainLocalMenu;
					int i1 = this.MenuList.Add (pendantMenu1);
					pendantMenu1 = this.HomeMenu;
					int i2 = this.MenuList.Add (pendantMenu1);
					this.DisplayMenu (pendantMenu1);
					return;
				}
				this.MenuList.Clear ();
				PendantMenu pendantMenu2 = this.MainRemoteMenu;
				int i3 = this.MenuList.Add (pendantMenu2);
				pendantMenu2 = this.HomeMenu;
				int i4 = this.MenuList.Add (pendantMenu2);
				this.DisplayMenu (pendantMenu2);
			}
			
			private void UserAccessMenuAction (byte pbValue)
			
			{
				uint uInt32_1 = this.CommonMenuAction (pbValue);
				PendantMenu pendantMenu1 = ((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]);
				if ((pbValue == this.Pendant.D1Key) || (uInt32_1 == 1))
				{
					pendantMenu1.SetSelection (1);
					this.m_oDataObject = ((IPendantInputData) new UserPasswordData ());
					this.m_oDataObject.OnInputCommand += new InputCommandHandler (this.OnInputCommand);
					this.m_oDataObject.Description = PendantMenu.GetStringFromResource ("UserPassword");
					this.m_strEditValue = this.m_oDataObject.Value;
					int i1 = this.MenuList.Add (this.ChangePasswordMenu);
				}
				else if ((pbValue == this.Pendant.D2Key) || (uInt32_1 == 2))
				{
					pendantMenu1.SetSelection (2);
					this.m_oDataObject = ((IPendantInputData) new AdminPasswordData ());
					this.m_oDataObject.OnInputCommand += new InputCommandHandler (this.OnInputCommand);
					this.m_oDataObject.Description = PendantMenu.GetStringFromResource ("AdminPassword");
					this.m_strEditValue = this.m_oDataObject.Value;
					int i2 = this.MenuList.Add (this.ChangePasswordMenu);
				}
				else if ((pbValue == this.Pendant.D3Key) || (uInt32_1 == 3))
				{
					pendantMenu1.SetSelection (3);
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
				}
				this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
			}
			
			private void UserInfoMenuAction (byte pbValue)
			
			{
				uint uInt32_1 = this.CommonMenuAction (pbValue);
				if ((pbValue == this.Pendant.D1Key) || (uInt32_1 == 1))
				{
					this.MenuList.RemoveAt (((int) (this.MenuList.Count - 1)));
				}
				if (this.MenuList.Count == 0)
				{
					int i1 = this.MenuList.Add (this.HomeMenu);
				}
				this.DisplayMenu (((PendantMenu) this.MenuList[((int) (this.MenuList.Count - 1))]));
			}
			
		#endregion
	}
	
}

