//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:26:05
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LocalManager.Hosts.Utilities

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.General;
			using LanmarkControls.CommonLib.Protocol;
			using LanmarkControls.CommonLib.Threading;
			using System;
			using System.Runtime.InteropServices;
			using System.Threading;
			
		#endregion
		
	public class AliveThread : BaseTransmitThread
	
	{
		
		#region Fields
			private Timer m_oTimeout;
			private TimerCallback timerDelegate;
		#endregion
		
		#region Constructors
		
			public AliveThread ()
			
			{
				this.m_oTimeout = ((Timer) null);
				this.timerDelegate = ((TimerCallback) null);
				base.SendResponseAck = true;
				this.timerDelegate = new TimerCallback (this.AbortNotification);
				this.m_oTimeout = new Timer (this.timerDelegate, this, -1, -1);
			}
			
		#endregion
		
		#region Methods
		
			public void AbortNotification (object stateInfo)
			
			{
				bool b1 = this.m_oTimeout.Change (-1, -1);
				Logging.Instance.Log (4, "AliveThread.AbortNotification() - Starting the abort process.");
				this.InterruptWorkThread (true);
			}
			
			protected override bool Action (uint puiOpcode, byte[] pbyteData, out int piDataSent)
			
			{
				Logging.Instance.Log (4, "AliveThread.Action() called.");
				piDataSent = 0;
				if (puiOpcode != 3)
				{
					return false;
				}
				int i1 = BitConverter.ToInt32 (pbyteData, 0);
				piDataSent = 4;
				if (i1 != AtAliveReader.ID)
				{
					return true;
				}
				AtAliveReader atAliveReader1 = new AtAliveReader (pbyteData);
				piDataSent = pbyteData.Length;
				Logging.Instance.Log (4, ("AliveThread.Action() - received KeepAlive. Enable 0x03d " + atAliveReader1.Enable.ToString ()));
				if (atAliveReader1.Enable)
				{
					bool b2 = this.m_oTimeout.Change (((long) (((int) atAliveReader1.RetryTime) * 1000)), -1L);
				}
				return true;
			}
			
			protected override void InterruptWorkThread (bool pbAbort)
			
			{
				Logging.Instance.Log (4, "AliveThread.InterruptWorkThread() called.");
				base.AbortThisThread = pbAbort;
				base.InterruptWorkThread (pbAbort);
			}
			
			protected override bool TerminateWorkThread ()
			
			{
				bool b1 = this.m_oTimeout.Change (-1, -1);
				return base.TerminateWorkThread ();
			}
			
		#endregion
	}
	
}

