//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:26:05
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LocalManager.Hosts.Utilities

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.General;
			using LanmarkControls.CommonLib.Protocol;
			using LanmarkControls.CommonLib.Threading;
			using System.Net;
			using System.Net.Sockets;
			using System;
			using System.Runtime.InteropServices;
			using System.Threading;
			using Logging = LanmarkControls.CommonLib.General.Logging;
			
		#endregion
		
	public class BaseResponseThread : BaseThread
	
	{
		
		#region Fields
			private bool m_bAbort;
			private bool m_bWaitForResponse;
			private IPAddress m_ipConnectAddress;
			private TcpListener m_oListen;
			private uint m_uiConnectPort;
			private Socket oConnect;
		#endregion
		
		#region Constructors
		
			public BaseResponseThread ()
			
			{
				this.m_bWaitForResponse = false;
				this.oConnect = ((Socket) null);
				this.m_bAbort = false;
				this.m_ipConnectAddress = IPAddress.Parse ("127.0.0.1");
				this.m_uiConnectPort = 12200;
				this.m_oListen = ((TcpListener) null);
			}
			
		#endregion
		
		#region Properties
		
			protected bool Abort
			
			{
				get
				{
					return this.m_bAbort;
				}
				set
				{
					this.m_bAbort = value;
				}
			}
			
			
			public IPAddress ConnectAddress
			
			{
				get
				{
					return this.m_ipConnectAddress;
				}
				set
				{
					this.m_ipConnectAddress = value;
				}
			}
			
			
			public bool Connected
			
			{
				get
				{
					return (this.oConnect != null);
				}
			}
			
			
			public uint ConnectPort
			
			{
				get
				{
					return this.m_uiConnectPort;
				}
				set
				{
					this.m_uiConnectPort = value;
				}
			}
			
			
			protected bool WaitForResponse
			
			{
				get
				{
					return this.m_bWaitForResponse;
				}
				set
				{
					this.m_bWaitForResponse = value;
				}
			}
			
		#endregion
		
		#region Methods
		
			protected virtual bool Action (out uint puiOpcode, out byte[] pbyteData)
			
			{
				puiOpcode = uint.MinValue;
				pbyteData = new byte[0];
				return true;
			}
			
			private TransmitPacket BuildPacket (uint puiOpcode, byte[] pbytePacketData)
			
			{
				TransmitPacket transmitPacket1 = new TransmitPacket ();
				transmitPacket1.Address = IPAddress.Parse ("127.0.0.1");
				transmitPacket1.RequestAddress = IPAddress.Parse ("127.0.0.1");
				transmitPacket1.Opcode = puiOpcode;
				transmitPacket1.DataSize = ((uint) pbytePacketData.Length);
				transmitPacket1.Data = pbytePacketData;
				return transmitPacket1;
			}
			
			protected virtual bool ConnectionEstablished ()
			
			{
				return true;
			}
			
			protected override bool ExecuteWorkThread ()
			
			{
				uint uInt32_1;
				byte[] byteArray1;
				TransmitPacket transmitPacket1;
				byte[] byteArray2;
				int i1;
				Exception exception1;
				Exception exception2;
				try
				{
					Logging.Instance.Log (2, (this.ToString () + ".BaseResponseThread.ExecuteWorkThread() - Listening for a connection."));
					if (this.Abort)
					{
						Logging.Instance.Log ((this.ToString () + ".BaseResponseThread.ExecuteWorkThread() - An abort occurred while listening for "
						+ "a connection."));
						return false;
					}
					else
					{
						this.oConnect = this.PerformActionWhileWaiting ();
						if (this.oConnect == null)
						{
							Logging.Instance.Log ((this.ToString () + ".BaseResponseThread.ExecuteWorkThread() - Failed to accept Tcp client."));
							return false;
						}
						else
						{
							Logging.Instance.Log ((this.ToString () + ".BaseResponseThread.ExecuteWorkThread() - Connection accepted."));
							if (! this.ConnectionEstablished ())
							{
								Logging.Instance.Log ((this.ToString () + ".BaseResponseThread.ExecuteWorkThread() - ConnectionEstablished failed."));
								return false;
							}
							else
							{
								this.oConnect.SetSocketOption (SocketOptionLevel.Socket, SocketOptionName.DontLinger, 1);
								this.oConnect.SetSocketOption (SocketOptionLevel.Tcp, SocketOptionName.IPOptions, 1);
								while (! this.Abort)
								{
									if ((! this.Action (out uInt32_1, out byteArray1)) && (! this.Abort))
									{
										this.Abort = true;
									}
									if (((! this.Abort) && (byteArray1 != null)) && (byteArray1.Length > 0))
									{
										Logging.Instance.Log (2, (this.ToString () + ".BaseResponseThread.ExecuteWorkThread() - Action returned."));
										try
										{
											transmitPacket1 = this.BuildPacket (uInt32_1, byteArray1);
											byteArray2 = transmitPacket1.ToBytes ();
											int i2 = this.oConnect.Send (byteArray2);
											Logging.Instance.Log (2, (this.ToString () + ".BaseResponseThread.ExecuteWorkThread() - Wrote {0} bytes."), byteArray2.Length);
											if (this.WaitForResponse)
											{
												i1 = 0;
												while ((this.oConnect.Available == 0) && ((i1 < 5) && (! this.Abort)))
												{
													Logging.Instance.Log ((this.ToString () + ".BaseResponseThread.ExecuteWorkThread() - No data available.  Retry."));
													i1++;
													Thread.Sleep (0);
												}
												if (! this.Abort)
												{
													if (this.oConnect.Available <= 0)
													{
														Logging.Instance.Log ((this.ToString () + ".BaseResponseThread.ExecuteWorkThread() - No data available. Abort."));
														this.Abort = true;
														goto L_0262;
													}
													byteArray1 = new byte[4];
													while (this.oConnect.Available > 0)
													{
														int i3 = this.oConnect.Receive (byteArray1, byteArray1.Length, SocketFlags.None);
														Logging.Instance.Log ((this.ToString () + ".BaseResponseThread.ExecuteWorkThread() - Read {0} bytes."), byteArray1.Length);
													}
												}
												else
												{
													Logging.Instance.Log ((this.ToString () + ".BaseResponseThread.ExecuteWorkThread() - Connection aborted."));
												}
											}
											
										L_0262:
											
											{
											}
										}
										catch (Exception exception3)
										{
											exception1 = exception3;
											Logging.Instance.Log (0, (this.ToString () + ".BaseResponseThread.ExecuteWorkThread() - Exception thrown. Abort."));
											Logging.Instance.Log (0, exception1.ToString ());
											this.Abort = true;
										}
									}
								}
							}
						}
					}
				}
				catch (Exception exception4)
				{
					exception2 = exception4;
					Logging.Instance.Log (0, (this.ToString () + ".BaseResponseThread.ExecuteWorkThread() - Exception thrown. Abort."));
					Logging.Instance.Log (0, exception2.ToString ());
				}
				if (this.oConnect != null)
				{
					this.oConnect.Shutdown (SocketShutdown.Both);
					this.oConnect.Close ();
					this.oConnect = ((Socket) null);
				}
				return false;
			}
			
			protected override bool InitializeWorkThread ()
			
			{
				Exception exception1;
				this.Abort = false;
				try
				{
					this.m_oListen = new TcpListener (((int) this.m_uiConnectPort));
					this.m_oListen.Start ();
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, "Exception thrown while creating new TcpListener in BaseResponseThread.");
					Logging.Instance.Log (0, exception1.ToString ());
					this.m_oListen = ((TcpListener) null);
					return false;
				}
				return base.InitializeWorkThread ();
			}
			
			protected override void InterruptWorkThread (bool pbAbort)
			
			{
				Exception exception1;
				if (pbAbort)
				{
					try
					{
						if (this.m_oListen != null)
						{
							this.m_oListen.Stop ();
							this.m_oListen = ((TcpListener) null);
						}
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						Logging.Instance.Log (0, "Exception thrown in InterruptWorkThread while Listening.");
						Logging.Instance.Log (0, exception1.ToString ());
						this.m_oListen = ((TcpListener) null);
					}
				}
				base.InterruptWorkThread (pbAbort);
			}
			
			protected virtual Socket PerformActionWhileWaiting ()
			
			{
				uint uInt32_1;
				byte[] byteArray1;
				if (this.m_oListen == null)
				{
					return null;
				}
				while (! this.m_oListen.Pending ())
				{
					if ((! this.Action (out uInt32_1, out byteArray1)) && (! this.Abort))
					{
						this.Abort = true;
					}
					if (this.Abort)
					{
						Logging.Instance.Log ((this.ToString () + ".BaseResponseThread.ActionWait() - An abort occurred while listening for a conne"
						+ "ction."));
						return null;
					}
				}
				Socket socket1 = this.m_oListen.AcceptSocket ();
				this.m_oListen.Stop ();
				this.m_oListen = ((TcpListener) null);
				return socket1;
			}
			
			protected override bool TerminateWorkThread ()
			
			{
				Exception exception1;
				try
				{
					if (this.m_oListen != null)
					{
						this.m_oListen.Stop ();
						this.m_oListen = ((TcpListener) null);
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, "Exception thrown in TerminateWorkThread in BaseResponseThread.");
					Logging.Instance.Log (0, exception1.ToString ());
					this.m_oListen = ((TcpListener) null);
				}
				return base.TerminateWorkThread ();
			}
			
		#endregion
	}
	
}

