//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:26:05
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LocalManager.Hosts.Utilities

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.General;
			using LanmarkControls.CommonLib.Protocol;
			using LanmarkControls.CommonLib.Threading;
			using LanmarkControls.LECHardwareAbstraction;
			using LanmarkControls.LocalManager;
			using System.Collections;
			using System;
			using System.IO;
			using System.Net;
			using System.Runtime.InteropServices;
			using System.Threading;
			using Logging = LanmarkControls.CommonLib.General.Logging;
			
		#endregion
		
	public class DataThread : BaseTransmitThread, IDisposable
	
	{
		
		#region Fields
			private bool m_bAborting;
			private bool m_bEndOfAbortFound;
			private bool m_bExecuting;
			private bool m_bMessagesDisabled;
			private ClientConnectionStatus m_enumCurrentStatus;
			private int m_iDuplicateCount;
			private int m_iLastError;
			private int m_iRepeatCount;
			private Queue m_oQueue;
			private BinaryWriter m_oWriter;
			private string m_strConnectAddress;
			public event MessagesEventHandler MessagesNotify;
			public event UpdateClientInfoHandler OnUpdateClientInfo;
		#endregion
		
		#region Constructors
		
			public DataThread ()
			
			{
				this.m_oWriter = ((BinaryWriter) null);
				this.m_bEndOfAbortFound = false;
				this.m_bAborting = false;
				this.m_oQueue = new Queue ();
				this.m_bExecuting = false;
				this.m_bMessagesDisabled = false;
				this.m_iRepeatCount = -1;
				this.m_iDuplicateCount = 0;
				this.m_enumCurrentStatus = ClientConnectionStatus.Startup;
				this.m_strConnectAddress = "0.0.0.0";
				this.m_iLastError = 0;
				this.Create ();
			}
			
		#endregion
		
		#region Properties
		
			protected bool Aborting
			
			{
				get
				{
					return this.m_bAborting;
				}
			}
			
			
			public ClientConnectionStatus CurrentStatus
			
			{
				get
				{
					return this.m_enumCurrentStatus;
				}
			}
			
			
			protected int DuplicateCount
			
			{
				get
				{
					return this.m_iDuplicateCount;
				}
				set
				{
					this.m_iDuplicateCount = value;
				}
			}
			
			
			protected bool EndOfAbortFound
			
			{
				get
				{
					return this.m_bEndOfAbortFound;
				}
				set
				{
					this.m_bEndOfAbortFound = value;
				}
			}
			
			
			protected bool Executing
			
			{
				get
				{
					return this.m_bExecuting;
				}
				set
				{
					this.m_bExecuting = value;
				}
			}
			
			
			public bool MessagesDisabled
			
			{
				get
				{
					return this.m_bMessagesDisabled;
				}
				set
				{
					this.m_bMessagesDisabled = value;
				}
			}
			
			
			protected int RepeatCount
			
			{
				get
				{
					return this.m_iRepeatCount;
				}
				set
				{
					this.m_iRepeatCount = value;
				}
			}
			
		#endregion
		
		#region Methods
		
			public void AbortCompleteNotification ()
			
			{
				Exception exception1;
				Logging.Instance.Log (4, "DataThread.AbortCompleteNotification() called.");
				try
				{
					this.EndOfAbortFound = true;
					if (! base.Connected)
					{
						LECHAL.Instance.FPGAAbortState = false;
					}
					this.SetConnectionStatus (((string) null), ClientConnectionStatus.Wait);
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("DataThread.AbortCompleteNotification() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
				}
			}
			
			public bool AbortFPGA ()
			
			{
				LECHAL.ResetType resetType1;
				Exception exception1;
				Logging.Instance.Log (4, "DataThread.AbortFPGA() called.");
				try
				{
					if (LECHAL.Instance.FPGAAbortState)
					{
						Logging.Instance.Log (4, "DataThread.AbortFPGA() - FPGA is already aborting.  Return true.");
						return true;
					}
					else
					{
						LECHAL.Instance.FPGAAbortState = true;
						if (LECHAL.Instance.FPGASendingData)
						{
							Logging.Instance.Log (4, "DataThread.AbortFPGA() - Yield to FPGA.SendData() to abort.");
							return false;
						}
						else
						{
							Logging.Instance.Log (4, "DataThread.AbortFPGA() - Attempting to abort.");
							resetType1 = LECHAL.Instance.ResetFPGA ();
							Logging.Instance.Log (("DataThread.AbortFPGA() - " + LECHAL.Instance.FPGAMessageLog));
							if (resetType1 == LanmarkControls.LECHardwareAbstraction.LECHAL.ResetType.Complete)
							{
								this.AbortCompleteNotification ();
							}
						}
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("DataThread.AbortFPGA() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
					return false;
				}
				return true;
			}
			
			public void AbortNotification (object sender, AbortEventArgs e)
			
			{
				bool b1;
				Exception exception1;
				Logging.Instance.Log (4, "DataThread.AbortNotification() called.");
				try
				{
					b1 = this.AbortFPGA ();
					if (e.Reason != AbortReason.Terminate)
					{
						this.SetConnectionStatus (((string) null), ClientConnectionStatus.Wait);
					}
					else
					{
						if (b1)
						{
							base.AbortThisThread = true;
						}
						this.m_bAborting = true;
						this.SetConnectionStatus ("", ClientConnectionStatus.Aborting);
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("DataThread.AbortNotification() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
				}
			}
			
			protected override bool Action (uint puiOpcode, byte[] pbyteData, out int piDataSent)
			
			{
				bool b1;
				LECHAL.ResetType resetType1;
				AtAbortReader atAbortReader1;
				Exception exception1;
				Logging.Instance.Log (4, "DataThread.Action() called.");
				piDataSent = 0;
				try
				{
					if (this.CheckIfAbortCompleted ())
					{
						this.SetConnectionStatus (((string) null), ClientConnectionStatus.Connected);
					}
					if ((puiOpcode == 4) || (puiOpcode == 13))
					{
						Logging.Instance.Log (4, "DataThread.Action() - Detected Job Data.");
						if (LECHAL.Instance.FPGAAbortState)
						{
							piDataSent = pbyteData.Length;
							Logging.Instance.Log ("DataThread.Action() - Ignoring {0} bytes.", piDataSent);
							Logging.Instance.Log (4, "DataThread.Action() called complete.");
							return true;
						}
						else
						{
							b1 = this.SendFixedDataFiles ();
							if (b1)
							{
								piDataSent = pbyteData.Length;
								Logging.Instance.Log (4, ("DataThread.Action() - " + LECHAL.Instance.FPGAMessageLog));
								if (piDataSent == 0)
								{
									Logging.Instance.Log (4, "DataThread.Action() called complete.");
									return false;
								}
								else
								{
									if (AdminSettings.DataSettings.EnableStreamToFile)
									{
										if (this.m_oWriter == null)
										{
											this.m_oWriter = new BinaryWriter (((Stream) File.Open (Path.Combine (CommonSvrUtil.FullConfigPath, ("Job_" + AdminSettings.DataSettings.StreamFile)), FileMode.Create)));
										}
										if (this.m_oWriter != null)
										{
											this.m_oWriter.Write (pbyteData, 0, piDataSent);
										}
									}
									b1 = LECHAL.Instance.SendFPGAStreamData (pbyteData, piDataSent);
									if (b1)
									{
										Logging.Instance.Log ("DataThread.Action() - Wrote {0} bytes.", piDataSent);
									}
									else
									{
										Logging.Instance.Log (("DataThread.Action() - " + LECHAL.Instance.FPGAMessageLog));
									}
								}
							}
							if (b1 && (puiOpcode != 13))
							{
								b1 = this.SendFixedDataFiles ();
							}
							if (! b1)
							{
								resetType1 = LECHAL.Instance.ResetFPGA ();
								Logging.Instance.Log (("DataThread.Action() - " + LECHAL.Instance.FPGAMessageLog));
								b1 = (LECHAL.Instance.FPGAAbortState && (! this.m_bAborting));
								if (resetType1 == LanmarkControls.LECHardwareAbstraction.LECHAL.ResetType.Complete)
								{
									this.AbortCompleteNotification ();
								}
							}
							Logging.Instance.Log (4, "DataThread.Action() called complete.");
							return b1;
						}
					}
					else if (puiOpcode != 3)
					{
						Logging.Instance.Log (4, "DataThread.Action() - Detected Unknown Data.");
					}
					else
					{
						Logging.Instance.Log (4, "DataThread.Action() - Detected Action Data.");
						if (BitConverter.ToInt32 (pbyteData, 0) == AtAbortReader.ID)
						{
							Logging.Instance.Log (4, "DataThread.Action() - Detected Abort Action Data.");
							atAbortReader1 = new AtAbortReader (pbyteData);
							piDataSent = pbyteData.Length;
							if (atAbortReader1.Reason == AbortReason.Job)
							{
								Logging.Instance.Log ("DataThread.Action() - Received AbortReason.Job marking EndOfAbortedData.");
								LECHAL.Instance.FPGAAbortState = false;
								if (this.EndOfAbortFound)
								{
									this.EndOfAbortFound = false;
									this.SetConnectionStatus (((string) null), ClientConnectionStatus.Connected);
								}
							}
							Logging.Instance.Log (4, "DataThread.Action() called complete.");
							return true;
						}
						else
						{
							Logging.Instance.Log (4, "DataThread.Action() - Detected Unknown Action Data.");
						}
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("DataThread.Action() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
				}
				Logging.Instance.Log (4, "DataThread.Action() called complete.");
				return false;
			}
			
			private bool CheckIfAbortCompleted ()
			
			{
				Exception exception1;
				try
				{
					if (this.EndOfAbortFound && (! LECHAL.Instance.FPGAAbortState))
					{
						Logging.Instance.Log (4, "DataThread.CheckIfCompleted() - completion detected.");
						this.EndOfAbortFound = false;
						return true;
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("DataThread.CheckIfCompleted() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
				}
				return false;
			}
			
			private bool CheckSendFixedDataFiles ()
			
			{
				bool b1;
				Exception exception1;
				try
				{
					if ((this.m_oQueue.Count == 0) || LECHAL.Instance.FPGAAbortState)
					{
						return false;
					}
					else
					{
						b1 = this.SendFixedDataFiles ();
						if (! b1)
						{
							b1 = (LECHAL.Instance.FPGAAbortState && (! this.m_bAborting));
						}
						return b1;
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("DataThread.CheckSendDataFiles() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
				}
				return false;
			}
			
			protected override void ConnectionEstablished (IPAddress pipAddress)
			
			{
				Exception exception1;
				Logging.Instance.Log (4, "DataThread.ConnectionEstablished() called.");
				try
				{
					this.SetConnectionStatus (pipAddress.ToString (), ClientConnectionStatus.Connected);
					this.m_iLastError = 0;
					base.ConnectionEstablished (pipAddress);
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("DataThread.ConnectionEstablished() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
				}
			}
			
			protected override bool ConnectionLost (IPAddress pipAddress)
			
			{
				Exception exception1;
				Logging.Instance.Log (4, "DataThread.ConnectionLost() called.");
				try
				{
					this.PrepareAbortConnection ();
					bool b2 = base.ConnectionLost (pipAddress);
					LECHAL.Instance.FPGAAbortState = false;
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("DataThread.ConnectionLost() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
					return false;
				}
				return true;
			}
			
			protected override void ConnectionWait ()
			
			{
				Exception exception1;
				try
				{
					base.ConnectionWait ();
					this.SetConnectionStatus (((string) null), ClientConnectionStatus.Available);
					bool b1 = this.CheckSendFixedDataFiles ();
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("DataThread.ConnectionWait() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
				}
			}
			
			protected void Create ()
			
			{
				Logging.Instance.LogFile = "DataThread.txt";
				this.SetConnectionStatus ("", ClientConnectionStatus.Startup);
				base.MaxBufferSize = ((int) LECHAL.Instance.GetOptimumSegmentSize ());
			}
			
			public virtual void Dispose ()
			
			{
				if (this.m_oWriter != null)
				{
					this.m_oWriter.Close ();
					this.m_oWriter = ((BinaryWriter) null);
				}
			}
			
			public void ExceptionMessageNotification (int piMessage)
			
			{
				Exception exception1;
				Logging.Instance.Log (4, "DataThread.ExceptionMessageNotification() called.");
				try
				{
					this.m_iLastError = piMessage;
					if (this.OnUpdateClientInfo != null)
					{
						this.OnUpdateClientInfo (this.m_enumCurrentStatus, "Remote PC", this.m_strConnectAddress, this.m_iLastError);
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("DataThread.ExceptionMessageNotification() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
				}
			}
			
			protected override bool ExecuteWorkThread ()
			
			{
				Exception exception1;
				this.Executing = true;
				bool b1 = false;
				try
				{
					if (this.MessagesDisabled)
					{
						this.MessagesNotify (true);
						this.MessagesDisabled = false;
					}
					b1 = base.ExecuteWorkThread ();
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("DataThread.ExecuteWorkThread() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
					b1 = false;
				}
				this.Executing = false;
				return b1;
			}
			
			public void GetAddress (out string pstrAddress)
			
			{
				pstrAddress = this.m_strConnectAddress;
			}
			
			public void GetLastError (out int piLastError)
			
			{
				piLastError = this.m_iLastError;
			}
			
			public void GetStatus (out ClientConnectionStatus penumType)
			
			{
				penumType = this.m_enumCurrentStatus;
			}
			
			public bool Initialize ()
			
			{
				LECHAL.ResetType resetType1;
				Exception exception1;
				Logging.Instance.Log (4, "DataThread.Intialize() called.");
				bool b1 = true;
				try
				{
					resetType1 = LECHAL.Instance.ResetFPGA ();
					Logging.Instance.Log ("DataThread.Initialize() - ");
					if (resetType1 == LanmarkControls.LECHardwareAbstraction.LECHAL.ResetType.Failed)
					{
						return false;
					}
					else
					{
						this.EndOfAbortFound = true;
						Logging.Instance.Log (4, "DataThread.Intialize() call completed.");
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("DataThread.Initialize() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
					b1 = false;
				}
				return b1;
			}
			
			protected override bool InitializeWorkThread ()
			
			{
				Exception exception1;
				Logging.Instance.Log (4, "DataThread.IntializeWorkThread() called.");
				bool b1 = true;
				try
				{
					this.SetConnectionStatus ("", ClientConnectionStatus.Startup);
					if (! base.InitializeWorkThread ())
					{
						return false;
					}
					else
					{
						b1 = this.Initialize ();
						if (! b1)
						{
							bool b3 = base.TerminateWorkThread ();
						}
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("DataThread.InitializeWorkThread() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
					b1 = false;
				}
				return b1;
			}
			
			protected override void InterruptWorkThread (bool pbAbort)
			
			{
				Exception exception1;
				Logging.Instance.Log (4, "DataThread.InterruptWorkThread() called.");
				try
				{
					base.AbortThisThread = pbAbort;
					if (base.AbortThisThread)
					{
						this.m_bAborting = true;
					}
					if (LECHAL.Instance.FPGASendingData)
					{
						LECHAL.Instance.FPGAAbortState = true;
					}
					base.InterruptWorkThread (pbAbort);
					Logging.Instance.Log (4, ("DataThread.InterruptWorkThread() - Abort 0x03d " + base.AbortThisThread.ToString ()));
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("DataThread.InterruptWorkThread() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
				}
			}
			
			protected override void PerformActionWhileWaiting ()
			
			{
				Exception exception1;
				try
				{
					base.PerformActionWhileWaiting ();
					if (this.CheckIfAbortCompleted ())
					{
						this.SetConnectionStatus (((string) null), ClientConnectionStatus.Connected);
					}
					bool b1 = this.CheckSendFixedDataFiles ();
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("DataThread.ActionWait() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
				}
			}
			
			public void PrepareAbortConnection ()
			
			{
				Exception exception1;
				Logging.Instance.Log (4, "DataThread.PrepareAbortConnection() called.");
				try
				{
					this.SetConnectionStatus ("", ClientConnectionStatus.Aborting);
					LECHAL.Instance.FPGAAbortState = true;
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("DataThread.PrepareAbortConnection() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
				}
			}
			
			private bool SendFixedDataFiles ()
			
			{
				bool b2;
				ClientConnectionStatus clientConnectionStatus1;
				string string1;
				Exception exception1;
				Queue queue1;
				Logging.Instance.Log (4, "DataThread.SendFixedDataFiles() called.");
				bool b1 = true;
				try
				{
					b2 = false;
					clientConnectionStatus1 = this.m_enumCurrentStatus;
					if (this.m_oQueue.Count > 0)
					{
						this.SetConnectionStatus (((string) null), ClientConnectionStatus.Wait);
						b2 = true;
					}
					
				L_011A:
					
					{
					}
					if ((this.m_oQueue.Count > 0) && b1)
					{
						queue1 = this.m_oQueue;
						lock (queue1)
						{
							string1 = ((string) this.m_oQueue.Peek ());
						}
						if (! string1.StartsWith ("<?xml"))
						{
							Logging.Instance.Log ("DataThread.SendDataFiles() - Configuration file updated:");
							Logging.Instance.Log (("DataThread.SendDataFiles() - " + string1));
							b1 = LECHAL.Instance.ProcessDataFile (string1);
						}
						else
						{
							Logging.Instance.Log ("DataThread.SendDataFiles() - Information found:");
							Logging.Instance.Log (("DataThread.SendDataFiles() - " + string1));
							b1 = LECHAL.Instance.ProcessInformation (string1);
						}
						if (! b1)
						{
							Logging.Instance.Log ("DataThread.SendDataFiles() - Error. Queue data failed to be processed.");
						}
						else
						{
							queue1 = this.m_oQueue;
							lock (queue1)
							{
								object object1 = this.m_oQueue.Dequeue ();
							}
							Logging.Instance.Log ("DataThread.SendDataFiles() - Successfully processed queue data.");
						}
						goto L_011A;
					}
					else if (b2)
					{
						this.SetConnectionStatus (((string) null), clientConnectionStatus1);
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("DataThread.SendDataFiles() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
					b1 = false;
				}
				Logging.Instance.Log (4, "DataThread.SendDataFiles() called complete.");
				return b1;
			}
			
			private void SetConnectionStatus (string pstrIPAddress, ClientConnectionStatus penumStatus)
			
			{
				string string1;
				Exception exception1;
				try
				{
					this.m_enumCurrentStatus = penumStatus;
					if (pstrIPAddress != null)
					{
						if (pstrIPAddress.Length <= 0)
						{
							this.m_strConnectAddress = "0.0.0.0";
						}
						else
						{
							this.m_strConnectAddress = pstrIPAddress.ToString ();
						}
					}
					if (pstrIPAddress == null)
					{
						Logging.Instance.Log ("DataThread.SetConnectionStatus() - Address unchanged - status 0x03d {0}.", ((int) penumStatus));
					}
					else
					{
						string1 = ("DataThread.SetConnectionStatus() - Address: " + pstrIPAddress + " - status 0x03d {0}.");
						Logging.Instance.Log (string1, ((int) penumStatus));
					}
					if (this.OnUpdateClientInfo != null)
					{
						this.OnUpdateClientInfo (this.m_enumCurrentStatus, "Remote PC", this.m_strConnectAddress, this.m_iLastError);
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("DataThread.SetConnectionStatus() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
				}
			}
			
			public void UpdateNotification (object sender, UpdateEventArgs e)
			
			{
				int i1;
				string string1;
				Exception exception1;
				Queue queue1;
				Logging.Instance.Log (4, "DataThread.UpdateNotification() called.");
				try
				{
					if (e.AdditionalInfo.Length > 0)
					{
						queue1 = this.m_oQueue;
						lock (queue1)
						{
							this.m_oQueue.Enqueue (e.AdditionalInfo);
						}
						Logging.Instance.Log (4, ("DataThread.UpdateNotification() - Additional Info 0x03d " + e.AdditionalInfo));
					}
					for (i1 = 0; (i1 < e.FileCount); i1++)
					{
						if (base.AbortThisThread)
						{
							return;
						}
						string1 = e.GetFile (i1);
						if (string1.Length > 0)
						{
							queue1 = this.m_oQueue;
							lock (queue1)
							{
								this.m_oQueue.Enqueue (string1);
							}
						}
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("DataThread.UpdateNotification() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
				}
			}
			
		#endregion
	}
	
}

