//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:26:05
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LocalManager.Hosts.Utilities

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonInteropLib.PInvoke;
			using LanmarkControls.CommonLib.General;
			using LanmarkControls.CommonLib.Protocol;
			using LanmarkControls.CommonLib.Threading;
			using LanmarkControls.LECHardwareAbstraction.FPGAInterface;
			using LanmarkControls.LECHardwareAbstraction;
			using System.Collections;
			using System.Net;
			using System.Net.Sockets;
			using System;
			using System.Runtime.InteropServices;
			using System.Threading;
			using Logging = LanmarkControls.CommonLib.General.Logging;
			
		#endregion
		
	public class EventThread : BaseResponseThread
	
	{
		
		#region Fields
			public event AbortCompleteEventHandler AbortCompleteNotify;
			public event ExceptionMessageEventHandler ExceptionMessageNotify;
			private bool m_bMessagesEnabled;
			private IAsyncResult m_iListenResult;
			private AutoResetEvent m_oContentAvailable;
			private FixDataMsgThread m_oFixDataMsg;
			private JobExceptMsgThread m_oJobExceptMsg;
			private JobMarkerMsgThread m_oJobMarkerMsg;
			private JobMsgThread m_oJobMsg;
			private Socket m_oListen;
			private Socket m_oListenResult;
			private RegistersThread m_oRegisters;
			private string m_strEventExceptionName;
			private string m_strEventName;
		#endregion
		
		#region Constructors
		
			public EventThread ()
			
			{
				this.m_oContentAvailable = new AutoResetEvent (false);
				this.m_oListen = ((Socket) null);
				this.m_oListenResult = ((Socket) null);
				this.m_iListenResult = ((IAsyncResult) null);
				this.m_oJobMsg = ((JobMsgThread) null);
				this.m_oJobExceptMsg = ((JobExceptMsgThread) null);
				this.m_oJobMarkerMsg = ((JobMarkerMsgThread) null);
				this.m_oRegisters = ((RegistersThread) null);
				this.m_oFixDataMsg = ((FixDataMsgThread) null);
				this.m_bMessagesEnabled = false;
				this.m_strEventName = "";
				this.m_strEventExceptionName = "";
				Logging.Instance.LogFile = "EventThread.txt";
				this.m_oJobMsg = new JobMsgThread (this.m_oContentAvailable);
				this.m_oJobExceptMsg = new JobExceptMsgThread (this.m_oContentAvailable);
				this.m_oJobMarkerMsg = new JobMarkerMsgThread (this.m_oContentAvailable);
				this.m_oRegisters = new RegistersThread (this.m_oContentAvailable);
				this.m_oFixDataMsg = new FixDataMsgThread (this.m_oContentAvailable);
			}
			
		#endregion
		
		#region Properties
		
			public bool MessagesEnabled
			
			{
				get
				{
					return this.m_bMessagesEnabled;
				}
				set
				{
					this.m_bMessagesEnabled = (value && base.Connected);
				}
			}
			
		#endregion
		
		#region Methods
		
			public void AbortNotification (object sender, AbortEventArgs e)
			
			{
				Logging.Instance.Log (4, "EventThread.AbortNotification() called.");
				if (this.MessagesEnabled)
				{
					this.MessagesEnabled = false;
				}
			}
			
			protected override bool Action (out uint puiOpcode, out byte[] pbyteData)
			
			{
				ArrayList arrayList1;
				Exception exception1;
				Logging.Instance.Log (4, "EventThread.Action() called.");
				puiOpcode = uint.MinValue;
				pbyteData = new byte[0];
				try
				{
					arrayList1 = new ArrayList ();
					if (this.m_oJobExceptMsg != null)
					{
						while (this.m_oJobExceptMsg.Content.Count > 0)
						{
							int i1 = arrayList1.Add (this.m_oJobExceptMsg.Content.Dequeue ());
						}
					}
					if (this.m_oJobMarkerMsg != null)
					{
						while (this.m_oJobMarkerMsg.Content.Count > 0)
						{
							int i2 = arrayList1.Add (this.m_oJobMarkerMsg.Content.Dequeue ());
						}
					}
					if (this.m_oJobMsg != null)
					{
						while (this.m_oJobMsg.Content.Count > 0)
						{
							int i3 = arrayList1.Add (this.m_oJobMsg.Content.Dequeue ());
						}
					}
					if (this.m_oRegisters != null)
					{
						while (this.m_oRegisters.Content.Count > 0)
						{
							int i4 = arrayList1.Add (this.m_oRegisters.Content.Dequeue ());
						}
					}
					if (this.m_oFixDataMsg != null)
					{
						while (this.m_oFixDataMsg.Content.Count > 0)
						{
							int i5 = arrayList1.Add (this.m_oFixDataMsg.Content.Dequeue ());
						}
					}
					if (arrayList1.Count == 0)
					{
						bool b2 = this.m_oContentAvailable.WaitOne ();
						if (base.Abort)
						{
							return false;
						}
						else
						{
							if (this.m_oJobExceptMsg != null)
							{
								while (this.m_oJobExceptMsg.Content.Count > 0)
								{
									int i6 = arrayList1.Add (this.m_oJobExceptMsg.Content.Dequeue ());
								}
							}
							if (this.m_oJobMarkerMsg != null)
							{
								while (this.m_oJobMarkerMsg.Content.Count > 0)
								{
									int i7 = arrayList1.Add (this.m_oJobMarkerMsg.Content.Dequeue ());
								}
							}
							if (this.m_oJobMsg != null)
							{
								while (this.m_oJobMsg.Content.Count > 0)
								{
									int i8 = arrayList1.Add (this.m_oJobMsg.Content.Dequeue ());
								}
							}
							if (this.m_oRegisters != null)
							{
								while (this.m_oRegisters.Content.Count > 0)
								{
									int i9 = arrayList1.Add (this.m_oRegisters.Content.Dequeue ());
								}
							}
							if (this.m_oFixDataMsg != null)
							{
								while (this.m_oFixDataMsg.Content.Count > 0)
								{
									int i10 = arrayList1.Add (this.m_oFixDataMsg.Content.Dequeue ());
								}
							}
						}
					}
					if (arrayList1.Count > 0)
					{
						pbyteData = this.ProcessEvents (arrayList1);
						if (pbyteData != null)
						{
							puiOpcode = 8;
						}
					}
					if (base.Abort)
					{
						return false;
					}
					else
					{
						return true;
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, "EventThread.Action() - Exception thrown. Abort.");
					Logging.Instance.Log (0, exception1.ToString ());
				}
				return false;
			}
			
			protected override bool ConnectionEstablished ()
			
			{
				this.MessagesNotification (true);
				return true;
			}
			
			protected bool Initialize ()
			
			{
				this.MessagesNotification (false);
				return true;
			}
			
			protected override bool InitializeWorkThread ()
			
			{
				IPEndPoint iPEndPoint1;
				Exception exception1;
				Logging.Instance.Log (4, "EventThread.InitializeWorkThread() called.");
				try
				{
					if (this.m_oJobMsg != null)
					{
						this.m_oJobMsg.LogFile = base.LogFile;
						this.m_oJobMsg.LoggingLevel = base.LoggingLevel;
						this.m_oJobMsg.LogConsole = base.LogConsole;
						if (! this.m_oJobMsg.StartThread ())
						{
							return false;
						}
					}
					if (this.m_oJobExceptMsg != null)
					{
						this.m_oJobExceptMsg.LogFile = base.LogFile;
						this.m_oJobExceptMsg.LoggingLevel = base.LoggingLevel;
						this.m_oJobExceptMsg.LogConsole = base.LogConsole;
						if (! this.m_oJobExceptMsg.StartThread ())
						{
							return false;
						}
					}
					if (this.m_oJobMarkerMsg != null)
					{
						this.m_oJobMarkerMsg.LogFile = base.LogFile;
						this.m_oJobMarkerMsg.LoggingLevel = base.LoggingLevel;
						this.m_oJobMarkerMsg.LogConsole = base.LogConsole;
						if (! this.m_oJobMarkerMsg.StartThread ())
						{
							return false;
						}
					}
					if (this.m_oRegisters != null)
					{
						this.m_oRegisters.LogFile = base.LogFile;
						this.m_oRegisters.LoggingLevel = base.LoggingLevel;
						this.m_oRegisters.LogConsole = base.LogConsole;
						if (! this.m_oRegisters.StartThread ())
						{
							return false;
						}
					}
					if (this.m_oFixDataMsg != null)
					{
						this.m_oFixDataMsg.LogFile = base.LogFile;
						this.m_oFixDataMsg.LoggingLevel = base.LoggingLevel;
						this.m_oFixDataMsg.LogConsole = base.LogConsole;
						if (! this.m_oFixDataMsg.StartThread ())
						{
							return false;
						}
					}
					if (! this.Initialize ())
					{
						return false;
					}
					else
					{
						base.Abort = false;
						iPEndPoint1 = new IPEndPoint (IPAddress.Any, ((int) base.ConnectPort));
						this.m_oListen = new Socket (iPEndPoint1.AddressFamily, SocketType.Stream, ProtocolType.Tcp);
						this.m_oListen.Bind (((EndPoint) iPEndPoint1));
						this.m_oListen.Listen (1);
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, "Exception thrown in EventThread::InitializeWorkThread");
					Logging.Instance.Log (0, exception1.ToString ());
					this.m_oListen = ((Socket) null);
					return false;
				}
				return true;
			}
			
			protected override void InterruptWorkThread (bool pbAbort)
			
			{
				NamedEvent namedEvent1;
				NamedEvent namedEvent2;
				base.Abort = pbAbort;
				if (this.m_strEventName.Length > 0)
				{
					namedEvent1 = new NamedEvent (this.m_strEventName, true);
					bool b1 = namedEvent1.Pulse ();
				}
				if (this.m_strEventExceptionName.Length > 0)
				{
					namedEvent2 = new NamedEvent (this.m_strEventExceptionName, true);
					bool b2 = namedEvent2.Pulse ();
				}
				base.InterruptWorkThread (pbAbort);
				bool b3 = this.m_oContentAvailable.Set ();
			}
			
			private void ListenCallback (IAsyncResult ar)
			
			{
				Socket socket1;
				Exception exception1;
				try
				{
					socket1 = ((Socket) ar.AsyncState);
					this.m_oListenResult = socket1.EndAccept (ar);
					this.m_iListenResult = ((IAsyncResult) null);
					bool b1 = this.m_oContentAvailable.Set ();
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, "EventThread.ListenCallback() - Exception thrown. Abort.");
					Logging.Instance.Log (0, exception1.ToString ());
				}
			}
			
			public void MessagesNotification (bool pbEnable)
			
			{
				Logging.Instance.Log (4, ("EventThread.MessagesNotification() called - " + pbEnable.ToString ()));
				this.MessagesEnabled = pbEnable;
				LECHAL.Instance.EnableFPGAEventQueue (this.MessagesEnabled);
			}
			
			protected override Socket PerformActionWhileWaiting ()
			
			{
				uint uInt32_1;
				byte[] byteArray1;
				Exception exception1;
				try
				{
					if (this.m_oListen == null)
					{
						return ((Socket) null);
					}
					else
					{
						if (this.m_iListenResult == null)
						{
							this.m_oListenResult = ((Socket) null);
							this.m_iListenResult = this.m_oListen.BeginAccept (new AsyncCallback (this.ListenCallback), this.m_oListen);
						}
						while (this.m_oListenResult == null)
						{
							if ((! this.Action (out uInt32_1, out byteArray1)) && (! base.Abort))
							{
								base.Abort = true;
							}
							if (base.Abort)
							{
								Logging.Instance.Log ("EventThread.ActionWait() - An abort occurred while listening for a connection.");
								this.m_oListen.Close ();
								this.m_oListen = ((Socket) null);
								this.m_iListenResult = ((IAsyncResult) null);
								return ((Socket) null);
							}
						}
						this.m_oListen.Close ();
						this.m_oListen = ((Socket) null);
						this.m_iListenResult = ((IAsyncResult) null);
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, "EventThread.ActionWait() - Exception thrown. Abort.");
					Logging.Instance.Log (0, exception1.ToString ());
				}
				return this.m_oListenResult;
			}
			
			protected byte[] ProcessEvents (ArrayList plstEvents)
			
			{
				object object1;
				EventData eventData1;
				MecExceptionMessage mecExceptionMessage1;
				MecRegisters mecRegisters1;
				MecMessage mecMessage1;
				byte[] byteArray2;
				byte[] byteArray3;
				IDisposable iDisposable1;
				Logging.Instance.Log (4, "EventThread.ProcessEvents() called.");
				if (plstEvents.Count == 0)
				{
					Logging.Instance.Log (4, "EventThread.ProcessEvents() - No events.  Return null.");
					return null;
				}
				byte[] byteArray1 = ((byte[]) null);
				bool b1 = false;
				bool b2 = false;
				IEnumerator iEnumerator1 = plstEvents.GetEnumerator ();
				try
				{
					goto L_0232;
					
				L_00DA:
					
					{
					}
					eventData1.PayloadHigh = ((uint) (20544 | ((int) (((long) (mecExceptionMessage1.ExceptionCode << 16)) & ((long) (-65536))))));
					eventData1.PayloadLow = mecExceptionMessage1.LastOpcode;
					if (this.ExceptionMessageNotify != null)
					{
						this.ExceptionMessageNotify (mecExceptionMessage1.ExceptionCode);
					}
					Logging.Instance.Log ("EventThread.ProcessEvents() - Send FPGA Exception Message: {0:x}, {1:x}, {2:x}, "
					+ "{3:x}", ((int) (((int) eventData1.PayloadHigh) & 65535)), ((int) (eventData1.PayloadHigh >> 16)), ((int) (((int) eventData1.PayloadLow) & 65535)), ((int) (eventData1.PayloadLow >> 16)));
					
				L_01EC:
					
					{
					}
					if (byteArray1 == null)
					{
						byteArray1 = eventData1.ToBytes ();
					}
					else
					{
						byteArray2 = eventData1.ToBytes ();
						byteArray3 = new byte[(byteArray1.Length + byteArray2.Length)];
						Array.Copy (((Array) byteArray1), 0, ((Array) byteArray3), 0, byteArray1.Length);
						Array.Copy (((Array) byteArray2), 0, ((Array) byteArray3), byteArray1.Length, byteArray2.Length);
						byteArray1 = byteArray3;
					}
					
				L_0232:
					
					{
					}
					while (iEnumerator1.MoveNext ())
					{
						object1 = iEnumerator1.Current;
						if (object1 == null)
						{
							continue;
						}
						eventData1 = new EventData ();
						if (! (object1 is MecExceptionMessage))
						{
							if (! (object1 is MecRegisters))
							{
								mecMessage1 = (object1 as MecMessage);
								eventData1.PayloadHigh = Convert.ToUInt32 (mecMessage1.MessageID);
								eventData1.PayloadLow = Convert.ToUInt32 (mecMessage1.MessageOperand);
								Logging.Instance.Log ("EventThread.ProcessEvents() - Send FPGA Message: {0:x}, {1:x}, {2:x}, {3:x}", ((int) (((int) eventData1.PayloadHigh) & 65535)), ((int) (eventData1.PayloadHigh >> 16)), ((int) (((int) eventData1.PayloadLow) & 65535)), ((int) (eventData1.PayloadLow >> 16)));
								goto L_01EC;
							}
							mecRegisters1 = (object1 as MecRegisters);
							byteArray1 = mecRegisters1.ToBytes ();
							continue;
						}
						mecExceptionMessage1 = (object1 as MecExceptionMessage);
						if (mecExceptionMessage1.ExceptionCode != 8001)
						{
							if (mecExceptionMessage1.ExceptionCode != 9001)
							{
								if (mecExceptionMessage1.ExceptionCode == 9021)
								{
									bool b3 = LECHAL.Instance.SetCachedInterlockSetting ();
									mecExceptionMessage1.LastOpcode = LECHAL.Instance.CalcQualifiedInterlocks (mecExceptionMessage1.LastOpcode);
									Logging.Instance.Log (("EventThread.ProcessEvents() - " + LECHAL.Instance.FPGAMessageLog));
								}
								goto L_00DA;
							}
							b1 = true;
							b2 = true;
							goto L_00DA;
						}
						b1 = true;
						goto L_00DA;
					}
				}
				finally
				{
					iDisposable1 = (iEnumerator1 as IDisposable);
					if (iDisposable1 != null)
					{
						iDisposable1.Dispose ();
					}
				}
				base.WaitForResponse = false;
				if (b1)
				{
					LECHAL.Instance.StartCommandProcessing (false);
					Logging.Instance.Log (("EventThread.ProcessEvents() - " + LECHAL.Instance.FPGAMessageLog));
				}
				if (! b2)
				{
					return byteArray1;
				}
				this.MessagesEnabled = true;
				EventThread eventThread1 = this;
				lock (eventThread1)
				{
					LECHAL.Instance.ClearFPGAEventQueue ();
					Logging.Instance.Log (("EventThread.ProcessEvents() - " + LECHAL.Instance.FPGAMessageLog));
					LECHAL.Instance.ClearFPGAExceptionEventQueue ();
					Logging.Instance.Log (("EventThread.ProcessEvents() - " + LECHAL.Instance.FPGAMessageLog));
				}
				if (this.AbortCompleteNotify != null)
				{
					this.AbortCompleteNotify ();
				}
				Logging.Instance.Log ("EventThread.ProcessEvents() - AbortCompleteNotify() sent.");
				return byteArray1;
			}
			
			protected override bool TerminateWorkThread ()
			
			{
				if (this.m_oJobMarkerMsg != null)
				{
					bool b1 = this.m_oJobMarkerMsg.StopThread ();
				}
				if (this.m_oJobMsg != null)
				{
					bool b2 = this.m_oJobMsg.StopThread ();
				}
				if (this.m_oJobExceptMsg != null)
				{
					bool b3 = this.m_oJobExceptMsg.StopThread ();
				}
				if (this.m_oRegisters != null)
				{
					bool b4 = this.m_oRegisters.StopThread ();
				}
				if (this.m_oFixDataMsg != null)
				{
					bool b5 = this.m_oFixDataMsg.StopThread ();
				}
				if (this.m_oListen != null)
				{
					this.m_oListen.Close ();
					this.m_oListen = ((Socket) null);
					this.m_iListenResult = ((IAsyncResult) null);
				}
				LECHAL.Instance.EnableFPGAEventQueue (false);
				return base.TerminateWorkThread ();
			}
			
		#endregion
	}
	
}

