//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:26:05
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LocalManager

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonInteropLib.PInvoke;
			using LanmarkControls.CommonLib.General;
			using LanmarkControls.CommonLib.Protocol;
			using LanmarkControls.LECEngine;
			using LanmarkControls.LECHardwareAbstraction;
			using LanmarkControls.LECHardwareAbstraction.PInvoke;
			using LanmarkControls.LECHardwareAbstraction.SerialPortInterface;
			using LanmarkControls.LECHardwareAbstraction.Utilities;
			using LanmarkControls.LocalManager.Broadcast;
			using LanmarkControls.LocalManager.Hosts;
			using System;
			using System.Collections;
			using System.IO;
			using System.Net;
			using System.Runtime.InteropServices;
			using System.Text;
			using System.Threading;
			using Logging = LanmarkControls.CommonLib.General.Logging;
			
		#endregion
		
	public sealed class LocalModeManager
	
	{
		
		#region Fields
			private IHostControl bluetoothHost;
			private Broadcaster broadcastManager;
			private readonly byte[] carriageReturnSequence;
			private string clientIP;
			private string clientName;
			private Port COM2Port;
			private string com2RxBuffer;
			private string currentJob;
			private string[] ExeArgs;
			private IHostControl guiHost;
			private IHostControl hostInControl;
			private IHostControl lanHost;
			private IHostControl lanStreamHost;
			private int lastError;
			private string lastErrorString;
			private string objectExtensionVersion;
			public event AssumeHostControlHandler OnAssumeHostControl;
			public event AsyncJobEventHandler OnAsyncJobEvent;
			public event AsyncUpdateClientDataHandler OnAsyncUpdateClientData;
			public event AsyncUpdateHostInControlHandler OnAsyncUpdateHostInControl;
			private IHostControl pendantHost;
			private IHostControl rs232Host;
			private uint stateCode;
			public ManualResetEvent TerminateApplication;
			private bool waitingCOM2Response;
		#endregion
		
		#region Constructors
		
			public LocalModeManager (string[] args)
			
			{
				this.TerminateApplication = new ManualResetEvent (false);
				this.broadcastManager = ((Broadcaster) null);
				this.hostInControl = ((IHostControl) null);
				this.guiHost = ((IHostControl) null);
				this.pendantHost = ((IHostControl) null);
				this.bluetoothHost = ((IHostControl) null);
				this.lanHost = ((IHostControl) null);
				this.lanStreamHost = ((IHostControl) null);
				this.rs232Host = ((IHostControl) null);
				this.COM2Port = ((Port) null);
				this.ExeArgs = ((string[]) null);
				this.currentJob = "";
				this.objectExtensionVersion = "";
				this.lastError = 0;
				this.clientIP = "0.0.0.0";
				this.clientName = "";
				this.stateCode = 128;
				this.waitingCOM2Response = false;
				byte[] byteArray1 = new byte[] { 13 };
				this.carriageReturnSequence = byteArray1;
				this.com2RxBuffer = "";
				this.lastErrorString = APIResponses.ACK.ToString ();
				bool b1 = MemoryStatus.CalcDivision (25);
				LED.LED_ON (LanmarkControls.LECHardwareAbstraction.Utilities.LED.LED_ID.ONE);
				LED.LED_ON (LanmarkControls.LECHardwareAbstraction.Utilities.LED.LED_ID.TWO);
				bool b2 = Authentication.SetUsernamesPasswords ();
				LECHAL.Instance.setUSBPower (false);
				Thread.Sleep (2000);
				LECHAL.Instance.setUSBPower (true);
				if (args == null)
				{
					this.ExeArgs = new string[1];
				}
				else if (args.GetLength (0) == 0)
				{
					this.ExeArgs = new string[1];
				}
				else
				{
					this.ExeArgs = new string[args.GetLength (0)];
				}
			}
			
		#endregion
		
		#region Properties
		
			private string COM2RxBuffer
			
			{
				get
				{
					string string1;
					string string2 = this.com2RxBuffer;
					lock (string2)
					{
						string1 = this.com2RxBuffer;
					}
					return string1;
				}
				set
				{
					string string1 = this.com2RxBuffer;
					lock (string1)
					{
						this.com2RxBuffer = value;
					}
				}
			}
			
			
			private string LastErrorString
			
			{
				get
				{
					string string1;
					string string2 = this.lastErrorString;
					lock (string2)
					{
						string1 = this.lastErrorString;
					}
					return string1;
				}
				set
				{
					string string1 = this.lastErrorString;
					lock (string1)
					{
						this.lastErrorString = value;
					}
				}
			}
			
		#endregion
		
		#region Methods
		
			private string CloseCOMPort (string portNum)
			
			{
				string string1;
				if ((string1 = portNum) == null)
				{
					return APIResponses.ERROR_PORT_NUMBER.ToString ();
				}
				else
				{
					string1 = string.IsInterned (string1);
					switch (string1)
					{
						case "1":
						
						{
								return APIResponses.ERROR_PORT_NUMBER.ToString ();
						}
						case "2":
						
						{
								if (this.COM2Port != null)
								{
									bool b1 = this.COM2Port.Close ();
									this.COM2Port = ((Port) null);
								}
								return APIResponses.ACK.ToString ();
						}
						case "3":
						
						{
								return APIResponses.ERROR_PORT_NUMBER.ToString ();
						}
						default:
						
						{
								return APIResponses.ERROR_PORT_NUMBER.ToString ();
						}
					}
				}
			}
			
			private bool CommandOK (HostTypes requestingHost, APICommands apiCommand)
			
			{
				if ((this.hostInControl != null) && (requestingHost != this.hostInControl.ThisHostType))
				{
					switch (apiCommand)
					{
						case APICommands.Abort:
						
						{
								return false;
						}
						case APICommands.ClearJobList:
						
						{
								return false;
						}
						case APICommands.CloseCOMPort:
						
						{
								return true;
						}
						case APICommands.COMWriteLine:
						
						{
								return true;
						}
						case APICommands.EnableBroadcasting:
						
						{
								return true;
						}
						case APICommands.ExecuteJobContinuous:
						
						{
								return false;
						}
						case APICommands.ExecuteJobOnce:
						
						{
								return false;
						}
						case APICommands.ForceLog:
						
						{
								return true;
						}
						case APICommands.GetAdminPIN:
						
						{
								return true;
						}
						case APICommands.GetDHCPMode:
						
						{
								return true;
						}
						case APICommands.GetFlashJobFileList:
						
						{
								return true;
						}
						case APICommands.GetHostControlStatus:
						
						{
								return true;
						}
						case APICommands.GetHostInControl:
						
						{
								return true;
						}
						case APICommands.GetJobStatus:
						
						{
								return true;
						}
						case APICommands.GetKFactor:
						
						{
								return true;
						}
						case APICommands.GetLastError:
						
						{
								return true;
						}
						case APICommands.GetLocalGateway:
						
						{
								return true;
						}
						case APICommands.GetLocalIP:
						
						{
								return true;
						}
						case APICommands.GetNodeFriendlyName:
						
						{
								return true;
						}
						case APICommands.GetRemoteIP:
						
						{
								return true;
						}
						case APICommands.GetSubnetMask:
						
						{
								return true;
						}
						case APICommands.GetUSBJobFileList:
						
						{
								return true;
						}
						case APICommands.GetUserPIN:
						
						{
								return true;
						}
						case APICommands.HardwareReset:
						
						{
								return true;
						}
						case APICommands.LoadFlashJob:
						
						{
								return false;
						}
						case APICommands.LoadHardwareDefaults:
						
						{
								return false;
						}
						case APICommands.LoadUSBJob:
						
						{
								return false;
						}
						case APICommands.OpenCOMPort:
						
						{
								return true;
						}
						case APICommands.ReleaseHostControl:
						
						{
								return false;
						}
						case APICommands.RemoveJob:
						
						{
								return false;
						}
						case APICommands.ResetAlignmentGlobals:
						
						{
								return false;
						}
						case APICommands.ResetPerformanceGlobals:
						
						{
								return false;
						}
						case APICommands.SetAdminPIN:
						
						{
								return false;
						}
						case APICommands.SetAlignmentGlobals:
						
						{
								return false;
						}
						case APICommands.SetDHCPMode:
						
						{
								return false;
						}
						case APICommands.SetLocalGateway:
						
						{
								return false;
						}
						case APICommands.SetLocalIP:
						
						{
								return false;
						}
						case APICommands.SetNodeFriendlyName:
						
						{
								return false;
						}
						case APICommands.SetPerformanceGlobals:
						
						{
								return false;
						}
						case APICommands.SetSubnetMask:
						
						{
								return false;
						}
						case APICommands.SetUserPIN:
						
						{
								return false;
						}
						case APICommands.TakeHostControl:
						
						{
								return true;
						}
					}
				}
				return true;
			}
			
			private bool CommandOKWhileJobRunning (APICommands apiCommand)
			
			{
				if ((LECJobEngine.Instance != null) && (LECJobEngine.Instance.EngineStatus == JobOpStatus.Idle))
				{
					return true;
				}
				else
				{
					switch (apiCommand)
					{
						case APICommands.Abort:
						
						{
								return true;
						}
						case APICommands.ForceLog:
						
						{
								return true;
						}
						case APICommands.GetAdminPIN:
						
						{
								return true;
						}
						case APICommands.GetDHCPMode:
						
						{
								return true;
						}
						case APICommands.GetFlashJobFileList:
						
						{
								return true;
						}
						case APICommands.GetHostControlStatus:
						
						{
								return true;
						}
						case APICommands.GetHostInControl:
						
						{
								return true;
						}
						case APICommands.GetJobStatus:
						
						{
								return true;
						}
						case APICommands.GetKFactor:
						
						{
								return true;
						}
						case APICommands.GetLastError:
						
						{
								return true;
						}
						case APICommands.GetLocalGateway:
						
						{
								return true;
						}
						case APICommands.GetLocalIP:
						
						{
								return true;
						}
						case APICommands.GetNodeFriendlyName:
						
						{
								return true;
						}
						case APICommands.GetRemoteIP:
						
						{
								return true;
						}
						case APICommands.GetSubnetMask:
						
						{
								return true;
						}
						case APICommands.GetUSBJobFileList:
						
						{
								return true;
						}
						case APICommands.GetUserPIN:
						
						{
								return true;
						}
						case APICommands.LoadFlashJob:
						
						{
								return true;
						}
						case APICommands.LoadUSBJob:
						
						{
								return true;
						}
						case APICommands.ClearJobList:
						case APICommands.CloseCOMPort:
						case APICommands.COMWriteLine:
						case APICommands.EnableBroadcasting:
						case APICommands.ExecuteJobContinuous:
						case APICommands.ExecuteJobOnce:
						case APICommands.HardwareReset:
						case APICommands.LoadHardwareDefaults:
						
						{
								return false;
						}
					}
					return false;
				}
			}
			
			private string COMWriteLine (string portNum, string characterBuffer, int commandTimeout)
			
			{
				byte[] byteArray1;
				int i1;
				string string1;
				switch (portNum)
				{
					case "1":
					
					{
							return APIResponses.ERROR_PORT_NUMBER.ToString ();
					}
					default:
					
					{
							switch (portNum)
							{
								case "2":
								
								{
										if ((this.COM2Port == null) || (! this.COM2Port.IsOpen))
										{
											return APIResponses.ERROR_PORT_NOT_OPEN.ToString ();
										}
										byteArray1 = new ASCIIEncoding ().GetBytes (characterBuffer);
										this.COM2Port.Output = byteArray1;
										this.COM2Port.Output = this.carriageReturnSequence;
										if (commandTimeout <= 0)
										{
											return APIResponses.ACK.ToString ();
										}
										this.waitingCOM2Response = true;
										i1 = Environment.TickCount;
										while (this.COM2RxBuffer == "")
										{
											Thread.Sleep (20);
											if ((Environment.TickCount - i1) > commandTimeout)
											{
												this.waitingCOM2Response = false;
												this.COM2RxBuffer = "";
												return APIResponses.ERROR_PORT_TIMEOUT.ToString ();
											}
										}
										this.waitingCOM2Response = false;
										string1 = this.COM2RxBuffer;
										this.COM2RxBuffer = "";
										return string1;
								}
								case "3":
								
								{
										return APIResponses.ERROR_PORT_NUMBER.ToString ();
								}
								default:
								
								{
										return APIResponses.ERROR_PORT_NUMBER.ToString ();
								}
							}
					}
				}
			}
			
			private void CreateHostControllers (HostTypes hostClient, string pendantHostName)
			
			{
				this.pendantHost = ((IHostControl) new PendantHost (pendantHostName));
				this.pendantHost.OnUpdateClientInfo += new UpdateClientInfoHandler (this.OnUpdateClientInfo);
				this.pendantHost.OnInputCommand += new InputCommandHandler (this.OnInputCommand);
				this.pendantHost.HostInControl = hostClient;
				bool b1 = this.pendantHost.Initialize ();
				this.lanStreamHost = ((IHostControl) new LANStreamHost ());
				this.lanStreamHost.OnUpdateClientInfo += new UpdateClientInfoHandler (this.OnUpdateClientInfo);
				this.lanStreamHost.OnInputCommand += new InputCommandHandler (this.OnInputCommand);
				this.lanStreamHost.HostInControl = hostClient;
				bool b2 = this.lanStreamHost.Initialize ();
				this.guiHost = ((IHostControl) new GUIHost ());
				this.guiHost.OnUpdateClientInfo += new UpdateClientInfoHandler (this.OnUpdateClientInfo);
				this.guiHost.OnInputCommand += new InputCommandHandler (this.OnInputCommand);
				this.guiHost.HostInControl = hostClient;
				bool b3 = this.guiHost.Initialize ();
				this.bluetoothHost = ((IHostControl) new BluetoothHost ());
				this.bluetoothHost.OnUpdateClientInfo += new UpdateClientInfoHandler (this.OnUpdateClientInfo);
				this.bluetoothHost.OnInputCommand += new InputCommandHandler (this.OnInputCommand);
				this.bluetoothHost.HostInControl = hostClient;
				bool b4 = this.bluetoothHost.Initialize ();
				this.lanHost = ((IHostControl) new LANHost ());
				this.lanHost.OnUpdateClientInfo += new UpdateClientInfoHandler (this.OnUpdateClientInfo);
				this.lanHost.OnInputCommand += new InputCommandHandler (this.OnInputCommand);
				this.lanHost.HostInControl = hostClient;
				bool b5 = this.lanHost.Initialize ();
				this.rs232Host = ((IHostControl) new RS232Host ());
				this.rs232Host.OnUpdateClientInfo += new UpdateClientInfoHandler (this.OnUpdateClientInfo);
				this.rs232Host.OnInputCommand += new InputCommandHandler (this.OnInputCommand);
				this.rs232Host.HostInControl = hostClient;
				bool b6 = this.rs232Host.Initialize ();
			}
			
			public void Disconnect ()
			
			{
				bool b1 = this.TerminateApplication.Set ();
			}
			
			public void Initialize ()
			
			{
				string string3;
				string string1 = AdminSettings.OtherSettings.HostClient;
				string string2 = AdminSettings.OtherSettings.HostPendant;
				HostTypes hostTypes1 = HostTypes.LANStream;
				if ((string3 = string1) != null)
				{
					string3 = string.IsInterned (string3);
					switch (string3)
					{
						case "Bluetooth":
						
						{
								hostTypes1 = HostTypes.Bluetooth;
								break;
						}
						case "GUI":
						
						{
								hostTypes1 = HostTypes.GUI;
								break;
						}
						case "LAN":
						
						{
								hostTypes1 = HostTypes.LAN;
								break;
						}
						case "LANStream":
						
						{
								hostTypes1 = HostTypes.LANStream;
								break;
						}
						case "Pendant":
						
						{
								hostTypes1 = HostTypes.Pendant;
								break;
						}
						case "RS232":
						
						{
								hostTypes1 = HostTypes.RS232;
								break;
						}
					}
				}
				this.CreateHostControllers (hostTypes1, string2);
				this.broadcastManager = new Broadcaster ();
				this.broadcastManager.OnSystemInfoRequest += new SystemInfoRequestHandler (this.OnSystemInfoRequest);
				this.broadcastManager.OnStatusInfoRequest += new StatusInfoRequestHandler (this.OnStatusInfoRequest);
				this.broadcastManager.OnKickTheDog += new WatchDogHandler (this.OnKickTheDog);
				this.broadcastManager.Start (this.ExeArgs);
				LED.LED_OFF (LanmarkControls.LECHardwareAbstraction.Utilities.LED.LED_ID.ONE);
				if (! LECHAL.Instance.InitializeFPGA ())
				{
					this.stateCode = 1024;
				}
				else
				{
					if (LECHAL.Instance.LoadFPGAFirmware () != 0)
					{
						this.stateCode = 1024;
					}
					bool b1 = LECHAL.Instance.LoadDefaultSettings ();
				}
				LED.LED_ON (LanmarkControls.LECHardwareAbstraction.Utilities.LED.LED_ID.ONE);
				LED.LED_OFF (LanmarkControls.LECHardwareAbstraction.Utilities.LED.LED_ID.TWO);
				LECJobEngine.Instance.OnAsyncJobErrorMessage += new AsyncJobErrorMessageHandler (this.OnAsyncJobErrorMessage);
				this.StartHostAPI ();
				LED.LED_OFF (LanmarkControls.LECHardwareAbstraction.Utilities.LED.LED_ID.ONE);
				LED.LED_OFF (LanmarkControls.LECHardwareAbstraction.Utilities.LED.LED_ID.TWO);
				this.SetInControlHost (hostTypes1, false);
				AtCommand atCommand1 = new AtCommand (LECOpcodes.WriteDigital, 6, 1);
				byte[] byteArray1 = atCommand1.ToBytes ();
				bool b2 = LECHAL.Instance.SendFPGAStreamData (byteArray1, byteArray1.Length);
			}
			
			private void NotifyAllHosts (HostTypes inControlHost)
			
			{
				this.pendantHost.HostInControl = inControlHost;
				this.lanStreamHost.HostInControl = inControlHost;
				this.guiHost.HostInControl = inControlHost;
				this.bluetoothHost.HostInControl = inControlHost;
				this.lanHost.HostInControl = inControlHost;
				this.rs232Host.HostInControl = inControlHost;
				if (this.OnAsyncUpdateHostInControl != null)
				{
					this.OnAsyncUpdateHostInControl (inControlHost);
				}
			}
			
			private void OnAsyncJobErrorMessage (string jobMessage, string objName)
			
			{
				this.LastErrorString = jobMessage;
			}
			
			private void OnCOM2DataReceived ()
			
			{
				if (! this.waitingCOM2Response)
				{
					return;
				}
				byte[] byteArray1 = this.COM2Port.Input;
				string string1 = Encoding.ASCII.GetString (byteArray1, 0, byteArray1.Length);
				char[] charArray2 = new char[3];
				charArray2[0] = '\r';
				charArray2[1] = '\n';
				char[] charArray1 = charArray2;
				this.COM2RxBuffer = string1.TrimEnd (charArray1);
			}
			
			private void OnEndHostSession ()
			
			{
				bool b1 = this.TerminateApplication.Set ();
			}
			
			private string[] OnInputCommand (HostTypes requestingHost, string[] commandString)
			
			{
				APICommands aPICommands1;
				string[] stringArray1;
				IPConfig iPConfig1;
				SettingsConfigData settingsConfigData1;
				JobOpStatus jobOpStatus1;
				int i1;
				string string1;
				int i2;
				int i3;
				Exception exception1;
				int i4;
				Exception exception2;
				APICommands aPICommands2;
				aPICommands1 = this.ParseAPICommandString (commandString[0]);
				if (! this.CommandOK (requestingHost, aPICommands1))
				{
					return new string[] { APIResponses.ERROR_NOT_IN_HOST_CONTROL.ToString () };
				}
				if (! this.CommandOKWhileJobRunning (aPICommands1))
				{
					return new string[] { APIResponses.ERROR_JOB_BUSY.ToString () };
				}
				if (aPICommands1 == APICommands.GetLastError)
				{
					stringArray1 = new string[] { this.LastErrorString };
					this.LastErrorString = APIResponses.ACK.ToString ();
					return stringArray1;
				}
				aPICommands2 = aPICommands1;
				switch (aPICommands2)
				{
					case APICommands.Abort:
					
					{
							jobOpStatus1 = LECJobEngine.Instance.AbortJob ();
							if (jobOpStatus1 != JobOpStatus.Idle)
							{
								return new string[] { jobOpStatus1.ToString () };
							}
							this.currentJob = "";
							stringArray1 = new string[] { APIResponses.ACK.ToString () };
							if (this.OnAsyncJobEvent != null)
							{
								this.OnAsyncJobEvent (jobOpStatus1, this.currentJob);
							}
							return stringArray1;
					}
					case APICommands.ClearJobList:
					
					{
							LECJobEngine.Instance.ClearJobList ();
							return new string[] { APIResponses.ACK.ToString () };
					}
					case APICommands.CloseCOMPort:
					
					{
							if (commandString.Length <= 1)
							{
								return new string[] { APIResponses.ERROR_ARGS.ToString () };
							}
							else
							{
								return new string[] { this.CloseCOMPort (commandString[1]) };
							}
					}
					case APICommands.COMWriteLine:
					
					{
							stringArray1 = new string[1];
							if (commandString.Length > 3)
							{
								try
								{
									i1 = int.Parse (commandString[(commandString.Length - 1)]);
								}
								catch (Exception)
								{
									stringArray1[0] = APIResponses.ERROR_ARGS.ToString ();
									return stringArray1;
								}
								string1 = "";
								for (i2 = 2; (i2 < (commandString.Length - 1)); i2++)
								{
									if (i2 > 2)
									{
										string1 = (string1 + ",");
									}
									string1 = (string1 + commandString[i2]);
								}
								stringArray1[0] = this.COMWriteLine (commandString[1], string1, i1);
								return stringArray1;
							}
							stringArray1[0] = APIResponses.ERROR_ARGS.ToString ();
							return stringArray1;
					}
					case APICommands.EnableBroadcasting:
					
					{
							if (commandString.Length <= 1)
							{
								return new string[] { APIResponses.ERROR_ARGS.ToString () };
							}
							if (commandString[1] != "0")
							{
								this.broadcastManager.Enabled = true;
								return new string[] { APIResponses.ACK.ToString () };
							}
							this.broadcastManager.Enabled = false;
							return new string[] { APIResponses.ACK.ToString () };
					}
					case APICommands.ExecuteJobContinuous:
					
					{
							if (commandString.Length <= 1)
							{
								return new string[] { APIResponses.ERROR_ARGS.ToString () };
							}
							jobOpStatus1 = LECJobEngine.Instance.ExecuteAllObjects (commandString[1], LanmarkControls.LECEngine.LECJobEngine.ExecuteMode.ExecuteContinuous);
							if (jobOpStatus1 != JobOpStatus.Busy)
							{
								return new string[] { jobOpStatus1.ToString () };
							}
							this.currentJob = commandString[1];
							stringArray1 = new string[] { APIResponses.ACK.ToString () };
							if (this.OnAsyncJobEvent != null)
							{
								this.OnAsyncJobEvent (jobOpStatus1, this.currentJob);
							}
							return stringArray1;
					}
					case APICommands.ExecuteJobOnce:
					
					{
							if (commandString.Length <= 1)
							{
								return new string[] { APIResponses.ERROR_ARGS.ToString () };
							}
							jobOpStatus1 = LECJobEngine.Instance.ExecuteAllObjects (commandString[1], LanmarkControls.LECEngine.LECJobEngine.ExecuteMode.ExecuteOnce);
							if (jobOpStatus1 != JobOpStatus.Busy)
							{
								return new string[] { jobOpStatus1.ToString () };
							}
							this.currentJob = commandString[1];
							stringArray1 = new string[] { APIResponses.ACK.ToString () };
							if (this.OnAsyncJobEvent != null)
							{
								this.OnAsyncJobEvent (jobOpStatus1, this.currentJob);
							}
							return stringArray1;
					}
					case APICommands.ForceLog:
					
					{
							Logging.Instance.ForceLog ();
							return new string[] { APIResponses.ACK.ToString () };
					}
					case APICommands.GetAdminPIN:
					
					{
							return new string[] { AdminSettings.OtherSettings.AdminPassword };
					}
					case APICommands.GetDHCPMode:
					
					{
							iPConfig1 = LECHAL.Instance.WinCEIPSettings;
							return new string[] { iPConfig1.IPMode.ToString () };
					}
					case APICommands.GetFlashJobFileList:
					
					{
							try
							{
								stringArray1 = Directory.GetFiles (CommonSvrUtil.FullFlashJobsPath);
								if (stringArray1.Length == 0)
								{
									return new string[] { APIResponses.ERROR_NO_FILES_FOUND.ToString () };
								}
								else
								{
									for (i3 = 0; (i3 < stringArray1.Length); i3++)
									{
										stringArray1[i3] = Path.GetFileName (stringArray1[i3]);
									}
									return stringArray1;
								}
							}
							catch (Exception exception4)
							{
								exception1 = exception4;
								Logging.Instance.Log (0, "Exception thrown while getting FlashJobFileList.");
								Logging.Instance.Log (0, exception1.ToString ());
								return new string[] { APIResponses.ERROR_NO_DRIVE.ToString () };
							}
					}
					case APICommands.GetHostControlStatus:
					
					{
							stringArray1 = new string[1];
							if ((this.hostInControl == null) || (requestingHost == this.hostInControl.ThisHostType))
							{
								stringArray1[0] = APIResponses.IN_CONTROL.ToString ();
								return stringArray1;
							}
							stringArray1[0] = APIResponses.NOT_IN_CONTROL.ToString ();
							return stringArray1;
					}
					case APICommands.GetHostInControl:
					
					{
							stringArray1 = new string[1];
							if (this.hostInControl == null)
							{
								stringArray1[0] = HostTypes.LANStream.ToString ();
								return stringArray1;
							}
							stringArray1[0] = this.hostInControl.ThisHostType.ToString ();
							return stringArray1;
					}
					case APICommands.GetJobStatus:
					
					{
							return new string[] { LECJobEngine.Instance.EngineStatus.ToString () };
					}
					case APICommands.GetKFactor:
					
					{
							return new string[] { LECHAL.Instance.CurrentLens.KFactor.ToString () };
					}
					case APICommands.GetLocalGateway:
					
					{
							iPConfig1 = LECHAL.Instance.WinCEIPSettings;
							return new string[] { iPConfig1.IPGateway.ToString () };
					}
					case APICommands.GetLocalIP:
					
					{
							iPConfig1 = LECHAL.Instance.WinCEIPSettings;
							return new string[] { iPConfig1.IPAddr.ToString () };
					}
					case APICommands.GetNodeFriendlyName:
					
					{
							return new string[] { AdminSettings.OtherSettings.FriendlyName };
					}
					case APICommands.GetRemoteIP:
					
					{
							return new string[] { this.clientIP };
					}
					case APICommands.GetSubnetMask:
					
					{
							iPConfig1 = LECHAL.Instance.WinCEIPSettings;
							return new string[] { iPConfig1.IPSubnetMask.ToString () };
					}
					case APICommands.GetUSBJobFileList:
					
					{
							try
							{
								stringArray1 = Directory.GetFiles (CommonSvrUtil.FullUSBJobsPath);
								if (stringArray1.Length == 0)
								{
									return new string[] { APIResponses.ERROR_NO_FILES_FOUND.ToString () };
								}
								else
								{
									for (i4 = 0; (i4 < stringArray1.Length); i4++)
									{
										stringArray1[i4] = Path.GetFileName (stringArray1[i4]);
									}
									return stringArray1;
								}
							}
							catch (Exception exception5)
							{
								exception2 = exception5;
								Logging.Instance.Log (0, "Exception thrown while trying to getUSBJobFileList");
								Logging.Instance.Log (0, exception2.ToString ());
								return new string[] { APIResponses.ERROR_NO_DRIVE.ToString () };
							}
					}
					case APICommands.GetUserPIN:
					
					{
							return new string[] { AdminSettings.OtherSettings.UserPassword };
					}
					case APICommands.HardwareReset:
					
					{
							JobOpStatus jobOpStatus2 = LECJobEngine.Instance.AbortJob ();
							if (this.hostInControl != null)
							{
								this.hostInControl.Disconnect ();
							}
							LECHAL.Instance.ResetBoard ();
							return null;
					}
					case APICommands.LoadFlashJob:
					
					{
							if (commandString.Length <= 1)
							{
								return new string[] { APIResponses.ERROR_ARGS.ToString () };
							}
							jobOpStatus1 = LECJobEngine.Instance.LoadJobFromFile (Path.Combine (CommonSvrUtil.FullFlashJobsPath, commandString[1]));
							if (jobOpStatus1 != JobOpStatus.Success)
							{
								return new string[] { jobOpStatus1.ToString () };
							}
							else
							{
								return new string[] { APIResponses.ACK.ToString () };
							}
					}
					case APICommands.LoadHardwareDefaults:
					
					{
							if (! LECHAL.Instance.LoadDefaultSettings ())
							{
								return new string[] { APIResponses.ERROR_SOFTWARE.ToString () };
							}
							else
							{
								return new string[] { APIResponses.ACK.ToString () };
							}
					}
					case APICommands.LoadUSBJob:
					
					{
							if (commandString.Length <= 1)
							{
								return new string[] { APIResponses.ERROR_ARGS.ToString () };
							}
							jobOpStatus1 = LECJobEngine.Instance.LoadJobFromFile (Path.Combine (CommonSvrUtil.FullUSBJobsPath, commandString[1]));
							if (jobOpStatus1 != JobOpStatus.Success)
							{
								return new string[] { jobOpStatus1.ToString () };
							}
							else
							{
								return new string[] { APIResponses.ACK.ToString () };
							}
					}
					case APICommands.OpenCOMPort:
					
					{
							if (this.hostInControl.ThisHostType != HostTypes.LANStream)
							{
								return new string[] { APIResponses.ERROR_WRONG_HOST_TYPE.ToString () };
							}
							else if (commandString.Length <= 6)
							{
								return new string[] { APIResponses.ERROR_ARGS.ToString () };
							}
							else
							{
								return new string[] { this.OpenCOMPort (commandString[1], commandString[2], commandString[3], commandString[4], commandString[5], commandString[6]) };
							}
					}
					case APICommands.ReleaseHostControl:
					
					{
							this.TakeControlRequest (requestingHost, false);
							return new string[] { APIResponses.ACK.ToString () };
					}
					case APICommands.RemoveJob:
					
					{
							if (commandString.Length <= 1)
							{
								return new string[] { APIResponses.ERROR_ARGS.ToString () };
							}
							jobOpStatus1 = LECJobEngine.Instance.RemoveJob (commandString[1]);
							if (jobOpStatus1 != JobOpStatus.Success)
							{
								return new string[] { jobOpStatus1.ToString () };
							}
							else
							{
								return new string[] { APIResponses.ACK.ToString () };
							}
					}
					case APICommands.ResetAlignmentGlobals:
					
					{
							return new string[] { APIResponses.ACK.ToString () };
					}
					case APICommands.ResetPerformanceGlobals:
					
					{
							return new string[] { APIResponses.ACK.ToString () };
					}
					case APICommands.SetAdminPIN:
					
					{
							if (commandString.Length <= 1)
							{
								return new string[] { APIResponses.ERROR_ARGS.ToString () };
							}
							settingsConfigData1 = AdminSettings.OtherSettings;
							settingsConfigData1.AdminPassword = commandString[1];
							AdminSettings.UpdateAdminSettings (settingsConfigData1);
							return new string[] { APIResponses.ACK.ToString () };
					}
					case APICommands.SetAlignmentGlobals:
					
					{
							if (commandString.Length <= 1)
							{
								return new string[] { APIResponses.ERROR_ARGS.ToString () };
							}
							else
							{
								return new string[] { APIResponses.ACK.ToString () };
							}
					}
					case APICommands.SetDHCPMode:
					
					{
							if (commandString.Length <= 1)
							{
								return new string[] { APIResponses.ERROR_ARGS.ToString () };
							}
							iPConfig1 = LECHAL.Instance.WinCEIPSettings;
							if (commandString[1].CompareTo (DHCPModeType.Static.ToString ()) != 0)
							{
								if (commandString[1].CompareTo (DHCPModeType.Autodetect.ToString ()) != 0)
								{
									goto L_0A1F;
								}
								iPConfig1.IPMode = DHCPModeType.Autodetect;
								goto L_0A1F;
							}
							iPConfig1.IPMode = DHCPModeType.Static;
							goto L_0A1F;
					}
					case APICommands.SetLocalGateway:
					
					{
							if (commandString.Length <= 1)
							{
								return new string[] { APIResponses.ERROR_ARGS.ToString () };
							}
							iPConfig1 = LECHAL.Instance.WinCEIPSettings;
							iPConfig1.IPGateway = IPAddress.Parse (commandString[1]);
							LECHAL.Instance.WinCEIPSettings = iPConfig1;
							return new string[] { APIResponses.ACK.ToString () };
					}
					case APICommands.SetLocalIP:
					
					{
							if (commandString.Length <= 1)
							{
								return new string[] { APIResponses.ERROR_ARGS.ToString () };
							}
							iPConfig1 = LECHAL.Instance.WinCEIPSettings;
							iPConfig1.IPAddr = IPAddress.Parse (commandString[1]);
							LECHAL.Instance.WinCEIPSettings = iPConfig1;
							return new string[] { APIResponses.ACK.ToString () };
					}
					case APICommands.SetNodeFriendlyName:
					
					{
							if (commandString.Length <= 1)
							{
								return new string[] { APIResponses.ERROR_ARGS.ToString () };
							}
							settingsConfigData1 = AdminSettings.OtherSettings;
							settingsConfigData1.FriendlyName = commandString[1];
							AdminSettings.UpdateAdminSettings (settingsConfigData1);
							return new string[] { APIResponses.ACK.ToString () };
					}
					case APICommands.SetPerformanceGlobals:
					
					{
							if (commandString.Length <= 1)
							{
								return new string[] { APIResponses.ERROR_ARGS.ToString () };
							}
							else
							{
								return new string[] { APIResponses.ACK.ToString () };
							}
					}
					case APICommands.SetSubnetMask:
					
					{
							if (commandString.Length <= 1)
							{
								return new string[] { APIResponses.ERROR_ARGS.ToString () };
							}
							iPConfig1 = LECHAL.Instance.WinCEIPSettings;
							iPConfig1.IPSubnetMask = IPAddress.Parse (commandString[1]);
							LECHAL.Instance.WinCEIPSettings = iPConfig1;
							return new string[] { APIResponses.ACK.ToString () };
					}
					case APICommands.SetUserPIN:
					
					{
							if (commandString.Length <= 1)
							{
								return new string[] { APIResponses.ERROR_ARGS.ToString () };
							}
							settingsConfigData1 = AdminSettings.OtherSettings;
							settingsConfigData1.UserPassword = commandString[1];
							AdminSettings.UpdateAdminSettings (settingsConfigData1);
							return new string[] { APIResponses.ACK.ToString () };
					}
					case APICommands.TakeHostControl:
					
					{
							this.TakeControlRequest (requestingHost, true);
							return new string[] { APIResponses.ACK.ToString () };
					}
				}
				return new string[] { APIResponses.ERROR_COMMAND.ToString () };
				
			L_0A1F:
				
				{
				}
				LECHAL.Instance.WinCEIPSettings = iPConfig1;
				return new string[] { APIResponses.ACK.ToString () };
			}
			
			private void OnKickTheDog ()
			
			{
				LED.LED_ON (LanmarkControls.LECHardwareAbstraction.Utilities.LED.LED_ID.ONE);
				Thread.Sleep (50);
				LED.LED_OFF (LanmarkControls.LECHardwareAbstraction.Utilities.LED.LED_ID.ONE);
			}
			
			private void OnStatusInfoRequest (out StatusInfo statusInfo)
			
			{
				StatusInfo statusInfo1 = new StatusInfo ();
				statusInfo = statusInfo1;
			}
			
			private void OnSystemInfoRequest (string friendlyName, string headSerialNum, out SystemInfo sysInfo)
			
			{
				SystemInfo systemInfo1 = new SystemInfo (friendlyName, headSerialNum, this.currentJob, this.stateCode, IPAddress.Parse (this.clientIP), this.objectExtensionVersion, ((uint) this.lastError));
				sysInfo = systemInfo1;
			}
			
			private void OnUpdateClientInfo (ClientConnectionStatus stateCodeValue, string clientName, string clientIP, int lastError)
			
			{
				uint uInt32_1;
				ClientConnectionStatus clientConnectionStatus1;
				clientConnectionStatus1 = stateCodeValue;
				switch (clientConnectionStatus1)
				{
					case ClientConnectionStatus.Startup:
					
					{
							uInt32_1 = 128;
							goto L_005B;
					}
					case ClientConnectionStatus.Available:
					
					{
							uInt32_1 = uint.MinValue;
							goto L_005B;
					}
					case ClientConnectionStatus.Wait:
					
					{
							if (clientIP.Length == 0)
							{
								uInt32_1 = 16;
								goto L_005B;
							}
							uInt32_1 = 64;
							goto L_005B;
					}
					case ClientConnectionStatus.Connected:
					
					{
							uInt32_1 = 1;
							goto L_005B;
					}
					case ClientConnectionStatus.Aborting:
					
					{
							uInt32_1 = 8;
							goto L_005B;
					}
					case ClientConnectionStatus.Paused:
					
					{
							uInt32_1 = 32;
							goto L_005B;
					}
					case ClientConnectionStatus.Local:
					
					{
							uInt32_1 = 4;
							goto L_005B;
					}
				}
				uInt32_1 = 128;
				
			L_005B:
				
				{
				}
				if ((this.stateCode != uInt32_1) || ((this.clientIP != clientIP) || ((this.lastError != lastError) || (this.clientName != clientName))))
				{
					this.stateCode = uInt32_1;
					this.clientIP = clientIP;
					this.lastError = lastError;
					this.clientName = clientName;
					if ((this.OnAsyncUpdateClientData != null) && (this.hostInControl != this.guiHost))
					{
						this.OnAsyncUpdateClientData (this.stateCode, clientName, clientIP, this.currentJob, lastError);
					}
				}
			}
			
			private string OpenCOMPort (string portNum, string baudRate, string dataBits, string parityValue, string stopBits, string flowControl)
			
			{
				bool b1;
				DetailedPortSettings detailedPortSettings1;
				string string1;
				object object1;
				Hashtable hashtable1 = ((Hashtable) null);
				if (hashtable1 == null)
				{
					hashtable1 = new Hashtable (26, 0.5F);
					hashtable1.Add ("110", 0);
					hashtable1.Add ("300", 1);
					hashtable1.Add ("1200", 2);
					hashtable1.Add ("2400", 3);
					hashtable1.Add ("4800", 4);
					hashtable1.Add ("9600", 5);
					hashtable1.Add ("19200", 6);
					hashtable1.Add ("38400", 7);
					hashtable1.Add ("57600", 8);
					hashtable1.Add ("115200", 9);
					hashtable1.Add ("128000", 10);
					hashtable1.Add ("256000", 11);
				}
				b1 = false;
				if (portNum == "1")
				{
					b1 = true;
				}
				detailedPortSettings1 = ((DetailedPortSettings) null);
				if ((string1 = flowControl) == null)
				{
					return APIResponses.ERROR_ARGS.ToString ();
				}
				string1 = string.IsInterned (string1);
				switch (string1)
				{
					case "None":
					
					{
							detailedPortSettings1 = ((DetailedPortSettings) new HandshakeNone ());
							break;
					}
					case "XonXoff":
					
					{
							if (! b1)
							{
								detailedPortSettings1 = ((DetailedPortSettings) new HandshakeNone ());
							}
							else
							{
								detailedPortSettings1 = ((DetailedPortSettings) new HandshakeXonXoff ());
							}
							break;
					}
					case "CTS_RTS":
					
					{
							if (! b1)
							{
								detailedPortSettings1 = ((DetailedPortSettings) new HandshakeNone ());
							}
							else
							{
								detailedPortSettings1 = ((DetailedPortSettings) new HandshakeCtsRts ());
							}
							break;
					}
					case "DSR_DTR":
					
					{
							if (! b1)
							{
								detailedPortSettings1 = ((DetailedPortSettings) new HandshakeNone ());
							}
							else
							{
								detailedPortSettings1 = ((DetailedPortSettings) new HandshakeDsrDtr ());
							}
							break;
					}
					default:
					
					{
							return APIResponses.ERROR_ARGS.ToString ();
					}
				}
				if ((object1 = baudRate) == null)
				{
					return APIResponses.ERROR_ARGS.ToString ();
				}
				if ((object1 = hashtable1[object1]) == null)
				{
					return APIResponses.ERROR_ARGS.ToString ();
				}
				switch ((int) object1)
				{
					case 0:
					
					{
							detailedPortSettings1.BasicSettings.BaudRate = BaudRates.CBR_110;
							goto L_02FA;
					}
					case 1:
					
					{
							detailedPortSettings1.BasicSettings.BaudRate = BaudRates.CBR_300;
							goto L_02FA;
					}
					case 2:
					
					{
							detailedPortSettings1.BasicSettings.BaudRate = BaudRates.CBR_1200;
							goto L_02FA;
					}
					case 3:
					
					{
							detailedPortSettings1.BasicSettings.BaudRate = BaudRates.CBR_2400;
							goto L_02FA;
					}
					case 4:
					
					{
							detailedPortSettings1.BasicSettings.BaudRate = BaudRates.CBR_4800;
							goto L_02FA;
					}
					case 5:
					
					{
							detailedPortSettings1.BasicSettings.BaudRate = BaudRates.CBR_9600;
							goto L_02FA;
					}
					case 6:
					
					{
							detailedPortSettings1.BasicSettings.BaudRate = BaudRates.CBR_19200;
							goto L_02FA;
					}
					case 7:
					
					{
							detailedPortSettings1.BasicSettings.BaudRate = BaudRates.CBR_38400;
							goto L_02FA;
					}
					case 8:
					
					{
							detailedPortSettings1.BasicSettings.BaudRate = BaudRates.CBR_57600;
							goto L_02FA;
					}
					case 9:
					
					{
							detailedPortSettings1.BasicSettings.BaudRate = BaudRates.CBR_115200;
							goto L_02FA;
					}
					case 10:
					
					{
							detailedPortSettings1.BasicSettings.BaudRate = BaudRates.CBR_128000;
							goto L_02FA;
					}
					case 11:
					
					{
							detailedPortSettings1.BasicSettings.BaudRate = BaudRates.CBR_256000;
							goto L_02FA;
					}
				}
				return APIResponses.ERROR_ARGS.ToString ();
				
			L_02FA:
				
				{
				}
				if ((string1 = dataBits) == null)
				{
					return APIResponses.ERROR_ARGS.ToString ();
				}
				else
				{
					string1 = string.IsInterned (string1);
					switch (string1)
					{
						case "5":
						
						{
								detailedPortSettings1.BasicSettings.ByteSize = 5;
								break;
						}
						case "6":
						
						{
								detailedPortSettings1.BasicSettings.ByteSize = 6;
								break;
						}
						case "7":
						
						{
								detailedPortSettings1.BasicSettings.ByteSize = 7;
								break;
						}
						case "8":
						
						{
								detailedPortSettings1.BasicSettings.ByteSize = 8;
								break;
						}
						default:
						
						{
								return APIResponses.ERROR_ARGS.ToString ();
						}
					}
					if ((string1 = parityValue) == null)
					{
						return APIResponses.ERROR_ARGS.ToString ();
					}
					else
					{
						string1 = string.IsInterned (string1);
						switch (string1)
						{
							case "Even":
							
							{
									detailedPortSettings1.BasicSettings.Parity = Parity.even;
									break;
							}
							case "Odd":
							
							{
									detailedPortSettings1.BasicSettings.Parity = Parity.odd;
									break;
							}
							case "None":
							
							{
									detailedPortSettings1.BasicSettings.Parity = Parity.none;
									break;
							}
							case "Mark":
							
							{
									detailedPortSettings1.BasicSettings.Parity = Parity.mark;
									break;
							}
							case "Space":
							
							{
									detailedPortSettings1.BasicSettings.Parity = Parity.space;
									break;
							}
							default:
							
							{
									return APIResponses.ERROR_ARGS.ToString ();
							}
						}
						if ((string1 = stopBits) == null)
						{
							return APIResponses.ERROR_ARGS.ToString ();
						}
						else
						{
							string1 = string.IsInterned (string1);
							switch (string1)
							{
								case "1":
								
								{
										detailedPortSettings1.BasicSettings.StopBits = StopBits.one;
										break;
								}
								case "1.5":
								
								{
										detailedPortSettings1.BasicSettings.StopBits = StopBits.onePointFive;
										break;
								}
								case "2":
								
								{
										detailedPortSettings1.BasicSettings.StopBits = StopBits.two;
										break;
								}
								default:
								
								{
										return APIResponses.ERROR_ARGS.ToString ();
								}
							}
							switch (portNum)
							{
								case "1":
								
								{
										return APIResponses.ERROR_PORT_NUMBER.ToString ();
								}
								default:
								
								{
										if (portNum == "2")
										{
											if (this.COM2Port != null)
											{
												return APIResponses.ACK.ToString ();
											}
											this.COM2Port = new Port ("COM2:", detailedPortSettings1);
											if (this.COM2Port == null)
											{
												return APIResponses.ERROR_CANNOT_CREATE_PORT.ToString ();
											}
											this.COM2Port.RThreshold = uint.MinValue;
											this.COM2Port.RLineByte = 13;
											this.COM2Port.InputLen = 20;
											this.COM2Port.SThreshold = 1;
											this.COM2Port.DataReceived += new Port.CommEvent (this.OnCOM2DataReceived);
											if (this.COM2Port.Open ())
											{
												return APIResponses.ACK.ToString ();
											}
											else
											{
												return APIResponses.ERROR_CANNOT_OPEN_PORT.ToString ();
											}
										}
										switch (portNum)
										{
											case "3":
											
											{
													return APIResponses.ERROR_PORT_NUMBER.ToString ();
											}
											default:
											
											{
													return APIResponses.ERROR_PORT_NUMBER.ToString ();
											}
										}
								}
							}
						}
					}
				}
			}
			
			private APICommands ParseAPICommandString (string commandString)
			
			{
				object object1;
				Hashtable hashtable1 = ((Hashtable) null);
				if (hashtable1 == null)
				{
					hashtable1 = new Hashtable (84, 0.5F);
					hashtable1.Add ("TakeHostControl", 0);
					hashtable1.Add ("ReleaseHostControl", 1);
					hashtable1.Add ("GetHostControlStatus", 2);
					hashtable1.Add ("GetHostInControl", 3);
					hashtable1.Add ("ResetAlignmentGlobals", 4);
					hashtable1.Add ("SetAlignmentGlobals", 5);
					hashtable1.Add ("ResetPerformanceGlobals", 6);
					hashtable1.Add ("SetPerformanceGlobals", 7);
					hashtable1.Add ("OpenCOMPort", 8);
					hashtable1.Add ("CloseCOMPort", 9);
					hashtable1.Add ("COMWriteLine", 10);
					hashtable1.Add ("HardwareReset", 11);
					hashtable1.Add ("EnableBroadcasting", 12);
					hashtable1.Add ("LoadHardwareDefaults", 13);
					hashtable1.Add ("LoadFlashJob", 14);
					hashtable1.Add ("LoadUSBJob", 15);
					hashtable1.Add ("RemoveJob", 16);
					hashtable1.Add ("ClearJobList", 17);
					hashtable1.Add ("ExecuteJobContinuous", 18);
					hashtable1.Add ("ExecuteJobOnce", 19);
					hashtable1.Add ("Abort", 20);
					hashtable1.Add ("GetFlashJobFileList", 21);
					hashtable1.Add ("GetUSBJobFileList", 22);
					hashtable1.Add ("GetRemoteIP", 23);
					hashtable1.Add ("GetJobStatus", 24);
					hashtable1.Add ("GetKFactor", 25);
					hashtable1.Add ("GetLastError", 26);
					hashtable1.Add ("GetLocalIP", 27);
					hashtable1.Add ("SetLocalIP", 28);
					hashtable1.Add ("GetSubnetMask", 29);
					hashtable1.Add ("SetSubnetMask", 30);
					hashtable1.Add ("GetDHCPMode", 31);
					hashtable1.Add ("SetDHCPMode", 32);
					hashtable1.Add ("GetLocalGateway", 33);
					hashtable1.Add ("SetLocalGateway", 34);
					hashtable1.Add ("GetAdminPIN", 35);
					hashtable1.Add ("ForceLog", 36);
					hashtable1.Add ("SetAdminPIN", 37);
					hashtable1.Add ("GetUserPIN", 38);
					hashtable1.Add ("SetUserPIN", 39);
					hashtable1.Add ("GetNodeFriendlyName", 40);
					hashtable1.Add ("SetNodeFriendlyName", 41);
				}
				if (((object1 = commandString) != null) && ((object1 = hashtable1[object1]) != null))
				{
					switch ((int) object1)
					{
						case 0:
						
						{
								return APICommands.TakeHostControl;
						}
						case 1:
						
						{
								return APICommands.ReleaseHostControl;
						}
						case 2:
						
						{
								return APICommands.GetHostControlStatus;
						}
						case 3:
						
						{
								return APICommands.GetHostInControl;
						}
						case 4:
						
						{
								return APICommands.ResetAlignmentGlobals;
						}
						case 5:
						
						{
								return APICommands.SetAlignmentGlobals;
						}
						case 6:
						
						{
								return APICommands.ResetAlignmentGlobals;
						}
						case 7:
						
						{
								return APICommands.SetAlignmentGlobals;
						}
						case 8:
						
						{
								return APICommands.OpenCOMPort;
						}
						case 9:
						
						{
								return APICommands.CloseCOMPort;
						}
						case 10:
						
						{
								return APICommands.COMWriteLine;
						}
						case 11:
						
						{
								return APICommands.HardwareReset;
						}
						case 12:
						
						{
								return APICommands.EnableBroadcasting;
						}
						case 13:
						
						{
								return APICommands.LoadHardwareDefaults;
						}
						case 14:
						
						{
								return APICommands.LoadFlashJob;
						}
						case 15:
						
						{
								return APICommands.LoadUSBJob;
						}
						case 16:
						
						{
								return APICommands.RemoveJob;
						}
						case 17:
						
						{
								return APICommands.ClearJobList;
						}
						case 18:
						
						{
								return APICommands.ExecuteJobContinuous;
						}
						case 19:
						
						{
								return APICommands.ExecuteJobOnce;
						}
						case 20:
						
						{
								return APICommands.Abort;
						}
						case 21:
						
						{
								return APICommands.GetFlashJobFileList;
						}
						case 22:
						
						{
								return APICommands.GetUSBJobFileList;
						}
						case 23:
						
						{
								return APICommands.GetRemoteIP;
						}
						case 24:
						
						{
								return APICommands.GetJobStatus;
						}
						case 25:
						
						{
								return APICommands.GetKFactor;
						}
						case 26:
						
						{
								return APICommands.GetLastError;
						}
						case 27:
						
						{
								return APICommands.GetLocalIP;
						}
						case 28:
						
						{
								return APICommands.SetLocalIP;
						}
						case 29:
						
						{
								return APICommands.GetSubnetMask;
						}
						case 30:
						
						{
								return APICommands.SetSubnetMask;
						}
						case 31:
						
						{
								return APICommands.GetDHCPMode;
						}
						case 32:
						
						{
								return APICommands.SetDHCPMode;
						}
						case 33:
						
						{
								return APICommands.GetLocalGateway;
						}
						case 34:
						
						{
								return APICommands.SetLocalGateway;
						}
						case 35:
						
						{
								return APICommands.GetAdminPIN;
						}
						case 36:
						
						{
								return APICommands.ForceLog;
						}
						case 37:
						
						{
								return APICommands.SetAdminPIN;
						}
						case 38:
						
						{
								return APICommands.GetUserPIN;
						}
						case 39:
						
						{
								return APICommands.SetUserPIN;
						}
						case 40:
						
						{
								return APICommands.GetNodeFriendlyName;
						}
						case 41:
						
						{
								return APICommands.SetNodeFriendlyName;
						}
					}
				}
				return APICommands.Unknown;
			}
			
			private void SetInControlHost (HostTypes requestingHost, bool recordHostName)
			
			{
				SettingsConfigData settingsConfigData1;
				HostTypes hostTypes1;
				hostTypes1 = requestingHost;
				switch (hostTypes1)
				{
					case HostTypes.Pendant:
					
					{
							this.hostInControl = this.pendantHost;
							goto L_0082;
					}
					case HostTypes.LANStream:
					
					{
							this.hostInControl = this.lanStreamHost;
							goto L_0082;
					}
					case HostTypes.GUI:
					
					{
							this.hostInControl = this.guiHost;
							goto L_0082;
					}
					case HostTypes.Bluetooth:
					
					{
							this.hostInControl = this.bluetoothHost;
							goto L_0082;
					}
					case HostTypes.LAN:
					
					{
							this.hostInControl = this.lanHost;
							goto L_0082;
					}
					case HostTypes.RS232:
					
					{
							this.hostInControl = this.rs232Host;
							goto L_0082;
					}
				}
				this.hostInControl = this.lanStreamHost;
				
			L_0082:
				
				{
				}
				if (recordHostName && ((this.hostInControl == this.lanStreamHost) || ((this.hostInControl == this.pendantHost) || (this.hostInControl == this.guiHost))))
				{
					settingsConfigData1 = AdminSettings.OtherSettings;
					settingsConfigData1.HostClient = requestingHost.ToString ();
					AdminSettings.UpdateAdminSettings (settingsConfigData1);
				}
				if (requestingHost == HostTypes.Pendant)
				{
					bool b1 = LECHAL.Instance.LoadDefaultSettings ();
				}
				this.objectExtensionVersion = LECJobEngine.Instance.ObjectExtensionVersion;
				if (requestingHost == HostTypes.LANStream)
				{
					LECJobEngine.Instance.Shutdown ();
				}
				else
				{
					bool b2 = LECJobEngine.Instance.Initialize ();
				}
				if (requestingHost == HostTypes.GUI)
				{
					this.OnUpdateClientInfo (ClientConnectionStatus.Local, "GUI Host", "0.0.0.0", 0);
					if (this.OnAssumeHostControl != null)
					{
						this.OnAssumeHostControl ();
					}
				}
				else
				{
					this.hostInControl.AssumeControl ();
				}
				this.NotifyAllHosts (requestingHost);
			}
			
			public void ShutdownSequence ()
			
			{
				AtCommand atCommand1 = new AtCommand (LECOpcodes.WriteDigital, 6, 0);
				byte[] byteArray1 = atCommand1.ToBytes ();
				bool b1 = LECHAL.Instance.SendFPGAStreamData (byteArray1, byteArray1.Length);
				LED.LED_ON (LanmarkControls.LECHardwareAbstraction.Utilities.LED.LED_ID.ONE);
				LED.LED_ON (LanmarkControls.LECHardwareAbstraction.Utilities.LED.LED_ID.TWO);
			}
			
			private void StartHostAPI ()
			
			{
				this.pendantHost.StartHostAPI ();
				this.lanStreamHost.StartHostAPI ();
				this.guiHost.StartHostAPI ();
				this.bluetoothHost.StartHostAPI ();
				this.lanHost.StartHostAPI ();
				this.rs232Host.StartHostAPI ();
			}
			
			public void TakeControlRequest (HostTypes requestingHost, bool controlFlag)
			
			{
				if (controlFlag)
				{
					if (this.hostInControl.ThisHostType != requestingHost)
					{
						if (LECJobEngine.Instance.EngineStatus == JobOpStatus.Busy)
						{
							JobOpStatus jobOpStatus1 = LECJobEngine.Instance.AbortJob ();
						}
						this.hostInControl.ReleaseControl ();
						this.SetInControlHost (requestingHost, true);
					}
				}
				else if (this.hostInControl.ThisHostType == requestingHost)
				{
					this.SetInControlHost (HostTypes.LANStream, true);
				}
			}
			
		#endregion
	}
	
}

