//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:26:05
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LocalManager.Pendants

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.LECHardwareAbstraction.SerialPortInterface;
			using LanmarkControls.LocalManager;
			using System;
			using System.Text;
			using System.Threading;
			
		#endregion
		
	public class HyperTerminalPendant : IPendant
	
	{
		
		#region Fields
			private byte backspaceKey;
			private byte[] beepSequence;
			private byte[] carriageReturnSequence;
			private byte[] clearScreenSequence;
			private Port COM1Port;
			private byte d0Key;
			private byte d1Key;
			private byte d2Key;
			private byte d3Key;
			private byte d4Key;
			private byte d9Key;
			private byte[] deleteCharSequence;
			private byte deleteKey;
			private byte downKey;
			private byte enterKey;
			private byte escapeKey;
			private byte[] hideCursorSequence;
			private Timer IdleTimer;
			private byte leftKey;
			private int m_iInputCacheLength;
			private byte[] m_strInputCacheLine;
			private uint m_uiIdleTimeout;
			private byte minusKey;
			public virtual event InputIdleHandler OnInputIdle;
			public virtual event InputValueHandler OnInputValue;
			private byte periodKey;
			private byte rightKey;
			private char selectedLineCharacter;
			private byte[] showEditCursorSequence;
			private byte tabKey;
			private byte upKey;
			private int writeDelay;
		#endregion
		
		#region Constructors
		
			public HyperTerminalPendant ()
			
			{
				this.clearScreenSequence = new byte[] { 27, 91, 50, 74 };
				byte[] byteArray1 = new byte[] { 13, 10 };
				this.carriageReturnSequence = byteArray1;
				this.selectedLineCharacter = '\0';
				this.deleteCharSequence = new byte[] { 8, 32, 8 };
				byteArray1 = new byte[] { 7 };
				this.beepSequence = byteArray1;
				this.showEditCursorSequence = ((byte[]) null);
				this.hideCursorSequence = ((byte[]) null);
				this.upKey = 38;
				this.downKey = 40;
				this.leftKey = 37;
				this.rightKey = 9;
				this.d0Key = 48;
				this.d1Key = 49;
				this.d2Key = 50;
				this.d3Key = 51;
				this.d4Key = 52;
				this.d9Key = 57;
				this.escapeKey = 27;
				this.enterKey = 13;
				this.deleteKey = 46;
				this.backspaceKey = 8;
				this.tabKey = 9;
				this.periodKey = 110;
				this.minusKey = 109;
				this.COM1Port = ((Port) null);
				this.m_uiIdleTimeout = 10;
				this.writeDelay = 100;
				this.m_strInputCacheLine = new byte[256];
				this.m_iInputCacheLength = 0;
				this.IdleTimer = ((Timer) null);
			}
			
		#endregion
		
		#region Properties
		
			public virtual byte BackspaceKey
			
			{
				get
				{
					return this.backspaceKey;
				}
			}
			
			
			public virtual byte[] BeepSequence
			
			{
				get
				{
					return this.beepSequence;
				}
			}
			
			
			public virtual byte[] CarriageReturnSequence
			
			{
				get
				{
					return this.carriageReturnSequence;
				}
			}
			
			
			public virtual byte[] ClearScreenSequence
			
			{
				get
				{
					return this.clearScreenSequence;
				}
			}
			
			
			public virtual byte D0Key
			
			{
				get
				{
					return this.d0Key;
				}
			}
			
			
			public virtual byte D1Key
			
			{
				get
				{
					return this.d1Key;
				}
			}
			
			
			public virtual byte D2Key
			
			{
				get
				{
					return this.d2Key;
				}
			}
			
			
			public virtual byte D3Key
			
			{
				get
				{
					return this.d3Key;
				}
			}
			
			
			public virtual byte D4Key
			
			{
				get
				{
					return this.d4Key;
				}
			}
			
			
			public virtual byte D9Key
			
			{
				get
				{
					return this.d9Key;
				}
			}
			
			
			public virtual byte[] DeleteCharSequence
			
			{
				get
				{
					return this.deleteCharSequence;
				}
			}
			
			
			public virtual byte DeleteKey
			
			{
				get
				{
					return this.deleteKey;
				}
			}
			
			
			public virtual byte DownKey
			
			{
				get
				{
					return this.downKey;
				}
			}
			
			
			public virtual byte EnterKey
			
			{
				get
				{
					return this.enterKey;
				}
			}
			
			
			public virtual byte EscapeKey
			
			{
				get
				{
					return this.escapeKey;
				}
			}
			
			
			public virtual byte[] HideCursorSequence
			
			{
				get
				{
					return this.hideCursorSequence;
				}
			}
			
			
			public virtual uint IdleTimeout
			
			{
				get
				{
					return this.m_uiIdleTimeout;
				}
				set
				{
					this.m_uiIdleTimeout = value;
				}
			}
			
			
			public virtual byte LeftKey
			
			{
				get
				{
					return this.leftKey;
				}
			}
			
			
			public virtual byte MinusKey
			
			{
				get
				{
					return this.minusKey;
				}
			}
			
			
			public virtual byte PeriodKey
			
			{
				get
				{
					return this.periodKey;
				}
			}
			
			
			public virtual byte RightKey
			
			{
				get
				{
					return this.rightKey;
				}
			}
			
			
			public virtual char SelectedLineCharacter
			
			{
				get
				{
					return this.selectedLineCharacter;
				}
			}
			
			
			public virtual byte[] ShowEditCursorSequence
			
			{
				get
				{
					return this.showEditCursorSequence;
				}
			}
			
			
			public virtual byte TabKey
			
			{
				get
				{
					return this.tabKey;
				}
			}
			
			
			public virtual byte UpKey
			
			{
				get
				{
					return this.upKey;
				}
			}
			
			
			public int WriteDelay
			
			{
				get
				{
					return this.writeDelay;
				}
			}
			
		#endregion
		
		#region Methods
		
			public virtual void Beep ()
			
			{
			}
			
			public virtual void ClearScreen ()
			
			{
				this.COM1Port.Output = this.ClearScreenSequence;
				Thread.Sleep (this.WriteDelay);
			}
			
			public virtual bool Connect ()
			
			{
				DetailedPortSettings detailedPortSettings1 = ((DetailedPortSettings) new HandshakeNone ());
				detailedPortSettings1.BasicSettings.BaudRate = BaudRates.CBR_9600;
				this.COM1Port = new Port ("COM1:", detailedPortSettings1);
				if (this.COM1Port == null)
				{
					return false;
				}
				this.COM1Port.RThreshold = 1;
				this.COM1Port.InputLen = 1;
				this.COM1Port.SThreshold = 1;
				this.COM1Port.DataReceived += new Port.CommEvent (this.OnDataReceived);
				bool b1 = this.COM1Port.Open ();
				if (b1)
				{
					this.InitializePendant ();
				}
				return b1;
			}
			
			private bool DataVerified (byte testCharacter)
			
			{
				if ((testCharacter >= 65) && (testCharacter <= 90))
				{
					return true;
				}
				else if ((testCharacter >= 40) && (testCharacter <= 57))
				{
					return true;
				}
				else if (testCharacter == 32)
				{
					return true;
				}
				else if (testCharacter == 13)
				{
					return true;
				}
				else if (testCharacter == 8)
				{
					return true;
				}
				else if (testCharacter == 11)
				{
					return true;
				}
				else if (testCharacter != 9)
				{
					return false;
				}
				else
				{
					return true;
				}
			}
			
			public virtual bool Disconnect ()
			
			{
				if (this.IdleTimer != null)
				{
					this.IdleTimer.Dispose ();
					this.IdleTimer = ((Timer) null);
				}
				return this.COM1Port.Close ();
			}
			
			public virtual void IdleTimeoutCallback (object stateInfo)
			
			{
				string string1;
				if (this.IdleTimer != null)
				{
					bool b1 = this.IdleTimer.Change (-1L, ((long) (((int) this.IdleTimeout) * 1000)));
				}
				if (this.OnInputIdle != null)
				{
					string1 = Encoding.ASCII.GetString (this.m_strInputCacheLine, 0, this.m_iInputCacheLength);
					this.OnInputIdle (string1);
				}
				this.m_iInputCacheLength = 0;
				if (this.IdleTimer != null)
				{
					bool b2 = this.IdleTimer.Change (((uint) (((int) this.IdleTimeout) * 1000)), ((uint) (((int) this.IdleTimeout) * 1000)));
				}
			}
			
			private void InitializePendant ()
			
			{
				this.ClearScreen ();
				this.WriteLine ("Lanmark Controls Inc");
				this.WriteLine ("Terminal Console Driver");
				this.WriteLine ("Version 1.0");
				Thread.Sleep (1500);
			}
			
			public virtual bool IsTextCharacter (byte testCharacter)
			
			{
				if ((testCharacter >= 65) && (testCharacter <= 90))
				{
					return true;
				}
				else if ((testCharacter >= 40) && (testCharacter <= 57))
				{
					return true;
				}
				else if (testCharacter != 32)
				{
					return false;
				}
				else
				{
					return true;
				}
			}
			
			private void OnDataReceived ()
			
			{
				if ((this.IdleTimer != null) && (this.IdleTimer != null))
				{
					bool b1 = this.IdleTimer.Change (-1L, ((long) (((int) this.IdleTimeout) * 1000)));
				}
				byte[] byteArray1 = this.COM1Port.Input;
				if ((this.OnInputValue != null) && this.DataVerified (byteArray1[0]))
				{
					this.OnInputValue (byteArray1[0]);
				}
				if (this.IdleTimer != null)
				{
					bool b2 = this.IdleTimer.Change (((uint) (((int) this.IdleTimeout) * 1000)), ((uint) (((int) this.IdleTimeout) * 1000)));
				}
			}
			
			public virtual byte[] SetCursorPositionSequence (uint puiRow, uint puiColumn)
			
			{
				string string1 = string.Format ("[{0};{1}H", puiRow, puiColumn);
				byte[] byteArray1 = new ASCIIEncoding ().GetBytes (string1);
				byte[] byteArray2 = new byte[(byteArray1.Length + 1)];
				byteArray2[0] = this.EscapeKey;
				Array.Copy (((Array) byteArray1), 0, ((Array) byteArray2), 1, byteArray1.Length);
				return byteArray2;
			}
			
			public virtual void StartIdleTimer ()
			
			{
				TimerCallback timerCallback1 = new TimerCallback (this.IdleTimeoutCallback);
				this.IdleTimer = new Timer (timerCallback1, this, ((uint) (((int) this.IdleTimeout) * 1000)), ((uint) (((int) this.IdleTimeout) * 1000)));
			}
			
			public virtual void Write (byte[] pbyteLine)
			
			{
				this.COM1Port.Output = pbyteLine;
				Thread.Sleep (this.WriteDelay);
			}
			
			public virtual void Write (string pstrLine)
			
			{
				byte[] byteArray1 = new ASCIIEncoding ().GetBytes (pstrLine);
				this.COM1Port.Output = byteArray1;
				Thread.Sleep (this.WriteDelay);
			}
			
			public virtual void WriteLine ()
			
			{
				this.COM1Port.Output = this.CarriageReturnSequence;
				Thread.Sleep (this.WriteDelay);
			}
			
			public virtual void WriteLine (string pstrLine)
			
			{
				this.Write (pstrLine);
				this.WriteLine ();
			}
			
		#endregion
	}
	
}

